<?php
	/**************************************************************************\
	* Simple Groupware 0.241                                                   *
	* http://www.simple-groupware.de                                           *
	* Copyright (C) 2002-2006 by Thomas Bley                                   *
	* ------------------------------------------------------------------------ *
	*  This program is free software; you can redistribute it and/or           *
	*  modify it under the terms of the GNU General Public License Version 2   *
	*  as published by the Free Software Foundation; only version 2            *
	*  of the License, no later version.                                       *
	*                                                                          *
	*  This program is distributed in the hope that it will be useful,         *
	*  but WITHOUT ANY WARRANTY; without even the implied warranty of          *
	*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the            *
	*  GNU General Public License for more details.                            *
	*                                                                          *
	*  You should have received a copy of the GNU General Public License       *
	*  Version 2 along with this program; if not, write to the Free Software   *
	*  Foundation, Inc., 59 Temple Place - Suite 330, Boston,                  *
	*  MA  02111-1307, USA.                                                    *
	\**************************************************************************/

if (!defined("MAIN_SCRIPT")) exit;

function _asset_action_data_edit($data,$tfields,$tview,$id,$t_data) {
  $cfields = array();
  $new_files = array();
  $delete_files = array();
  $sys_fields = array("history"=>"","dsize"=>"","seen"=>"");
  foreach ($data as $data_key=>$data_value) {
	if (isset($t_data[$id][$data_key]["data"])) {
      $tdata = $t_data[$id][$data_key]["data"];
	  if (!is_array($tdata)) $tdata = array($tdata);
	  if (strcmp(implode("|",$tdata),$data_value)!=0) {
		if (isset($tfields[$data_key]["SIMPLE_TYPE"])) {
		  switch($tfields[$data_key]["SIMPLE_TYPE"]) {
		    case "password": $data_value = ""; break;
			case "date": $data_value = sys_date("{t}m/d/Y{/t}",$data_value); break;
	    	case "datetime": $data_value = sys_date("{t}m/d/Y g:i a{/t}",$data_value); break;
			case "time": $data_value = sys_date("{t}g:i a{/t}",$data_value); break;
			case "dateselect":
			  $data = "";
			  foreach (explode("|",$data_value) as $date) $data .= " ".sys_date("{t}m/d/Y g:i a{/t}",$date);
			  $data_value = trim($data);
			  break;
		  }
		}
		if (!empty($tfields[$data_key]["NO_SEARCH_INDEX"])) $data_value = "";
		if ($data_value!="") $cfields[] = $data_key.": ".addslashes($data_value)." "; else $cfields[] = $data_key;

		if (isset($tfields[$data_key]["SIMPLE_TYPE"]) and $tfields[$data_key]["SIMPLE_TYPE"]=="files") {
		  $data_value = explode("|",$data_value);
		  foreach ($tdata as $old_file) {
			if (!in_array($old_file,$data_value)) $delete_files[] = $old_file;
		  }
		  foreach ($data_value as $new_file) {
			if (!in_array($new_file,$tdata)) $new_files[] = $new_file;
		  }
		}
	  } else unset($data[$data_key]);
	}
    if (isset($sys_fields[$data_key])) continue;
	$addfield = true;
	$thefield = $tfields[$data_key];
	if (isset($thefield["NOTINALL"]) or isset($thefield["READONLYALL"])) $addfield = false;
	if (isset($thefield["NOTIN"]) and in_array($tview,$thefield["NOTIN"])) $addfield = false;
	if (isset($thefield["READONLYIN"]) and in_array($tview,$thefield["READONLYIN"])) $addfield = false;
	if (isset($thefield["ONLYIN"])) {
	  if (in_array($tview,$thefield["ONLYIN"])) $addfield = true; else $addfield = false;
	}
	if (!$addfield) unset($data[$data_key]);
  }
  $data["history"] = str_replace("@fields@",implode(",",$cfields),$data["history"]);
  if (count($data)==2 or (count($data)==3 and isset($data["seen"]))) $data = array();
  return array($data,$new_files,$delete_files);
}

function _asset_action_data_create($data,$tfields,$tview) {
  $new_files = array();
  $sys_fields = array("history"=>"","dsize"=>"","seen"=>"");
  foreach ($data as $data_key=>$data_value) {
    if (isset($sys_fields[$data_key])) continue;
	$fields = $tfields[$data_key];
	if (isset($fields["SIMPLE_TYPE"]) and $fields["SIMPLE_TYPE"]=="files") {
	  foreach (explode("|",$data_value) as $new_file) $new_files[] = $new_file;
	}
	$addfield = true;
	if (isset($fields["NOTINALL"])) $addfield = false;
	if (isset($fields["NOTIN"]) and in_array($tview,$fields["NOTIN"])) $addfield = false;
	if (isset($fields["ONLYIN"])) {
	  if (in_array($tview,$fields["ONLYIN"])) $addfield = true; else $addfield = false;
	}
	if (!$addfield) unset($data[$data_key]);
  }
  return array($data,$new_files);
}

function _asset_action_create_edit_modifystore($store_arr,$fieldname,$value) {
  if (!is_array($store_arr) or count($store_arr)==0) return $value;
  foreach ($store_arr as $store) {
	if (!empty($store["FUNCTION"])) {
	  $store["FUNCTION"] = "modify_".$store["FUNCTION"];
	  if (function_exists($store["FUNCTION"])) {
		$value = $store["FUNCTION"]($value);
  } } }
  return $value;
}

function _asset_action_create_edit_transformdata($data) {
  $table = $GLOBALS["table"];
  foreach ($data as $data_key=>$data_value) {
	if (is_array($data_value) and count($data_value)==1 and $table["fields"][$data_key]["SIMPLE_SIZE"]==1) {
	  $data[$data_key] = implode("|",$data_value);
	} else if (is_array($data_value)) {
	  $data[$data_key] = "|".implode("|",$data_value)."|";
	} else {
      $data[$data_key] = $data_value;
	}
  }
  return $data;
}

function _asset_action_create_edit_movefiles($field,$fieldname,$object_id,$prefix,$field_name) {
  $t = &$GLOBALS["t"];
  if (!empty($_REQUEST[$fieldname])) {
    $data = explode("|",$_REQUEST[$fieldname]);
	foreach ($data as $filekey=>$file) {
	  $filebase = modify_basename(basename($file));
  	  list($target,$filename) = sys_build_filename($t["title"],$filebase,"");
	  dirs_checkdir($target);
	  $target .= sys_get_pathnum($object_id)."/";
	  dirs_checkdir($target);
	  $target .= $object_id.$filename;
	  if (file_exists(SIMPLE_CACHE."/upload/".basename($file))) {
	    rename(SIMPLE_CACHE."/upload/".basename($file),$target);
		$data[$filekey] = $target;
	  }
	}
    $_REQUEST[$fieldname] = implode("|",$data);
	$t["fields"][$field_name]["SIMPLE_DEFAULTS"][$prefix] = $_REQUEST[$fieldname];
  }
}
			
function _asset_count_filesizes($data) {
  $data = explode("|",$data);
  $size = 0;
  foreach ($data as $key=>$val) {
    if (file_exists($val)) $size += filesize($val);
  }
  return $size;
}

function _asset_action_create_edit_trigger($att,$id,$data,$mode) {
  if (!empty($att["TRIGGER_NEW"]) and $mode=="create") {
    $trigger = $att["TRIGGER_NEW"];
  } elseif (!empty($att["TRIGGER_EDIT"])) {
    $trigger = $att["TRIGGER_EDIT"];
  } else return "";
  return asset_process_trigger($trigger,$id,$data);
}

function _asset_action_create_edit_validate($error,$mode,$field,$fieldname,$prefix2) {
  $t = $GLOBALS["t"];
  $key = $field["NAME"];
  $key_name = isset($field["DISPLAYNAME"])?$field["DISPLAYNAME"]:$field["NAME"];
  $data = isset($_REQUEST[$fieldname])?$_REQUEST[$fieldname]:"";
  if ($field["SIMPLE_TYPE"]=="password" and isset($_REQUEST[$fieldname."_confirm"]) and $_REQUEST[$fieldname]!=$_REQUEST[$fieldname."_confirm"]) $error[$key][] = array($key_name,"{t}password not confirmed.{/t}");
  if (isset($field["REQUIRED"]) and empty($data)) {
	$error[$key][] = array($key_name,"{t}missing field{/t}");
  } elseif (isset($field["VALIDATE"])) {
    if (!isset($_REQUEST[$fieldname])) $_REQUEST[$fieldname] = "";
	foreach ($field["VALIDATE"] as $validate) {
	  if (isset($validate["FUNCTION"]) and $validate["FUNCTION"]!="") {
		$params = array();
		if (strpos($validate["FUNCTION"],"|")) {
		  $params = explode("|",$validate["FUNCTION"]);
		  $validate["FUNCTION"] = array_shift($params);
		}
		$validate["FUNCTION"] = "validate_".$validate["FUNCTION"];
		if (function_exists($validate["FUNCTION"])) {
		  if (!is_array($data)) $data_arr = array($data); else $data_arr = $data;
		  foreach ($data_arr as $data_item) {
	        if ($data_item!="" or isset($field["REQUIRED"])) {
			  if (count($params)==0) $result_func = $validate["FUNCTION"]($data_item);
			    else $result_func = $validate["FUNCTION"]($data_item,$params);
			  if ($result_func!="") $error[$key][] = array($key_name,$result_func);
		    }
		  }
		} else {
		  $error[$key][] = array($key_name,sprintf("{t}Function does not exist: %s{/t}",$validate["FUNCTION"]));
  } } } }
  if (isset($field["KEY"]) or (isset($field["IS_UNIQUE"]) and !empty($data))) {
    if ($mode=="create") $prefix_id = -1; else $prefix_id = $prefix2;
	if ($result_func = validate_itemexists($t["title"],$key,$data,$prefix_id) and $result_func!="") {
	  $error[$key][] = array($key_name,$result_func);
	}
  }
  return $error;
}

function _asset_action_create_edit_processfiles($error,$field,$fieldname) {
  $t = $GLOBALS["t"];
  $uploads = array();
  $displayname = isset($field["DISPLAYNAME"])?$field["DISPLAYNAME"]:$field["NAME"];
  if (isset($_REQUEST[$fieldname."_delete"]) and count($_REQUEST[$fieldname."_delete"])>0) {
	foreach (array_keys($_REQUEST[$fieldname."_delete"]) as $delkey) {
	  @unlink(SIMPLE_CACHE."/upload/".basename($_REQUEST[$fieldname."_delete"][$delkey]));
	  if (in_array($delkey,$_REQUEST[$fieldname."_old"])) unset($_REQUEST[$fieldname."_old"][array_search($delkey,$_REQUEST[$fieldname."_old"])]);
	}
  }
  if (isset($_FILES[$fieldname]) and is_array($_FILES[$fieldname])) {
    $_REQUEST[$fieldname] = $_FILES[$fieldname];
	foreach (array_keys($_REQUEST[$fieldname]["name"]) as $filenum) {
	  if ($_REQUEST[$fieldname]["error"][$filenum]=="0" and $_REQUEST[$fieldname]["size"][$filenum]!=0) {
		if ($_REQUEST[$fieldname]["name"][$filenum]=="") $_REQUEST[$fieldname]["name"][$filenum] = "default";
	    list($target,$filename) = sys_build_filename($t["title"],basename($_REQUEST[$fieldname]["name"][$filenum]),"temp");
		dirs_checkdir($target);
		$target .= $_SESSION["username"]."__".$filename;
		if (!empty($field["SIMPLE_SIZE"]) and isset($_REQUEST[$fieldname."_old"]) and count($_REQUEST[$fieldname."_old"])>=$field["SIMPLE_SIZE"]) {
		  $error[$field["NAME"]][] = array($displayname,"{t}Upload failed{/t}: {t}maximum number of files exceeded.{/t}");
		  @unlink($_REQUEST[$fieldname]["tmp_name"][$filenum]);
		  $_REQUEST[$fieldname]["name"][$filenum] = "";
		} else if (move_uploaded_file($_REQUEST[$fieldname]["tmp_name"][$filenum],$target)) {
		  $filebase = modify_basename($target);
		  $uploads[$filebase] = $target;
		} else {
		  @unlink($_REQUEST[$fieldname]["tmp_name"][$filenum]);
		  $_REQUEST[$fieldname]["name"][$filenum] = "";
		}
	  } else {
	    if ($_REQUEST[$fieldname]["error"][$filenum]==UPLOAD_ERR_NO_FILE) {
		  $_REQUEST[$fieldname]["name"][$filenum] = "";
		} else {
		  $filename = $_REQUEST[$fieldname]["name"][$filenum];
	      switch ($_REQUEST[$fieldname]["error"][$filenum]) {
		    case UPLOAD_ERR_FORM_SIZE: $error[$field["NAME"]][] = array($displayname,"{t}Upload failed{/t}: {t}file is too big. Please upload a smaller one.{/t} (".$filename.")"); break; 
		    case UPLOAD_ERR_INI_SIZE: $error[$field["NAME"]][] = array($displayname,"{t}Upload failed{/t}: {t}file is too big. Please change upload_max_filesize, post_max_size in your php.ini{/t} (".$filename.") (upload_max_filesize=".@ini_get("upload_max_filesize").", post_max_size=".@ini_get("post_max_size").")"); break; 
		    case UPLOAD_ERR_PARTIAL: $error[$field["NAME"]][] = array($displayname,"{t}Upload failed{/t}: {t}file was uploaded partially.{/t} {t}Please upload again.{/t} (".$filename.")"); break; 
		    case 6: $error[$field["NAME"]][] = array($displayname,"{t}Upload failed{/t}: {t}missing a temporary folder.{/t} {t}Please upload again.{/t} (".$filename.")"); break; 
		    case 7: $error[$field["NAME"]][] = array($displayname,"{t}Upload failed{/t}: {t}Failed to write file to disk.{/t} {t}Please upload again.{/t} (".$filename.")"); break; 
            default: $error[$field["NAME"]][] = array($displayname,"{t}Upload failed{/t}: {t}Please upload again.{/t} (".$filename.")"); break; 
  } } } } }
  if (isset($_REQUEST[$fieldname])) {
    $_REQUEST[$fieldname] = array();
    if (!empty($_REQUEST[$fieldname."_old"]) and count($_REQUEST[$fieldname."_old"])>0) {
	  $_REQUEST[$fieldname] = $_REQUEST[$fieldname."_old"];
    }
    if (count($uploads)>0) {
	  $_REQUEST[$fieldname] = array_unique(array_merge($_REQUEST[$fieldname],$uploads));
    }
    $_REQUEST[$fieldname] = implode("|",$_REQUEST[$fieldname]);
  }
  return $error;
}

function asset_action_create_edit($mode) {
  $t = &$GLOBALS["t"];
  $table = $GLOBALS["table"];
  $backup_fields = $t["fields"];
  $tview = $t["view"];
  $tname = $t["title"];
  $tfolder = $t["folder"];
  $errors = array();
  $notification = array();
  $delete_files = array();
  $new_files = array();

  if (!isset($_REQUEST["form_fields"])) return;
  foreach ($_REQUEST["form_fields"] as $form_id=>$prefix2) {
    $prefix = "form_".$prefix2;
    $error = array();
    foreach ($table["fields"] as $field_name => $field) {
	  $fieldname = $prefix.$field["NAME"];
	  if ($field["SIMPLE_TYPE"]=="files") {
	    $error = _asset_action_create_edit_processfiles($error,$field,$fieldname);
	  }
	  if ($field["SIMPLE_TYPE"]!="id") {
		if (isset($t["fields"][$field_name])) $error = _asset_action_create_edit_validate($error,$mode,$field,$fieldname,$prefix2);
		if (!isset($_REQUEST[$fieldname]) and $mode=="create") $_REQUEST[$fieldname] = $field["SIMPLE_DEFAULT"];
		if (isset($t["fields"][$field_name])) {
		  $t["fields"][$field_name]["SIMPLE_DEFAULT"] = "";
		  if (isset($_REQUEST[$fieldname])) {
		    $t["fields"][$field_name]["SIMPLE_DEFAULTS"][$prefix] = is_array($_REQUEST[$fieldname])?implode("|",$_REQUEST[$fieldname]):$_REQUEST[$fieldname];
    } } } }

	if (count($error)==0) {
	  $object_id = sql_genID($tname);
	  if ($mode == "create") {
	    $id = $object_id*100+$_SESSION["serverid"];
	    $data = array("id"=>$id,"dsize"=>0,"history"=>sprintf("{t}Item created by %s at %s{/t}\n",$_SESSION["username"],sys_date("{t}m/d/y g:i:s a{/t}")));
	  } else {
	    $id = $prefix2;
	    $data = array("dsize"=>0,"history"=>sprintf("{t}Item edited (%s) by %s at %s{/t}\n","@fields@",$_SESSION["username"],sys_date("{t}m/d/y g:i:s a{/t}")));
	  }
      foreach ($table["fields"] as $field_name => $field) {
	    $fieldname = $prefix.$field["NAME"];	    
	    if ($field["SIMPLE_TYPE"]!="id") {
		  if ($field["SIMPLE_TYPE"]=="files" and isset($_REQUEST[$fieldname])) {
		    $data["dsize"] += _asset_count_filesizes($_REQUEST[$fieldname]);
		    _asset_action_create_edit_movefiles($field,$fieldname,$object_id,$prefix,$field_name);
	      }
		  if (isset($_REQUEST[$fieldname]) and isset($field["STORE"])) {
		    $_REQUEST[$fieldname] = _asset_action_create_edit_modifystore($field["STORE"],$fieldname,$_REQUEST[$fieldname]);
		  }
		  if (!isset($data[$field["NAME"]]) and isset($_REQUEST[$fieldname])) $data[$field["NAME"]] = $_REQUEST[$fieldname];
		}
	  }
	  $data = _asset_action_create_edit_transformdata($data);
	  $data_full = $data;
	  $error_sql = "";
	  if (empty($t["att"]["DEFAULT_SQL"])) {
	    if ($mode=="create") {
	      list($data,$new_files) = _asset_action_data_create($data,$table["fields"],$tview);
 	      $error_sql = db_insert($t["title"],$data,array("handler"=>$t["handler"]));
		  if ($error_sql=="") $notification[] = "{t}Item successfully created.{/t} (".$id.")";
	    } else {
		  list($data,$new_files,$delete_files) = _asset_action_data_edit($data,$table["fields"],$tview,$id,$t["data"]);
		  if (count($data)>1 and empty($t["att"]["DEFAULT_SQL"])) {
		    $error_sql = db_update($t["title"],$data,array("id=@id@"),array("id"=>$id),array("handler"=>$t["handler"]));
		    if ($error_sql=="") $notification[] = "{t}Item successfully updated.{/t}";
	  } } }
	  if ($error_sql!="") {
		$error["sql"][] = array("{t}SQL failed.{/t}",$error_sql." ".__LINE__." ".__FUNCTION__." ".__FILE__);
	  } else {
		$return = _asset_action_create_edit_trigger($t["att"],$id,$data_full,$mode);
		if ($return!="") {
		  $error["trigger"][] = array("{t}Trigger failed{/t}",$return);
		} else $_SESSION[$tname][$tview]["form_finished"][] = $form_id;

	    if ($mode == "create") $t["fields"] = $backup_fields;

  		if (empty($t["handler"])) {
		  db_search_update($t["title"],$id,$table["fields"]);
		  db_update_treesize($t["title"],$tfolder);
		  sys_log_stat("new_files",count($new_files));
		  sys_log_stat("deleted_files",count($delete_files));
		  if ($mode == "create") {
	        sys_log_stat("new_records",1);
		  } else sys_log_stat("changed_records",1);
		} else {
		  foreach ($new_files as $new_file) @unlink($new_file);
    } } }
	if (count($error)!=0) $errors[$prefix] = $error;
  }
  $GLOBALS["t"]["notification"] = array_merge($GLOBALS["t"]["notification"],$notification);
  $GLOBALS["t"]["errors"] = $errors;
  
  foreach ($t["limits"] as $key=>$val) {
	if (in_array($val,$_SESSION[$tname][$tview]["form_finished"])) unset($t["limits"][$key]);
  }
  if (count($errors)==0) {
    if (count($t["limits"])==0 or $mode!="new") {
      $_SESSION[$tname][$tview]["form_finished"] = array();
      $t["limits"] = range(0,$t["limit"]-1);
	}
  }
}

?>