<?php
	/**************************************************************************\
	* Simple Groupware 0.241                                                   *
	* http://www.simple-groupware.de                                           *
	* Copyright (C) 2002-2006 by Thomas Bley                                   *
	* ------------------------------------------------------------------------ *
	*  This program is free software; you can redistribute it and/or           *
	*  modify it under the terms of the GNU General Public License Version 2   *
	*  as published by the Free Software Foundation; only version 2            *
	*  of the License, no later version.                                       *
	*                                                                          *
	*  This program is distributed in the hope that it will be useful,         *
	*  but WITHOUT ANY WARRANTY; without even the implied warranty of          *
	*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the            *
	*  GNU General Public License for more details.                            *
	*                                                                          *
	*  You should have received a copy of the GNU General Public License       *
	*  Version 2 along with this program; if not, write to the Free Software   *
	*  Foundation, Inc., 59 Temple Place - Suite 330, Boston,                  *
	*  MA  02111-1307, USA.                                                    *
	\**************************************************************************/

function _asset_action_validate_value($data,$key) {
  $t = $GLOBALS["t"];
  $fields = $GLOBALS["table"]["fields"];
  $error = array();
  $field = $fields[$key];
  $key_name = isset($field["DISPLAYNAME"])?$field["DISPLAYNAME"]:$field["NAME"];

  if (isset($field["REQUIRED"]) and empty($data)) {
    $error[$key][] = "{t}missing field{/t} [".$key_name."]";
  } elseif (isset($field["VALIDATE"])) {
	foreach ($field["VALIDATE"] as $validate) {
	  if (isset($validate["FUNCTION"]) and $validate["FUNCTION"]!="") {
		$params = array();
		if (strpos($validate["FUNCTION"],"|")) {
		  $params = explode("|",$validate["FUNCTION"]);
		  $validate["FUNCTION"] = array_shift($params);
		}
		$validate["FUNCTION"] = "validate_".$validate["FUNCTION"];
		if (function_exists($validate["FUNCTION"])) {
		  if (!is_array($data)) $data_arr = array($data); else $data_arr = $data;
		  foreach ($data_arr as $data_item) {
		    if ($data_item!="" or isset($field["REQUIRED"])) {
			  if (count($params)==0) $result_func = $validate["FUNCTION"]($data_item);
			    else $result_func = $validate["FUNCTION"]($data_item,$params);
		      if ($result_func!="") $error[$key][] = $result_func." [".$key_name.",".$data_item."]";
		    }
		  }
		} else {
		  $error[$key][] = sprintf("{t}Function does not exist: %s{/t}",$validate["FUNCTION"]);
  } } } }
  if (isset($field["KEY"]) or (isset($field["IS_UNIQUE"]) and !empty($data))) {
    if ($result_func = validate_itemexists($t["title"],$key,$data,-1) and $result_func!="") {
	  $error[$key][] = $result_func;
    }
  }
  return $error;
}

function _asset_action_paste_item_copyfile($file,$id) {
  $t = $GLOBALS["t"];
  $tname = $t["title"];
  list($target,$filename) = sys_build_filename($tname,basename(modify_basename($file)),"");
  dirs_checkdir($target);
  $target .= sys_get_pathnum($id)."/";
  dirs_checkdir($target);
  $target .= $id.$filename;
  copy($file,$target);
  return $target;
}

function _asset_action_restore_value($data,$fieldname) {
  $t = $GLOBALS["t"];
  $value_edit = explode("|",$data[$fieldname]);
  $restore_filters = array();
  if (isset($t["restore_filters"][$fieldname])) $restore_filters = $t["restore_filters"][$fieldname];
  if (count($restore_filters)>0) {
	foreach ($restore_filters as $filter) {
	  $filter_a = explode("|",$filter["FUNCTION"]);
	  $filter_func = "modify_".array_shift($filter_a);
	  if (!function_exists($filter_func)) {
		$GLOBALS["t"]["notification"][] = sprintf("{t}Function does not exist: %s{/t}",$filter_func);
	  } else {
		foreach (array_keys($value_edit) as $key) {
	      $value_edit[$key] = $filter_func($value_edit[$key],$filter_a,$data);
  } } } }
  return implode("|",$value_edit);
}

function _asset_action_movepaste_item_getdata($ccp,$item) {
  $count_size = 0;
  $count_files = 0;
  if (!empty($ccp["handler"]) and file_exists("modules/lib/".$ccp["handler"].".php")) include_once("modules/lib/".$ccp["handler"].".php");
  
  $row = db_select_first($ccp["tname"],$ccp["data_fields"],array("id=@id@"),"","",array("id"=>$item,"folder"=>dirname($item)."/"),array("handler"=>$ccp["handler"]));
  if (count($ccp["file_fields"])>0) {
    foreach ($ccp["file_fields"] as $file_field) {
	  if (!empty($row[$file_field])) {
	    $arr = explode("|",$row[$file_field]);
		foreach ($arr as $file) {
		  if ($file!="" and @file_exists($file)) {
		    $count_size += filesize($file);
			$count_files++;
  } } } } }
  return array("size"=>$count_size,"files"=>$count_files,"row"=>$row);
}

function _asset_action_move($ccp) {
  $t = $GLOBALS["t"];
  $tname = $t["title"];
  $tfolder = $t["folder"];
  $count_records_all = 0;
  foreach ($ccp["items"] as $item) {
	$ccp["data_fields"] = array("id","folder","dsize");
	$data = _asset_action_movepaste_item_getdata($ccp,$item);
	if (empty($data["row"])) continue;
	$right = db_get_rights($data["row"]["folder"],"","write");
    if (!empty($data["row"]["folder"]) and $data["row"]["folder"]!=$tfolder and $right) {
	  db_search_delete($tname,$item);
  	  $t["sqlvars"]["id"] = $item;
	  $t["sqlvars"]["folder_source"] = $data["row"]["folder"];
      db_update($tname,array("folder"=>$tfolder,"history"=>sprintf("{t}Item moved by %s at %s from %s to %s{/t}\n",$_SESSION["username"],sys_date("{t}m/d/y g:i:s a{/t}"),$data["row"]["folder"],$tfolder)),array("id=@id@"),$t["sqlvars"],array("handler"=>$t["handler"]));
	  db_search_update($tname,$item,$GLOBALS["table"]["fields"]);
	  db_update_treesize($tname,$data["row"]["folder"]);
	  db_update_treesize($tname,$tfolder);
	  sys_log_stat("moved_records",1);
	  $count_records_all++;
	}
  }
  $_SESSION["ccp_data"] = array();
  return $count_records_all;
}

function asset_action_cutcopy_item($operation) {
  $t = $GLOBALS["t"];
  $tname = $t["title"];
  $tfolder = $t["folder"];
  $tview = $t["view"];
  $fields = $GLOBALS["table"]["fields"];
  
  if ((($operation=="cut" and $GLOBALS["trights"]["write"]) or $operation=="copy") and (isset($t["sqlvars"]["item"]) and count($t["sqlvars"]["item"])>0)) {
    $unique_fields = array();
    $file_fields = array();
	$data_fields = array();
	foreach ($fields as $field) {
	  if (isset($field["KEY"]) or isset($field["IS_UNIQUE"])) $unique_fields[] = $field["NAME"];
	  if ($field["SIMPLE_TYPE"]=="files") $file_fields[] = $field["NAME"];
	  $data_fields[] = $field["NAME"];
	}
    $_SESSION["ccp_data"] = array("operation"=>$operation,"tname"=>$tname,"handler"=>$t["handler"],"items"=>$t["sqlvars"]["item"],"unique_fields"=>$unique_fields,"file_fields"=>$file_fields,"data_fields"=>$data_fields);
	if (isset($_SESSION["_".$tfolder][$tview]["item"])) unset($_SESSION["_".$tfolder][$tview]["item"]);
	header("Location: index.php?".$GLOBALS["urladdon"]);
	exit;
  }
}

function asset_action_paste_item() {
  if (!isset($_SESSION["ccp_data"]) or count($_SESSION["ccp_data"])==0) return;

  $t = $GLOBALS["t"];
  $tname = $t["title"];
  $tfolder = $t["folder"];
  $count_records_all = 0;
  $ccp = $_SESSION["ccp_data"];
  $fields = $GLOBALS["table"]["fields"];

  if ($ccp["operation"]=="cut" and $tname!=$ccp["tname"]) {
	$GLOBALS["t"]["notification"][] = "{t}Operation not allowed. (Data loss protection){/t}";
  } elseif ($ccp["operation"]=="cut" and $tname==$ccp["tname"]) {
	$count_records_all = _asset_action_move($ccp);
  } elseif ($ccp["operation"]=="copy") {
	foreach ($ccp["items"] as $item) {
	  $newfiles = array();
	  $data = _asset_action_movepaste_item_getdata($ccp,$item);
	  if (empty($data["row"])) continue;
	  $right = db_get_rights($data["row"]["folder"],"","read");
	  if (!empty($data["row"]["folder"]) and $right) {
		$error = array();
		foreach (array_keys($data["row"]) as $key) {
		  if (isset($fields[$key])) {
			$data["row"][$key] = _asset_action_restore_value($data["row"],$key);
		  } else unset($data["row"][$key]);
		}
		foreach (array_keys($data["row"]) as $key) {
		  if (isset($fields[$key])) $error = array_merge($error,_asset_action_validate_value($data["row"][$key],$key));
		}
		if (count($error)>0) {
		  $message = "{t}Error pasting asset{/t}:";
		  foreach ($error as $err_key=>$err_val) {
			$message .= "\n\n".$fields[$err_key]["DISPLAYNAME"].":\n".implode("\n",$err_val);
		  }
		  sys_message_box($message);
		  continue;
		}
		foreach (array_keys($data["row"]) as $key) {
		  if (isset($fields[$key]) and isset($fields[$key]["STORE"])) {
			$data["row"][$key] = _asset_action_create_edit_modifystore($fields[$key]["STORE"],$key,$data["row"][$key]);
		  }
		}
  	  	$data["row"]["id"] = sql_genID($tname)*100+$_SESSION["serverid"];
		$data["row"]["folder"] = $tfolder;
		$data["row"]["dsize"] = 0;
		if ($data["files"] > 0) {
		  foreach ($ccp["file_fields"] as $file_field) {
		    if (!empty($data["row"][$file_field])) {
			  $data_files = explode("|",$data["row"][$file_field]);
			  $data["row"][$file_field] = array();
			  foreach ($data_files as $file) {
				if (file_exists($file)) {
				  $target = _asset_action_paste_item_copyfile($file,$data["row"]["id"]);
				  $data["row"][$file_field][] = $target;
				  $newfiles[] = $target;
				  $data["row"]["dsize"] += filesize($target);
				}
			  }
			  $data["row"][$file_field] = implode("|",$data["row"][$file_field]);
		} } }
		$error_sql = db_insert($tname,$data["row"],array("handler"=>$t["handler"]));
	  	if ($error_sql!="") {
		  if (count($newfiles) > 0) {
		    foreach ($newfiles as $newfile) if (file_exists($newfile)) unlink($newfile);
		  }
		  sys_message_box($error_sql);
		} else {
		  db_search_update($tname,$data["row"]["id"],$fields);
	      db_update_treesize($tname,$tfolder);
		  sys_log_stat("copied_files",count($newfiles));
	      sys_log_stat("copied_records",1);
		  $count_records_all++;
	} } }
    $_SESSION["ccp_data"] = array();
  }
}

?>