<?php
	/**************************************************************************\
	* Simple Groupware 0.241                                                   *
	* http://www.simple-groupware.de                                           *
	* Copyright (C) 2002-2006 by Thomas Bley                                   *
	* ------------------------------------------------------------------------ *
	*  This program is free software; you can redistribute it and/or           *
	*  modify it under the terms of the GNU General Public License Version 2   *
	*  as published by the Free Software Foundation; only version 2            *
	*  of the License, no later version.                                       *
	*                                                                          *
	*  This program is distributed in the hope that it will be useful,         *
	*  but WITHOUT ANY WARRANTY; without even the implied warranty of          *
	*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the            *
	*  GNU General Public License for more details.                            *
	*                                                                          *
	*  You should have received a copy of the GNU General Public License       *
	*  Version 2 along with this program; if not, write to the Free Software   *
	*  Foundation, Inc., 59 Temple Place - Suite 330, Boston,                  *
	*  MA  02111-1307, USA.                                                    *
	\**************************************************************************/

if (!defined("MAIN_SCRIPT")) exit;

function _export_build_data($t,$html) {
  $data = array();
  $i = 0;
  foreach ($t["data"] as $asset) {
    if (!isset($asset["_id"])) continue;
	foreach ($t["fields"] as $akey=>$value) {
	  if (!empty($value["HIDDEN"])) continue;
	  if ($value["SIMPLE_TYPE"]=="password") continue;
 	  $aval = $asset[$akey];
	  if ($value["SIMPLE_TYPE"]=="checkbox") {
		if ($aval["data"][0]=="1") $aval["filter"][0] = "checked"; else $aval["filter"][0] = "";
	  }
	  $filter = "";
	  if (isset($aval["filter"]) and is_array($aval["filter"]) and isset($aval["filter"][0])) {
	    $filter = implode(" ",$aval["filter"]);
	  } elseif (!is_array($aval["filter"]) and $aval!="") {
		$filter = $aval;
	  } else {
		if ($html) $filter = " ";
	  }
	  $name = $value["NAME"];
	  $displayname = $value["NAME"];
	  if (!empty($value["DISPLAYNAME"])) {
	    $name = $value["DISPLAYNAME"];
		$displayname = $value["DISPLAYNAME"];
	  }
	  if (count($aval["data"])<2) $aval["data"] = implode(" ",$aval["data"]);
	  $output = array("name"=>$name,"displayname"=>$displayname,"field"=>$value["NAME"],"data"=>$aval["data"],"filter"=>$filter,"type"=>$value["SIMPLE_TYPE"]);
	  $data[$i][$akey] = $output;
	}
	if (empty($data[$i]["created"])) $data[$i]["created"] = array("name"=>"","type"=>"","data"=>$asset["created"]);
	if (empty($data[$i]["lastmodified"])) $data[$i]["lastmodified"] = array("name"=>"","type"=>"","data"=>$asset["lastmodified"]);
	$data[$i]["_id"] = array("name"=>"","type"=>"","data"=>$asset["_id"]);
	$i++;
  }
  return $data;
}

function _export_date($time) {
  return sys_date("Y-m-d\\TH:i:s",$time)."+00:00";
}

function _export_icalendar_quote($str) {
  return wordwrap(str_replace(array("\r","\n"),array("","\\n"),trim($str)), 75, " \n ",true);
}

function _export_icalendar($t,$debug) {
  $output = "BEGIN:VCALENDAR\nVERSION:2.0\nPRODID:-//Simple Groupware//iCalendar 2.0//EN\n";
  $data = _export_build_data($t,false);
  if (count($data)==0) {
	$output .= "BEGIN:VEVENT\nDTSTART:".sys_date("Ymd\THis")."\n";
	$output .= "DURATION:PT1H\nSUMMARY:{t}No entries found.{/t}\nEND:VEVENT\n";
  } else {
    $url = "http".(isset($_SERVER['HTTPS'])?"s":"")."://".$_SERVER["HTTP_HOST"].dirname($_SERVER["SCRIPT_NAME"])."/index.php?folder=".$t["folder"]."&view=".$t["view"];
    foreach ($data as $key=>$asset) {
      $output .= "BEGIN:VEVENT\n";
	  if (!empty($asset["begin"]["data"])) $begin = $asset["begin"]["data"]; else $begin = $asset["created"]["data"];
	  if (!empty($asset["ending"]["data"])) $end = $asset["ending"]["data"]; else $end = $begin+3600;

	  if (!isset($asset["subject"]["filter"])) {
	    $subject = "";
	    foreach ($asset as $akey=>$aval) {
	      if ($aval["type"]=="text" and $aval["filter"]!="") $subject .= $aval["filter"]." ";
	    }
 	    $subject .= "[".$asset["_id"]["data"]."]";
	  } else $subject = $asset["subject"]["filter"];

	  if (!isset($asset["description"]["filter"])) {
	    $description = "";
	    foreach ($asset as $akey=>$aval) {
          if (isset($aval["filter"]) and $aval["filter"]!="" and $aval["name"]!="") $description .= "[".$aval["name"]."] ".$aval["filter"]."<br>";
	    }
	  } else $description = $asset["description"]["filter"];

	  if (!empty($asset["recurrence"]["data"])) $recurrence = $asset["recurrence"]["data"]; else $recurrence = "";
	  if (!empty($asset["repeatinterval"]["data"])) $repeatinterval = $asset["repeatinterval"]["data"]; else $repeatinterval = 1;
	  if (!empty($asset["repeatcount"]["data"])) $repeatcount = $asset["repeatcount"]["data"]; else $repeatcount = 0;
	  if (!empty($asset["repeatuntil"]["data"])) $repeatuntil = $asset["repeatuntil"]["data"]; else $repeatuntil = 0;
	  if (!empty($asset["repeatexcludes"]["data"])) $excludes = $asset["repeatexcludes"]["data"]; else $excludes = array();
	  
	  $data = array("ORGANIZER:MAILTO"=>"organizer","ATTENDEE:MAILTO"=>"participants_ext","ATTENDEE:MAILTO"=>"participants");
	  $filter = array("LOCATION"=>"location","CATEGORIES"=>"category");

	  foreach ($data as $key=>$field) {
		if (!empty($asset[$field]["data"])) $data[$key] = $asset[$field]["data"]; else $data[$key] = "";
	  }
	  foreach ($filter as $key=>$field) {
		if (!empty($asset[$field]["filter"])) $filter[$key] = $asset[$field]["filter"]; else $filter[$key] = "";
	  }
	  $output .= "DTSTAMP:".sys_date("Ymd\THis",$asset["created"]["data"])."\n";
	  $output .= "LAST-MODIFIED:".sys_date("Ymd\THis",$asset["lastmodified"]["data"])."\n";

	  $uid = is_numeric($asset["_id"]["data"])?$asset["_id"]["data"]:md5($asset["_id"]["data"]);
	  $output .= "UID:".$uid."@".$_SERVER["SERVER_ADDR"]."\n";
	  $output .= "URL;VALUE=URI:".$url."&item[]=".$asset["_id"]["data"]."\n";
	  if (!empty($asset["allday"]["data"]) and $asset["allday"]["data"]==1) {
  	    $output .= "DTSTART:".sys_date("Ymd",$begin)."\n";
	    $output .= "DTEND:".sys_date("Ymd",$end)."\n";
	  } else {
	    $output .= "DTSTART:".sys_date("Ymd\THis",$begin)."\n";
	    $output .= "DTEND:".sys_date("Ymd\THis",$end)."\n";
	  }
	  $output .= "SUMMARY:"._export_icalendar_quote($subject)."\n";
	  if ($description) $output .= "DESCRIPTION:"._export_icalendar_quote($description)."\n";
	  
	  foreach ($data as $key=>$field) {
	    if (is_array($field)) {
		  foreach ($field as $item) {
		    if ($item) $output .= $key.":"._export_icalendar_quote($item)."\n";
		  }
		} else if ($field) $output .= $key.":".$field."\n";
	  }
	  foreach ($filter as $key=>$field) {
		if ($field) $output .= $key.":"._export_icalendar_quote($field)."\n";
	  }

	  if ($recurrence) {
	    switch ($recurrence) {
		  case "years": $recurrence = "YEARLY"; break;
		  case "months": $recurrence = "MONTHLY"; break;
		  case "weeks": $recurrence = "WEEKLY"; break;
		  case "days": $recurrence = "DAILY"; break;
		}
	    $output .= "RRULE:FREQ=".$recurrence.";INTERVAL=".$repeatinterval;
		if ($repeatcount != 0) $output .= ";COUNT=".$repeatcount;
		if ($repeatuntil != 0) $output .= ";UNTIL=".sys_date("Ymd",$repeatuntil);
		$output .= "\n";
	    if (count($excludes)>0) {
		  foreach ($excludes as $key=>$val) $excludes[$key] = sys_date("Ymd",$val)."T000000";
	      $output .= "EXDATE:".implode(",",$excludes)."\n";
	    }
	  }
      $output .= "END:VEVENT\n";
	  
// TODO2 code / test
/*
  PRIORITY:[0..9]
  <field name="priority" displayname="{t}Priority{/t}" simple_type="select" simple_size="1" simple_default="normal">
  ATTENDEE by name ??
  ATTACH;FMTTYPE=application/binary:http://host.com/templates/agenda.doc
  <field name="image" displayname="{t}Image{/t}" simple_type="files" simple_file_size="1M" simple_size="1">
  <field name="attachment" displayname="{t}Attachment{/t}" simple_type="files" simple_file_size="2M" simple_size="1">
*/
    }
  }
  $output .= "END:VCALENDAR\n";  

  if (DEBUG) $output = sys_remove_trans($output);
  echo $output;
}

function _export_vcard($t,$debug) {
  $output = "";
  $data = _export_build_data($t,false);
  if (count($data)==0) {
	$output .= "BEGIN:VCARD\nVERSION:3.0\n";
	$output .= "FN:{t}No entries found.{/t}\nN:{t}No entries found.{/t};---\nEND:VCARD\n";
  } else {
    $url = "http".(isset($_SERVER['HTTPS'])?"s":"")."://".$_SERVER["HTTP_HOST"].dirname($_SERVER["SCRIPT_NAME"])."/index.php?folder=".$t["folder"]."&view=".$t["view"];
    foreach ($data as $key=>$asset) {
      $output .= "BEGIN:VCARD\nVERSION:3.0\n";
	  $uid = is_numeric($asset["_id"]["data"])?$asset["_id"]["data"]:md5($asset["_id"]["data"]);
	  $output .= "UID:".$uid."@".$_SERVER["SERVER_ADDR"]."\n";

	  if (isset($asset["firstname"]["filter"]) and isset($asset["lastname"]["filter"])) {
	    $output .= "FN:".$asset["firstname"]["filter"]." ".$asset["lastname"]["filter"]."\n";
	    $output .= "N:".$asset["lastname"]["filter"].";".$asset["firstname"]["filter"]."\n";
	  }
	  if (!empty($asset["nickname"]["filter"])) $output .= "NICKNAME:".$asset["nickname"]["filter"]."\n";
	  if (!empty($asset["title"]["filter"])) $output .= "TITLE:".$asset["title"]["filter"]."\n";
	  if (!empty($asset["position"]["filter"])) $output .= "ROLE:".$asset["position"]["filter"]."\n";

	  if (!empty($asset["birthday"]["data"]) and $asset["birthday"]["data"]!=0) $output .= "BDAY:".sys_date("Y-m-d",$asset["birthday"]["data"])."\n";

	  if (!empty($asset["company"]["filter"])) $output .= "ORG:".$asset["company"]["filter"]."\n";
	  if (!empty($asset["email"]["filter"])) $output .= "EMAIL;TYPE=WORK:".$asset["email"]["filter"]."\n";
	  if (!empty($asset["emailprivate"]["filter"])) $output .= "EMAIL;TYPE=HOME:".$asset["emailprivate"]["filter"]."\n";

  	  if (!empty($asset["phone"]["filter"])) $output .= "TEL;TYPE=VOICE,MSG,WORK:".$asset["phone"]["filter"]."\n";
	  if (!empty($asset["fax"]["filter"])) $output .= "TEL;TYPE=FAX,WORK:".$asset["fax"]["filter"]."\n";
	  if (!empty($asset["mobile"]["filter"])) $output .= "TEL;TYPE=CELL:".$asset["mobile"]["filter"]."\n";
	  if (!empty($asset["pager"]["filter"])) $output .= "TEL;TYPE=PAGER:".$asset["pager"]["filter"]."\n";

	  if (isset($asset["street"]["filter"]) and isset($asset["zipcode"]["filter"]) and isset($asset["city"]["filter"]) and isset($asset["state"]["filter"]) and isset($asset["country"]["filter"])) {
	    $output .= "ADR;TYPE=WORK:;;".$asset["street"]["filter"].";".$asset["city"]["filter"].";".$asset["state"]["filter"].";".$asset["zipcode"]["filter"].";".$asset["country"]["filter"]."\n";
	  }

	  if (!empty($asset["description"]["filter"])) $output .= "NOTE:"._export_icalendar_quote($asset["description"]["filter"])."\n";
	  if (!empty($asset["category"]["filter"])) $output .= "CATEGORIES:".$asset["category"]["filter"]."\n";
	  
	  $output .= "SOURCE:".$url."&item[]=".$asset["_id"]["data"]."\n";
      $output .= "END:VCARD\n";
    }
  }

  if (DEBUG) $output = sys_remove_trans($output);
  echo $output;
}

function _export_ldif($t,$debug) {
  $output = "";
  $data = _export_build_data($t,false);
  if (count($data)==0) {
	$output .= "";
  } else {
    $url = "http".(isset($_SERVER['HTTPS'])?"s":"")."://".$_SERVER["HTTP_HOST"].dirname($_SERVER["SCRIPT_NAME"])."/index.php?folder=".$t["folder"]."&view=".$t["view"];
    foreach ($data as $key=>$asset) {
	  $output .= "dn: cn=".(isset($asset["firstname"]["filter"])?$asset["firstname"]["filter"]:"")." ".(isset($asset["lastname"]["filter"])?$asset["lastname"]["filter"]:"").",mail=".(isset($asset["email"]["filter"])?$asset["email"]["filter"]:"")."\n";
	  $output .= "objectclass: person\n";
	  $output .= "objectclass: organizationalPerson\n";
	  $output .= "objectclass: inetOrgPerson\n";
	  if (!empty($asset["firstname"]["filter"])) $output .= "givenName: ".$asset["firstname"]["filter"]."\n";
	  if (!empty($asset["lastname"]["filter"])) $output .= "sn: ".$asset["lastname"]["filter"]."\n";
	  if (!empty($asset["contactid"]["filter"])) $output .= "uid: ".$asset["contactid"]["filter"]."\n";
	  
	  if (isset($asset["firstname"]["filter"]) and isset($asset["lastname"]["filter"])) {
	    $output .= "cn: ".$asset["firstname"]["filter"]." ".$asset["lastname"]["filter"]."\n";
	  }
	  if (!empty($asset["nickname"]["filter"])) $output .= "mozillaNickname: ".$asset["nickname"]["filter"]."\n";
	  if (!empty($asset["email"]["filter"])) $output .= "mail: ".$asset["email"]["filter"]."\n";

	  if (!empty($asset["emailprivate"]["filter"])) $output .= "mozillaSecondEmail: ".$asset["emailprivate"]["filter"]."\n";
  	  if (!empty($asset["phone"]["filter"])) $output .= "telephoneNumber: ".$asset["phone"]["filter"]."\n";
  	  if (!empty($asset["phoneprivate"]["filter"])) $output .= "homePhone: ".$asset["phoneprivate"]["filter"]."\n";
	  
	  if (!empty($asset["fax"]["filter"])) $output .= "fax: ".$asset["fax"]["filter"]."\n";
	  if (!empty($asset["pager"]["filter"])) $output .= "pager: ".$asset["pager"]["filter"]."\n";
	  if (!empty($asset["mobile"]["filter"])) $output .= "mobile: ".$asset["mobile"]["filter"]."\n";

	  if (!empty($asset["street"]["filter"])) $output .= "street: ".$asset["street"]["filter"]."\n";
	  if (!empty($asset["city"]["filter"])) $output .= "l: ".$asset["city"]["filter"]."\n";
	  if (!empty($asset["state"]["filter"])) $output .= "st: ".$asset["state"]["filter"]."\n";
	  if (!empty($asset["zipcode"]["filter"])) $output .= "postalCode: ".$asset["zipcode"]["filter"]."\n";
	  if (!empty($asset["country"]["filter"])) $output .= "c: ".$asset["country"]["filter"]."\n";

	  if (!empty($asset["title"]["filter"])) $output .= "title: ".$asset["title"]["filter"]."\n";
	  if (!empty($asset["department"]["filter"])) $output .= "department: ".$asset["department"]["filter"]."\n";

	  if (!empty($asset["company"]["filter"])) $output .= "company: ".$asset["company"]["filter"]."\n";

	  if (!empty($asset["description"]["filter"])) $output .= "description:: ".base64_encode($asset["description"]["filter"])."==\n";
	  
      $output .= "\n";
    }
  }

  if (DEBUG) $output = sys_remove_trans($output);
  echo $output;
}

function _export_xml($t,$isfeed,$debug) {
  $output = "";
  $output .= "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n";
  if ($isfeed) {
    $url = "http".(isset($_SERVER['HTTPS'])?"s":"")."://".$_SERVER["HTTP_HOST"].dirname($_SERVER["SCRIPT_NAME"])."/index.php?folder=".$t["folder"]."&amp;view=".$t["view"];
	$output .= "<feed xmlns=\"http://www.w3.org/2005/Atom\">\n";
	$output .= "<title>".$GLOBALS["sel_folder"]["ftitle"]." - ".ucfirst($t["view"])." - ".APP_TITLE."</title>\n";
 	$output .= "<link href=\"".$url."\"/>\n";
	$output .= "<link rel=\"self\" href=\"".$url."&amp;export=rss\"/>\n";
	$output .= "<updated>"._export_date($GLOBALS["time"])."</updated>\n";
  	$output .= "<author><name>Simple Groupware VERSIONNUM</name></author>\n";
  	$output .= "<id>".$url."</id>\n\n";
	$data = _export_build_data($t,false);

    $output .= "<entry>\n";
    $output .= "<title>".$GLOBALS["sel_folder"]["ftitle"]." - ".ucfirst($t["view"])."</title>\n";
    $output .= "<link href=\"".$url."\"/>\n";
    $output .= "<id>".$url."</id>\n";
    $output .= "<updated>"._export_date($GLOBALS["time"])."</updated>\n";
    $output .= "<summary></summary>\n";
    $output .= "</entry>\n";

	if (count($data)>0) {
      foreach ($data as $key=>$asset) {
	    $title = "";
	    foreach ($asset as $akey=>$aval) {
	      if ($aval["type"]=="text" and $aval["filter"]!="") $title .= $aval["filter"]." ";
	    }
	    $title .= "[".$asset["_id"]["data"]."]";
	    $summary = "";
	    foreach ($asset as $akey=>$aval) {
          if (isset($aval["filter"]) and $aval["name"]!="") $summary .= "[".$aval["name"]."] ".$aval["filter"]."<br>\n";
	    }
	    $item_url = $url."&amp;item[]=".$asset["_id"]["data"];
	
		if ($t["att"]["NAME"]=="simple_bookmarks") {
		  if (!empty($asset["url"]["data"]) and !empty($asset["bookmarkname"]["data"])) {
		    $item_url = $asset["url"]["data"];
			$title = $asset["bookmarkname"]["data"];
		  } else continue;
		  if (!empty($asset["description"]["data"])) $summary = $asset["description"]["data"];
		}
	    $output .= "<entry>\n";
	    $output .= "<title>"._export_html_quote($title)."</title>\n";
	    $output .= "<link href=\"".$item_url."\"/>\n";
	    $output .= "<id>".$item_url."</id>\n";
	    $output .= "<updated>"._export_date($asset["lastmodified"]["data"])."</updated>\n";
	    $output .= "<summary type='html'>"._export_html_quote($summary)."</summary>\n";
	    $output .= "</entry>\n";
      }
	}
	$output .= "</feed>";  
  } else {
    $output .= "<".$t["att"]["NAME"].">\n";
    foreach (_export_build_data($t,false) as $key=>$asset) {
	  $output .= "<asset id=\"".$asset["_id"]["data"]."\">\n";
	  foreach ($asset as $akey=>$aval) {
	    if ($aval["name"]) $output .= "<".$akey.">"._export_html_quote($aval["filter"])."</".$akey.">\n";
	  }
	  $output .= "</asset>\n";
    }
    $output .= "</".$t["att"]["NAME"].">\n";
  }
  if (DEBUG) $output = sys_remove_trans($output);
  echo $output;
}

function _export_xls($t,$debug) {
  include_once "lib/spreadsheet/Writer.php";
  $xls =& new Spreadsheet_Excel_Writer();
  $sheet =& $xls->addWorksheet($t["title"]);
  $sheet->setInputEncoding('utf-8');
  $sheet->freezePanes(array(1, 0, 1, 0));
  $bold =& $xls->addFormat();
  $bold->setBold();
  $normal =& $xls->addFormat();
  $normal->setVAlign("top");

  $data = _export_build_data($t,true);
  $row = 0;
  $col = 0;
  if ($debug!="") $sheet->write($row++,0,$debug);

  if (count($data)>0) {
    $col = 0;
	$sheet->setColumn(0,count($data[0])-1, 15);
    foreach ($data[0] as $field) {
	  if (empty($field["name"])) continue;
	  $sheet->write($row,$col++,$field["field"], $bold);
    }
	$row++;
    foreach ($data as $asset) {
      $col = 0;
	  foreach ($asset as $aval) {
	    if (!isset($aval["filter"])) continue;
	    $sheet->write($row,$col++,trim(strip_tags($aval["filter"])),$normal);
      }
	  $row++;
    }
  }
  $xls->close();
}

function _export_html($t,$debug) {
  $output = "";
  if ($debug!="") $output .= "<error>"._export_html_quote($debug)."</error>";

  $output .= "<style>body,table { font-family: Arial; font-size: 12px; }</style>";
  $output .= "<table border='1'>";
  $data = _export_build_data($t,true);
  if (count($data)>0) {
    $output .= "<tr>";
    foreach ($data[0] as $field) {
	  if (empty($field["name"])) continue;
	  $output .= "<td><b>"._export_html_quote($field["name"])."</b></td>";
    }
    $output .= "</tr>";
    foreach ($data as $asset) {
	  $output .= "<tr>";
	  foreach ($asset as $aval) {
	    if (!isset($aval["filter"])) continue;
        $output .= "<td>"._export_html_quote($aval["filter"])."</td>";
      }
	  $output .= "</tr>";
    }
  }
  $output .= "</table>";
  $output = str_replace(array("\r\n","\n","> <"),array("<br>","<br>",">&nbsp;<"),$output);
  if (DEBUG) $output = sys_remove_trans($output);
  echo $output;
}

function _export_html_vertical($t,$debug) {
  $output = "";
  if ($debug!="") $output .= "<error>"._export_html_quote($debug)."</error>";
  $output .= "<style>body,table { font-family: Arial; font-size: 12px; }</style>";
  $data = _export_build_data($t,true);
  if (count($data)>0) {
    foreach ($data as $key=>$asset) {
 	  $output .= "<table>";
  	  $output .= "<tr><td><b>{t}Id{/t}</b></td><td>".$key."</td>";
	  foreach ($asset as $akey=>$aval) {
	    if (!isset($aval["filter"])) continue;
  	    $output .= "<tr>";
        $output .= "<td><b>"._export_html_quote($aval["name"])."</b></td>";
	    $output .= "<td>"._export_html_quote($aval["filter"])."</td>";
	    $output .= "</tr>";
      }
	  $output .= "</table><br>";
	}
  }
  if (DEBUG) $output = sys_remove_trans($output);
  echo $output;
}

function _export_csv($t,$debug) {
  $output = "";
  $data = _export_build_data($t,true);
  if (count($data)>0) {
    $output .= "\"_id\",";
    foreach ($data[0] as $field) {
	  if (empty($field["name"])) continue;
      $output .= "\""._export_csv_quote($field["field"])."\",";
    }
    $output .= "\r\n";
    foreach ($data as $asset) {
      $output .= "\"".$asset["_id"]["data"]."\",";
	  foreach ($asset as $aval) {
	    if (!isset($aval["filter"])) continue;
	    $output .= "\"".trim(_export_csv_quote($aval["filter"]))."\",";
	  }
	  $output .= "\r\n";
	}
  }
  if (DEBUG) $output = sys_remove_trans($output);
  echo $output;
}

function _export_client($t,$debug) {
  $output = "";
  $data = _export_build_data($t,true);
  if (count($data)>0) {

    $output .= "\"_id\",\"_lastmodified\",";
    foreach ($data[0] as $field) {
	  if (empty($field["name"])) continue;
      $output .= "\""._export_client_quote($field["field"])."\",";
    }
    $output .= "\r\n";

    $output .= "\"_id\",\"_lastmodified\",";
    foreach ($data[0] as $field) {
	  if (empty($field["displayname"])) continue;
      $output .= "\""._export_client_quote($field["displayname"])."\",";
    }
    $output .= "\r\n";

    foreach ($data as $asset) {
      $output .= "\"".$asset["_id"]["data"]."\",";
      $output .= "\"".$asset["lastmodified"]["data"]."\",";
	  foreach ($asset as $aval) {
	    if (!isset($aval["filter"])) continue;
	    $output .= "\"".trim(_export_client_quote($aval["filter"]))."\",";
	  }
	  $output .= "\r\n";
	}
  }
  if (DEBUG) $output = sys_remove_trans($output);
  echo $output;
}

function _export_client_vertical($t,$debug) {
  $output = "";
  $data = _export_build_data($t,true);
  if (count($data)>0) {
    foreach ($data as $asset) {
	  foreach ($asset as $aval) {
	    if (!isset($aval["filter"])) continue;
		$output .= $aval["displayname"]."\n";
		$output .= $aval["type"]."\n";
		$output .= trim(str_replace("\n"," ",$aval["filter"]))."\n";
		$output .= "\n";
	  }
	  $output .= "\n\n\n";
	}
  }
  if (DEBUG) $output = sys_remove_trans($output);
  echo $output;
}

function _export_sss($t,$debug,$return=false) {
  $data = _export_build_data($t,true);
  $output = "cols = ".(isset($data[0])?count($data[0]):"13").";\n\ndbCells = [\n";
  if (count($data)>0) {
    $row = -1;
    $col = 0;
	$output .= "  [".$col.",".$row.",\"".trim(_export_sss_quote("ID"))."\",\"white-space:nowrap;\",\"".trim(_export_sss_quote("id"))."\"], // ".chr($row+65).($col+1)."\n";
	$col++;
    foreach ($data[0] as $field) {
	  if (empty($field["name"])) continue;
	  $output .= "  [".$col.",".$row.",\"".trim(_export_sss_quote($field["name"]))."\",\"white-space:nowrap;\",\"".trim(_export_sss_quote($field["field"]))."\"], // ".chr($row+65).($col+1)."\n";
	  $col++;
    }
    $output .= "\n";
	$row = 0;
    foreach ($data as $asset) {
	  $col = 0;
      $output .= "  [".$col.",".$row.",\"".trim(_export_sss_quote($asset["_id"]["data"]))."\",\"\"], // ".chr($row+65).($col+1)."\n";
	  foreach ($asset as $aval) {
		$col++;
	    if (!isset($aval["filter"]) or trim($aval["filter"])=="") continue;
	    $output .= "  [".$col.",".$row.",\"".trim(_export_sss_quote($aval["filter"]))."\",\"\"], // ".chr($row+65).($col+1)."\n";
	  }
	  $output .= "\n";
	  $row++;
	}
  }
  $output .= "];";
  if (DEBUG) $output = sys_remove_trans($output);
  if ($return) return $output; else echo $output;
}  

function _export_sss_editor($output) {
  echo '  
	<html>
	<head>
	<title>Simple Spreadsheet</title>
	<link media="all" href="ext/lib/simple_spreadsheet/styles.css" rel="stylesheet" type="text/css" />
	<script src="ext/lib/simple_spreadsheet/spreadsheet.js" type="text/javascript"></script>
	</head>
	<body>
	<div id="data"></div>
	<div id="source">
	<textarea id="code" wrap="off">'.htmlspecialchars($output,ENT_QUOTES).'</textarea>
	<input type="button" value="Load" onclick="load();">
	<script>var init_data=getObj("code").value; load();</script>
	</div>
	</body>
	</html>  
  ';
}

function _export_build_filename($t) {
  return "data-".$t["title"]."-".$t["folder"]."-".$t["view"]."-".$_SESSION["username"]."-".sys_date("{t}m/d/Y{/t}",$GLOBALS["time"]);
}

function _export_html_quote($str) {
  return htmlspecialchars($str,ENT_QUOTES);
}

function _export_csv_quote($str) {
  return str_replace(array("\"","\r\n","\n"),array("\"\""," "," "),$str);
}

function _export_client_quote($str) {
  return str_replace(array("\"","\r\n","\n"),array("\"\"","\\n","\\n"),$str);
}

function _export_sss_quote($str) {
  return str_replace(array("\"","\r\n","\n"),array("\"\""," "," "),$str);
}

function export_html($t,$debug) {
  Header("Content-Type: text/html; charset=utf-8");
  Header("Content-Disposition: attachment; filename=\""._export_build_filename($t).".html\"");
  _export_html($t,$debug);
}

function export_sss($t,$debug) {
  Header("Content-Type: text/plain; charset=utf-8");
  _export_sss($t,$debug);
}

function export_sss_editor($t,$debug) {
  Header("Content-Type: text/html; charset=utf-8");
  echo _export_sss_editor(_export_sss($t,$debug,true));
}

function export_xml($t,$debug) {
  Header("Content-Type: text/xml; charset=utf-8");
  Header("Content-Disposition: attachment; filename=\""._export_build_filename($t).".xml\"");
  _export_xml($t,false,$debug);
}

function export_rss($t,$debug) {
  Header("Content-Type: application/atom+xml; charset=utf-8");
  _export_xml($t,true,$debug);
}

function export_icalendar($t,$debug) {
  Header("Content-Type: text/calendar; charset=utf-8");
  Header("Content-Disposition: attachment; filename=\""._export_build_filename($t).".ics\"");
  _export_icalendar($t,$debug);
}

function export_vcard($t,$debug) {
  Header("Content-Type: text/x-vcard; charset=utf-8");
  Header("Content-Disposition: attachment; filename=\""._export_build_filename($t).".vcf\"");
  _export_vcard($t,$debug);
}

function export_ldif($t,$debug) {
  Header("Content-Type: text/plain; charset=utf-8");
  Header("Content-Disposition: attachment; filename=\""._export_build_filename($t).".ldif\"");
  _export_ldif($t,$debug);
}

function export_csv($t,$debug) {
  Header("Content-Type: text/csv; charset=utf-8");
  Header("Content-Disposition: attachment; filename=\""._export_build_filename($t).".csv\"");
  _export_csv($t,$debug);
}

function export_client($t,$debug) {
  Header("Content-Type: text/plain; charset=utf-8");
  _export_client($t,$debug);
}

function export_client_vertical($t,$debug) {
  Header("Content-Type: text/plain; charset=utf-8");
  _export_client_vertical($t,$debug);
}

function export_calc($t,$debug) {
  Header("Content-Type: application/vnd.ms-excel; charset=utf-8");
  Header("Content-Disposition: attachment; filename=\""._export_build_filename($t).".xls\"");
  _export_xls($t,$debug);
}

function export_writer($t,$debug) {
  Header("Content-Type: application/msword; charset=utf-8");
  Header("Content-Disposition: attachment; filename=\""._export_build_filename($t).".doc\"");
  _export_html_vertical($t,$debug);
}
?>