<?php
	/**************************************************************************\
	* Simple Groupware 0.241                                                   *
	* http://www.simple-groupware.de                                           *
	* Copyright (C) 2002-2006 by Thomas Bley                                   *
	* ------------------------------------------------------------------------ *
	*  This program is free software; you can redistribute it and/or           *
	*  modify it under the terms of the GNU General Public License Version 2   *
	*  as published by the Free Software Foundation; only version 2            *
	*  of the License, no later version.                                       *
	*                                                                          *
	*  This program is distributed in the hope that it will be useful,         *
	*  but WITHOUT ANY WARRANTY; without even the implied warranty of          *
	*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the            *
	*  GNU General Public License for more details.                            *
	*                                                                          *
	*  You should have received a copy of the GNU General Public License       *
	*  Version 2 along with this program; if not, write to the Free Software   *
	*  Foundation, Inc., 59 Temple Place - Suite 330, Boston,                  *
	*  MA  02111-1307, USA.                                                    *
	\**************************************************************************/

if (!defined("MAIN_SCRIPT")) exit;
if ($_SESSION["username"]!=SETUP_ADMIN_USER) die("{t}Not allowed. Please log in as super administrator.{/t}");

function _sys_process_action_sys() {
  switch ($_REQUEST["action_sys"]) {
    case "maintenance":
	  $lock_file = SIMPLE_STORE."/maintenance.lck";
	  if (!file_exists($lock_file)) {
	    touch($lock_file);
	    sys_log_message_alert("info","{t}Maintenance mode{/t}: {t}Active{/t}");
	  } else {
	    unlink($lock_file);
	    sys_log_message_alert("info","{t}Maintenance mode{/t}: {t}Inactive{/t}");
	  }
	  break;
    case "clear_locking": dirs_create_empty_dir(SIMPLE_STORE."/locking"); break;
    case "clear_output":
	  dirs_create_empty_dir(SIMPLE_CACHE."/smarty");
	  dirs_create_empty_dir(SIMPLE_CACHE."/output");
	  dirs_create_empty_dir(SIMPLE_CACHE."/jpgraph");
	  dirs_create_empty_dir(SIMPLE_CACHE."/thumbs");
	  break;
	case "clear_debug": dirs_create_empty_dir(SIMPLE_CACHE."/debug"); break;
	case "clear_ip": dirs_create_empty_dir(SIMPLE_CACHE."/ip"); break;
	case "clear_schema":
	  dirs_create_empty_dir(SIMPLE_CACHE."/schema");
	  header("Location: index.php?".$GLOBALS["urladdon"]);
	  exit;
	  break;
	case "clear_schemadata":
	  dirs_create_empty_dir(SIMPLE_CACHE."/schema_data");
	  dirs_create_empty_dir(SIMPLE_CACHE."/preview");
	  break;
	case "clear_email": 
	  dirs_create_empty_dir(SIMPLE_CACHE."/imap");
	  dirs_create_empty_dir(SIMPLE_CACHE."/pop3");
	  break;
	case "clear_upload": dirs_create_empty_dir(SIMPLE_CACHE."/upload"); break;
	case "clean_tables":
	  @set_time_limit(300);
	  db_optimize_tables();
	  sys_log_message_log("clean","{t}Optimize Tables{/t}","");
	  break;
	case "clean_cache": 
	  @set_time_limit(60);
	  $dirs = array(SIMPLE_CACHE."/imap", SIMPLE_CACHE."/pop3", SIMPLE_CACHE."/smarty", SIMPLE_CACHE."/output", SIMPLE_CACHE."/jpgraph", SIMPLE_CACHE."/thumbs", SIMPLE_CACHE."/schema");
	  foreach ($dirs as $dir) dirs_clean_dir($dir,2592000); // 30 days
	  $dirs = array(SIMPLE_CACHE."/schema_data", SIMPLE_CACHE."/preview", SIMPLE_CACHE."/locking", SIMPLE_CACHE."/upload", SIMPLE_CACHE."/ip", SIMPLE_CACHE."/debug");
	  foreach ($dirs as $dir) dirs_clean_dir($dir,86400);
	  sys_log_message_log("clean","{t}Clean Cache{/t}","");
	  header("Location: index.php?".$GLOBALS["urladdon"]);
	  exit;
	  break;
	case "edit_setup":
	  include "core/sysconfig.php";
	  exit;
	  break;
	case "clear_setup":
  	  @unlink(SIMPLE_STORE."/config.php");
	  header("Location: index.php");
	  exit;
	  break;
	case "backup":
	  _sys_create_backup($_SESSION["folder"]);
	  _sys_out("<br><a href='index.php'>{t}Continue{/t}</a>");
	  exit;
	  break;
	case "restore_newer":
	  $GLOBALS["restore_here"] = false;
  	  $GLOBALS["restore_onlynewer"] = true;
	  _sys_restore($_REQUEST["item"]);
	  _sys_out("<br><a href='index.php'>{t}Continue{/t}</a>");
	  exit;
	  break;
	case "restore":
	  $GLOBALS["restore_here"] = false;
  	  $GLOBALS["restore_onlynewer"] = false;
	  _sys_restore($_REQUEST["item"]);
	  _sys_out("<br><a href='index.php'>{t}Continue{/t}</a>");
	  exit;
	  break;
    case "restore_here":
	  $GLOBALS["restore_here"] = true;
  	  $GLOBALS["restore_onlynewer"] = false;
	  _sys_restore($_REQUEST["item"]);
	  _sys_out("<br><a href='index.php'>{t}Continue{/t}</a>");
	  exit;
	  break;
    case "clear_session":
	  db_delete("simple_sys_session",array(),array());
	  header("Location: index.php?".$GLOBALS["urladdon"]);
	  exit;
	  break;
  }
}

function _sys_build_backupdata($folder_obj) {
  $ftype = $folder_obj["ftype"];
  $folder = $folder_obj["id"];
  _sys_out("{t}Backup{/t}: ".$folder);
  $folder_path = _sys_get_backup_folderpath($folder_obj);
  
  $schema_data = db_get_schema(folder_build_schema_filename($ftype),"display");
  $tname = $schema_data["att"]["NAME"];
  
  $data = array();
  if (!strpos($tname,"_nosql_")) {
    $data = db_select($tname,array("*"),array("folder=@folder@"),"created asc","",array("folder"=>$folder));
  }
  $output = "<table name=\"".htmlspecialchars($tname,ENT_QUOTES)."\" folderpath=\"".htmlspecialchars($folder_path,ENT_QUOTES)."\">\n";
  $output .= "<assetfolder id=\"".$folder_obj["id"]."\">\n";
  foreach ($folder_obj as $akey=>$aval) {
	$output .= "<".$akey.">".htmlspecialchars($aval,ENT_QUOTES)."</".$akey.">\n";
  }
  $files = array();
  $output .= "</assetfolder>\n\n";
  if (is_array($data) and count($data)>0) {
    foreach ($data as $key=>$asset) {
	  @set_time_limit(10);
	  $output .= "<asset id=\"".$asset["id"]."\">\n";
	  foreach ($asset as $akey=>$aval) {
	    $is_file = false;
	    if (!empty($schema_data["fields"][$akey]) and $schema_data["fields"][$akey]["SIMPLE_TYPE"]=="files") {
		  $file_arr = explode("|",$aval);
		  foreach ($file_arr as $file) if (!is_dir($file) and file_exists($file)) $files[] = $file;
		  $aval = str_replace(SIMPLE_STORE."/","",$aval);
		  $is_file = true;
		}
	    $output .= "<".$akey.($is_file?" is_file='true'":"").">".htmlspecialchars($aval,ENT_QUOTES)."</".$akey.">\n";
	  }
	  $output .= "</asset>\n\n";
    }
  }
  $output .= "</table>\n";
  if (DEBUG) $output = sys_remove_trans($output);
  
  $files_fields = array();
  foreach ($schema_data["fields"] as $field) {
    if ($field["SIMPLE_TYPE"]=="files") $files_fields[] = str_replace(SIMPLE_STORE."/","",$field["NAME"]);
  }
  return array("output"=>$output,"files"=>$files);
}

function _sys_create_backup($folder) {
  include_once("lib/tar/Tar.php");
  
  $bfolder = db_select_first("simple_sys_tree",array("*"),array("id=@id@"),"lft asc","",array("id"=>$folder));
  $folders = db_select("simple_sys_tree",array("*"),array("lft>=@lft@","rgt<=@rgt@"),"lft asc","",array("lft"=>$bfolder["lft"],"rgt"=>$bfolder["rgt"]));

  $folder_path = _sys_get_backup_folderpath($bfolder);
  $rand_str = $GLOBALS["time"]."-".sha1(uniqid(rand(), true).uniqid(rand(), true));
  $tarfile = SIMPLE_STORE."/backup/".$rand_str."--".urlencode(str_replace("/","__",$folder_path))."--".date("Y-m-d---H-i-s").".tar";
  $cachefile = SIMPLE_CACHE."/backup/".$rand_str."--".urlencode(str_replace("/","__",$folder_path))."--".date("Y-m-d---H-i-s")."_content.xml";

  $files = array();
  $fp = fopen($cachefile,"w");
  fwrite($fp,"<?xml version=\"1.0\" encoding=\"utf-8\"?>\n");
  fwrite($fp,"<data>\n");
  fclose($fp);
  foreach ($folders as $folder) {
    $data = _sys_build_backupdata($folder);
	$files = array_merge($files,$data["files"]);
	$fp = fopen($cachefile,"a");
	fwrite($fp,$data["output"]);
	fclose($fp);
  }
  $fp = fopen($cachefile,"a");
  fwrite($fp,"</data>\n");
  fclose($fp);

  @set_time_limit(300);
  $tar_object = new Archive_Tar($tarfile.".part");
  $tar_object->setErrorHandling(PEAR_ERROR_PRINT);

  $tar_object->addModify(array($cachefile), '', SIMPLE_CACHE."/backup/");
  _sys_out("TAR: ".implode(", ",$files));
  $tar_object->addModify($files, '', SIMPLE_STORE."/");
  if (file_exists($cachefile)) unlink($cachefile);
  rename($tarfile.".part",$tarfile);

  $message = "{t}Backup{/t}: ".$folder_path." [".$bfolder["id"]."]";
  sys_log_message_log("info",$message,"");
  _sys_out($message);
  return "";
}

function _sys_get_backup_folderpath($folder) {
  $parents = db_get_parents($folder);
  $parents[] = $folder;
  $folder_path = "";
  foreach ($parents as $parent) $folder_path .= "/".$parent["ftitle"];
  return $folder_path;
}

function _sys_restore_startElement($parser, $name, $attrs) {
  if ($name=="TABLE") {
    $GLOBALS["restore_buffer"] = array("table"=>$attrs,"data"=>array());
  } else if ($name!="ASSET" and $name!="ASSETFOLDER") {
    $GLOBALS["restore_buffer"]["lastname"] = $name;
    $GLOBALS["restore_buffer"]["is_file"] = isset($attrs["IS_FILE"]);
	$GLOBALS["restore_buffer"]["data"][$name] = "";
  }
}
function _sys_restore_characterData($parser, $data) {
  if (isset($GLOBALS["restore_buffer"]["lastname"])) {
    $name = $GLOBALS["restore_buffer"]["lastname"];
	if (isset($GLOBALS["restore_buffer"]["data"][$name])) {
      $GLOBALS["restore_buffer"]["data"][$name] .= $data;
	}
  }
}
function _sys_restore_endElement($parser, $name) {
  unset($GLOBALS["restore_buffer"]["lastname"]);
  if ($name=="ASSETFOLDER") {
	$data = $GLOBALS["restore_buffer"]["data"];
	$id = $data["ID"];
    $existing = db_select_first("simple_sys_tree",array("id","lastmodified"),array("id=@id@"),"","",array("id"=>$id));
	$data = array_change_key_case($data,CASE_LOWER);
	
	if (!empty($data["anchor"])) {
      $anchor_existing = db_select_first("simple_sys_tree",array("id"),array("anchor=@anchor@"),"","",array("anchor"=>$data["anchor"]));
	  if (!empty($anchor_existing["id"])) unset($data["anchor"]);
	}
	$ftype = $data["ftype"];
	unset($data["fsizecount"]);
	unset($data["fchsizecount"]);
	unset($data["fcount"]);
	unset($data["fchcount"]);
	unset($data["lft"]);
	unset($data["rgt"]);
	unset($data["flevel"]);
	unset($data["folder"]);
	unset($data["id"]);
	unset($data["ftype"]);

	if (isset($GLOBALS["restore_maps"][$data["parent"]])) {
	  $data["parent"] = $GLOBALS["restore_maps"][$data["parent"]];
	}
    if (empty($existing["id"]) or $GLOBALS["restore_here"]) {
      $parent = db_select_first("simple_sys_tree",array("id"),array("id=@id@"),"","",array("id"=>$data["parent"]));
	  if (empty($parent["id"]) or (count($GLOBALS["restore_maps"])==0 and $GLOBALS["restore_here"])) {
	    $data["parent"] = $GLOBALS["restore_folder"];
	  }
	  $id2 = _folder_create($data["ftitle"],$ftype,$data["parent"],false,array("nochecksys"=>true));
	  _sys_out("{t}Insert{/t}: simple_sys_tree: ".$data["ftitle"]." [".$id2."]");
	  $GLOBALS["restore_maps"][$id] = $id2;
	  $id = $id2;
	}
	if (!$GLOBALS["restore_onlynewer"] or $data["lastmodified"] > $existing["lastmodified"]) {
	  _sys_out("{t}Update{/t}: simple_sys_tree ".$id);
	  $error = db_update("simple_sys_tree",$data,array("id=@id@"),array("id"=>$id));
  	  if ($error) _sys_out($error);
	}
    $GLOBALS["restore_buffer"]["data"] = array();
  } else if ($name=="ASSET") {
    $table = $GLOBALS["restore_buffer"]["table"]["NAME"];
	if ($table=="simple_sys_tree") return;
	$data = $GLOBALS["restore_buffer"]["data"];
	$id = $data["ID"];
    $existing = db_select_first($table,array("id","lastmodified"),array("id=@id@"),"","",array("id"=>$id));
	$data = array_change_key_case($data,CASE_LOWER);
	$folder = $data["folder"];
	if (isset($GLOBALS["restore_maps"][$folder])) $data["folder"] = $GLOBALS["restore_maps"][$folder];

    if (empty($existing["id"]) or $GLOBALS["restore_here"]) {
      $data["id"] = sql_genID($table)*100+$_SESSION["serverid"];
	  _sys_out("{t}Insert{/t}: ".$table.": ".$data["id"]);
      $error = db_insert($table,$data);
	  if ($error) _sys_out($error);
	  $GLOBALS["restore_update_folder"][$data["folder"]] = $table;
	} else {
	  if (!$GLOBALS["restore_onlynewer"] or $data["lastmodified"] > $existing["lastmodified"]) {
	    _sys_out("{t}Update{/t}: ".$table." ".$id);
	  	$error = db_update($table,$data,array("id=@id@"),array("id"=>$id));
  	    if ($error) _sys_out($error);
	    $GLOBALS["restore_update_folder"][$data["folder"]] = $table;
	  }
	}
    $GLOBALS["restore_buffer"]["data"] = array();
  } else {
    if ($GLOBALS["restore_buffer"]["is_file"] and isset($GLOBALS["restore_buffer"]["data"][$name])) {
	  $file_arr = explode("|",$GLOBALS["restore_buffer"]["data"][$name]);
	  foreach ($file_arr as $key=>$value) {
	    $file_arr[$key] = SIMPLE_STORE."/restore_".$GLOBALS["time"]."/".$value;
	  }
	  $GLOBALS["restore_buffer"]["data"][$name] = implode("|",$file_arr);
	}
  }
}

function _sys_restore($filename) {
  include_once("lib/tar/Tar.php");
  ob_end_flush();
  
  $filename = SIMPLE_STORE."/backup/".basename($filename);
  if (!file_exists($filename)) return "{t}file not found.{/t} (".$filename.")";
  if (filesize($filename)==0) return "{t}No entries found.{/t} (".$filename.")";
  
  _sys_out("{t}Extracting files{/t}: ".$filename);
  _sys_out("");

  $GLOBALS["restore_maps"] = array();
  if ($GLOBALS["restore_here"]) {
    $ftitle = str_replace(array("__","---","--"),array("/"," "," "),substr(modify_basename($filename),0,-4));
	$ftitle = substr($ftitle,strrpos($ftitle,"/")+1);
    $id = _folder_create(substr($ftitle,0,40),"blank",$_SESSION["folder"],false);
    $GLOBALS["restore_folder"] = $id;
	_sys_out("{t}Insert{/t}: simple_sys_tree: ".$ftitle." [".$id."]");
  }
  $tar_object = new Archive_Tar($filename);
  $tar_object->setErrorHandling(PEAR_ERROR_PRINT);
  $tar_object->extract(SIMPLE_STORE."/restore_".$GLOBALS["time"]."/");
  
  if (($file_list=$tar_object->ListContent())!=0) {
	$GLOBALS["restore_update_folder"] = array();
	foreach ($file_list as $file) {
	  $file_name = str_replace(chr(0),"",$file["filename"]);
	  if (!strpos("@".$file_name,"/")) {
		_sys_out("{t}Parsing{/t}: ".$file_name);
	    $xml_parser = xml_parser_create("utf-8");
		xml_parser_set_option($xml_parser,XML_OPTION_SKIP_WHITE,1);
		xml_set_element_handler($xml_parser, "_sys_restore_startElement", "_sys_restore_endElement");
		xml_set_character_data_handler($xml_parser, "_sys_restore_characterData");
		$GLOBALS["restore_buffer"] = array();
	    if ($fp = fopen(SIMPLE_STORE."/restore_".$GLOBALS["time"]."/".$file_name,"rb")) {
		  while ($data = fread($fp, 8192)) {
		    @set_time_limit(30);
		    $data = str_replace(chr(0),"",$data);
		    if (!xml_parse($xml_parser, $data, feof($fp))) {
		       die(sprintf("XML error: %s at line %d",xml_error_string(xml_get_error_code($xml_parser)),xml_get_current_line_number($xml_parser)));
		    }
		  }
		  xml_parser_free($xml_parser);
		  fclose($fp);
		  unlink(SIMPLE_STORE."/restore_".$GLOBALS["time"]."/".$file_name);
		}
	  }
	}
	if (count($GLOBALS["restore_update_folder"])>0) {
	  foreach ($GLOBALS["restore_update_folder"] as $folder) {
	    db_update_treesize($folder[0],$folder[1]);
	  }
	}
  }
  _sys_out("");
  $message = "{t}Restore complete{/t}: ".str_replace(array("__","---","--"),array("/","] ["," ["),substr(modify_basename($filename),0,-4))."]";
  sys_log_message_log("info",$message,"");
  _sys_out($message);
  return "";
}

function _sys_out($str) {
  if (DEBUG) $str = sys_remove_trans($str);
  echo $str."<br>\n";
  @ob_flush();
  flush();
}
?>