<?php
	/**************************************************************************\
	* Simple Groupware 0.241                                                   *
	* http://www.simple-groupware.de                                           *
	* Copyright (C) 2002-2006 by Thomas Bley                                   *
	* ------------------------------------------------------------------------ *
	*  This program is free software; you can redistribute it and/or           *
	*  modify it under the terms of the GNU General Public License Version 2   *
	*  as published by the Free Software Foundation; only version 2            *
	*  of the License, no later version.                                       *
	*                                                                          *
	*  This program is distributed in the hope that it will be useful,         *
	*  but WITHOUT ANY WARRANTY; without even the implied warranty of          *
	*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the            *
	*  GNU General Public License for more details.                            *
	*                                                                          *
	*  You should have received a copy of the GNU General Public License       *
	*  Version 2 along with this program; if not, write to the Free Software   *
	*  Foundation, Inc., 59 Temple Place - Suite 330, Boston,                  *
	*  MA  02111-1307, USA.                                                    *
	\**************************************************************************/

if (!defined("MAIN_SCRIPT")) exit;

function trigger_login() {
  if (!is_dir(SIMPLE_STORE."/home/".$_SESSION["username"])) sys_mkdir(SIMPLE_STORE."/home/".$_SESSION["username"]);
  db_update("simple_sys_users",array("status"=>"online"),array("username=@username@","status!='ooo'"),array("username"=>$_SESSION["username"]));
  return "";
}

function trigger_logout() {
  db_update("simple_sys_users",array("status"=>"offline"),array("username=@username@","status!='ooo'"),array("username"=>$_SESSION["username"]));
  return "";
}

function trigger_createuser($id,$data) {
  if (!is_dir(SIMPLE_STORE."/home/".$data["username"])) sys_mkdir(SIMPLE_STORE."/home/".$data["username"]);
  $folder = db_select_first("simple_sys_tree",array("id"),array("anchor=@username@"),"lft asc","",array("username"=>"home_".$data["username"]));
  if (!empty($folder["id"])) {
	$bookmarks = array(
	  array("1) {t}E-mail{/t}","emails","&view=display",1),
	  array("2) {t}Calendar{/t}","calendar","&view=display&markdate=custom&today=last monday&tomorrow=monday 23:59",1),
	  array("3) {t}Tasks{/t}","tasks","&view=display",1),
	  array("4) {t}Bookmarks{/t}","bookmarks","&view=display",1),
	  array("5) {t}Notes{/t}","notes","&view=display",1),
	);
	foreach ($bookmarks as $bookmark) {
      $folder_id = db_select_first("simple_sys_tree",array("id"),array("ftype=@ftype@","parent=@parent@"),"lft asc","",array("ftype"=>$bookmark[1],"parent"=>$folder["id"]));
      $id = sql_genID("simple_portal")*100+$_SESSION["serverid"];
      $data = array(
        "id"=>$id,
        "bookmarkname"=>$bookmark[0],
        "url"=>"index.php?folder=".$folder_id["id"].$bookmark[2],
        "folder"=>$folder["id"],
		"fullwidth"=>$bookmark[3]
      );
      $error_sql = db_insert("simple_portal",$data);
	}
  }
  return "";
}

function trigger_deleteuser($id,$data) {
  $res = db_select_first("simple_sys_users",array("count(*) as count"),array("username=@username@"),"","",array("username"=>$data["username"]));
  if (isset($res["count"]) and $res["count"]==1) {
    $row = db_select_first("simple_sys_tree",array("id"),array("anchor=@anchor@"),"","",array("anchor"=>"home_".$data["username"]));
    if (!empty($row["id"])) _folder_action_delete_folder($row["id"]);
  }
  return "";
}

function trigger_update_rights($id,$data) {
  $error_sql = "";
  if (is_numeric($id) and db_get_rights($id,"","admin")) {
    $t = $GLOBALS["t"];
	$data2 = array();
	foreach ($t["fields"] as $key=>$field) {
	  // TODO2 find changed fields and fix history ?
	  if (isset($data[$key])) $data2[$key] = $data[$key];
	}
	if (count($data2)>0) $error_sql = db_update("simple_sys_tree",$data2,array("id=@id@"),array("id"=>$id));
  }
  return $error_sql;
}

function trigger_increase_pwdexpire($id,$data) {
  $row = db_select_first("simple_sys_users",array("pwdexpires"),array("id=@id@"),"","",array("id"=>$id));
  if (!empty($row["pwdexpires"]) and $row["pwdexpires"]<$GLOBALS["time"]) {
    $expires = $GLOBALS["time"] + 7776000; // 90 days
	db_update("simple_sys_users",array("pwdexpires"=>$expires),array("id=@id@"),array("id"=>$id));
  }
}

function trigger_creategroup($name) {
  $row = db_select_first("simple_sys_groups",array("id"),array("groupname=@name@"),"","",array("name"=>$name));
  if (empty($row["id"])) {
    $folder = db_select_first("simple_sys_tree",array("id"),array("ftype=@ftype@"),"lft asc","",array("ftype"=>"sys_groups"));
    if (!empty($folder["id"])) {
	  $id = sql_genID("simple_sys_groups")*100+$_SESSION["serverid"];
      $data = array(
	    "id"=>$id,
	    "groupname"=>$name,
	    "folder"=>$folder["id"],
	  );
      $error_sql = db_insert("simple_sys_groups",$data);
	  if ($error_sql=="") {
	    db_search_update("simple_sys_groups",$id,array("groupname"=>array("SIMPLE_TYPE"=>"text")));
	    db_update_treesize("simple_sys_groups",$folder["id"]);
	    sys_log_stat("new_records",1);
	  } else return $error_sql;
	}
  }
  return "";
}

function trigger_createproject($id,$data) {
  return trigger_creategroup($data["projectname"]);
}

function trigger_createdepartment($id,$data) {
  return trigger_creategroup($data["departmentname"]);
}

function trigger_deleteproject($id,$data) {
  $res = db_select_first("simple_projects",array("count(*) as count"),array("projectname=@projectname@"),"","",array("projectname"=>$data["projectname"]));
  if (isset($res["count"]) and $res["count"]==1) {
    $row = db_select_first("simple_sys_tree",array("id"),array("anchor=@anchor@"),"","",array("anchor"=>"projects_".$data["projectname"]));
    if (!empty($row["id"])) _folder_action_delete_folder($row["id"]);
  }
  return "";
}

function trigger_deletechat($id,$data) {
  $res = db_select_first("simple_chat",array("count(*) as count"),array("roomname=@roomname@"),"","",array("roomname"=>$data["roomname"]));
  if (isset($res["count"]) and $res["count"]==1) {
	db_delete("simple_sys_chat2",array("folder=@folder@","room=@room@"),array("folder"=>$data["folder"],"room"=>$data["roomname"]));
  }
  return "";
}

function trigger_deletedepartment($id,$data) {
  $res = db_select_first("simple_departments",array("count(*) as count"),array("departmentname=@departmentname@"),"","",array("departmentname"=>$data["departmentname"]));
  if (isset($res["count"]) and $res["count"]==1) {
    $row = db_select_first("simple_sys_tree",array("id"),array("anchor=@anchor@"),"","",array("anchor"=>"departments_".$data["departmentname"]));
    if (!empty($row["id"])) _folder_action_delete_folder($row["id"]);
  }
  return "";
}

function trigger_sendmail_pop3($id,$data) {
  return trigger_sendmail($id,$data,true);
}

function trigger_sendmail($id,$data,$to_self=false) {
  $error = "";
  $row = db_select_first("simple_sys_users",array("smtp"),array("username=@username@"),"","",array("username"=>$_SESSION["username"]));
  if (!empty($row["smtp"])) {
	$credentials = sys_parse_folder("smtp:".$row["smtp"]."/");
	$GLOBALS["credentials"]["smtp_".$data["folder"]] = array(
	  "username"=>$credentials["user"],
	  "password"=>$credentials["pass"],
	  "server"=>$credentials["mfolder"],
	  "port"=>$credentials["port"],
	  "ssl"=>$credentials["ssl"],
	  "options"=>$credentials["options"]
	);
    include_once("modules/lib/smtp.php");
	$error = smtp_insert("",$data,$data["folder"],$to_self);
  } else {
    $error = sprintf("{t}SMTP not configured for %s{/t}",$_SESSION["username"]);
  }
  return $error;
}

function trigger_calcactivity($id,$data) {
  $duration = $data["ending"] - $data["begin"];
  db_update("simple_contactactivities",array("duration"=>$duration),array("id=@id@"),array("id"=>$id));
}

function trigger_calcappointment($id,$data) {
  $until = 0;
  if ($data["allday"]=="1") {
    $begin_arr = getdate($data["begin"]);
    $data["begin"] = mktime(0,0,0,$begin_arr["mon"],$begin_arr["mday"],$begin_arr["year"]);
    $end_arr = getdate($data["ending"]);
    $data["ending"] = mktime(23,59,0,$end_arr["mon"],$end_arr["mday"],$end_arr["year"]);
  }
  if ($data["recurrence"]!="" and $data["repeatcount"]*$data["repeatinterval"]>0) {
    $excludes = explode("|",trim($data["repeatexcludes"],"|"));
	if (empty($excludes[0])) unset($excludes[0]);
    $data["repeatcount"] += count($excludes);
    $until = strtotime("+".(int)($data["repeatcount"]*$data["repeatinterval"]-1)." ".$data["recurrence"],$data["begin"]);
  }
  $duration = $data["ending"] - $data["begin"];
  if ($until>$data["repeatuntil"] and $data["repeatuntil"]!=0) $until = $data["repeatuntil"];
  $repeatbegin = 0;
  $repeatend = 0;
  switch ($data["recurrence"]) {
	case "weeks":
      $repeatbegin = date("w",$data["begin"]);
      $repeatend = date("w",$data["ending"]);
	  break;
	case "months":
      $repeatbegin = date("j",$data["begin"]);
      $repeatend = date("j",$data["ending"]);
	  break;
	case "years":
      $repeatbegin = date("z",$data["begin"]);
      $repeatend = date("z",$data["ending"]);
	  break;
  }
  if ($id!="") {
    db_update("simple_calendar",array("begin"=>$data["begin"],"ending"=>$data["ending"],"duration"=>$duration,"until"=>$until,"repeatbegin"=>$repeatbegin,"repeatend"=>$repeatend),array("id=@id@"),array("id"=>$id));
  } else return array("until"=>$until,"repeatbegin"=>$repeatbegin,"repeatend"=>$repeatend);
  return "";
}

function trigger_runxml($id,$data,$file,$parent_function) {
  $home = db_select_first("simple_sys_tree",array("id"),array("anchor=@anchor@"),"lft asc","",array("anchor"=>$parent_function));
  if (!empty($home["id"]) and file_exists($file)) {
    $str_xml = file_get_contents($file);
    $matches = "";
    if (preg_match_all("|@(.*?)@|i",$str_xml,$matches,PREG_SET_ORDER)) {
	  foreach ($matches as $match) {
	    if (count($match)==2) {
		  $req_key = $match[1];
		  if (isset($data[$req_key])) $str_xml = str_replace("@".$req_key."@",$data[$req_key],$str_xml);
	    }
	  }
    }  
    folder_create_default_folders($str_xml,$home["id"],false);
  }
  return "";
}
?>