<?php
	/**************************************************************************\
	* Simple Groupware 0.241                                                   *
	* http://www.simple-groupware.de                                           *
	* Copyright (C) 2002-2006 by Thomas Bley                                   *
	* ------------------------------------------------------------------------ *
	*  This program is free software; you can redistribute it and/or           *
	*  modify it under the terms of the GNU General Public License Version 2   *
	*  as published by the Free Software Foundation; only version 2            *
	*  of the License, no later version.                                       *
	*                                                                          *
	*  This program is distributed in the hope that it will be useful,         *
	*  but WITHOUT ANY WARRANTY; without even the implied warranty of          *
	*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the            *
	*  GNU General Public License for more details.                            *
	*                                                                          *
	*  You should have received a copy of the GNU General Public License       *
	*  Version 2 along with this program; if not, write to the Free Software   *
	*  Foundation, Inc., 59 Temple Place - Suite 330, Boston,                  *
	*  MA  02111-1307, USA.                                                    *
	\**************************************************************************/

if (!defined("MAIN_SCRIPT")) exit;

function ______M_O_D_I_F_Y______() {}

function modify_folderstructure($var,$arr,$data) {
  return str_repeat("|_ ", $data["flevel"]["data"][0]).$var;
}

function modify_stripslashes(&$val) {
  if (is_array($val)) array_walk($val,"modify_stripslashes"); else $val = stripslashes($val);
} 

function modify_switch($data,$arr) {
  $default = "";
  if (is_array($arr) and count($arr)>0) {
    foreach ($arr as $item) {
      $item = explode("?",$item);
	  if (count($item)==2 and $data==$item[0]) return $item[1];
	    elseif (count($item)==3 and is_array($data) and isset($data[$item[0]]["data"]) and $data[$item[0]]["data"]==$item[1]) return $item[2];
	    else $default = $item[0];
    }
  }
  return $default;
}

function modify_task_dependancy($task,$params,$row) {
  if (isset($row["begin"]["data"]) and isset($row["ending"]["data"]) and 
  	  isset($row["subject"]["data"]) and $row["subject"]["data"][0]!=$task) {
    $item = db_select_first("simple_tasks",array("ending","begin"),array("subject=@subject@"),"","",array("subject"=>$task));
    if (!empty($item["ending"]) and !($item["ending"] <= $row["begin"]["data"][0] or $item["begin"] >= $row["ending"]["data"][0])) {
	  $task .= " [{t}overlap{/t}]";
	}
  }
  return $task;
}

function modify_buildbgcolor($data,$arr) {
  if (isset($data[$arr[0]])) {
    $value = $data[$arr[0]]["data"][0];
	if ($value!="") return "background-color:".$value.";";
  }
  return "";
}

function modify_buildseenstyle($data,$arr) {
  if (isset($data[$arr[0]]) and $data["lastmodifiedby"]!=$_SESSION["username"]) {
    $value = $data[$arr[0]]["data"][0];
	if ($value=="" or $value=="0") return "font-weight:bold;";
  }
  return "";
}

function modify_explode($var) {
  if (is_array($var)) return $var;
  if ($var=="") return array();
  $var = explode("|",$var);
  $result = array();
  foreach ($var as $val) {
    $i = strpos("@".$val,"_##_");
	if ($i>0) $result[substr($val,0,$i-1)] = substr($val,$i+3);
	  else if ($val!="") $result[$val] = $val;
  }
  return $result;
}

function modify_getpath($var) {
  if ($var=="") return "";
  $sel_folder = db_select_first("simple_sys_tree",array("id","rgt","lft","ftitle"),array("id=@id@"),"","",array("id"=>$var));
  if (empty($sel_folder["id"])) return $var;
  $parents = db_get_parents($sel_folder);
  if (!is_array($parents) or count($parents)==0) return " / ".$sel_folder["ftitle"];
  $result = "";
  foreach ($parents as $parent) $result .= " / ".$parent["ftitle"];
  return $result." / ".$sel_folder["ftitle"];
}

function modify_searchindex($value) {
  $value = strtr($value,array_flip(get_html_translation_table(HTML_ENTITIES)));
  $value = strip_tags(str_replace("<br>"," ",$value));
  $value = trim(str_replace(array("&#8211;",chr(255),"\r","\n")," ",$value));
  if ($value=="http://") $value="";
  return trim($value);
}

function modify_link($link,$row,$subitem,$urladdon) {
  if (isset($row["folder"]["data"][0]) and $row["folder"]["data"][0]=="sys_tree") {
    $row["folder"] = $row["id"]["data"][0];
	$row["id"]["data"][0] = "";
  }
  $matches = "";
  $row["subitem"]["data"][0] = $subitem;
  if (preg_match_all("|@(.*?)@|i",$link,$matches,PREG_SET_ORDER)) {
	foreach ($matches as $match) {
	  if (count($match)==2) {
		$req_key = $match[1];
		if (isset($row[$req_key]["data"][0])) $link = str_replace("@".$req_key."@",urlencode($row[$req_key]["data"][0]),$link);
		  elseif (isset($row[$req_key])) $link = str_replace("@".$req_key."@",urlencode($row[$req_key]),$link);
	  }
	}
	if (!strpos($link,"norefer.php")) $link .= "&".$urladdon;
  }
  return $link;
}

function modify_date_translate($str) {
  $index = 1;
  $pattern = "";
  $replace = array();
  $preg = sys_remove_trans("{t}m/d/Y{/t}");
  for ($i=0; $i<strlen($preg); $i++) {
    $token = $preg[$i];
	if ($token == "m") {
	  $pattern .= "(\d{1,2})";
	  $replace[0] = "\\".$index++;
	} else if ($token == "d") {
	  $pattern .= "(\d{1,2})";
	  $replace[1] = "\\".$index++;
	} else if ($token == "Y") {
	  $pattern .= "(\d{2,4})";
	  $replace[2] = "\\".$index++;
	} else if ($token == " ") {
	  $pattern .= " ?";
	} else {
      $pattern .= preg_quote($token);
	}
  }
  ksort($replace);
  return preg_replace("!".$pattern."(.*?)!",implode("/",$replace)."\\".$index,$str);
}

function modify_datetime_to_int($str) {
  if (empty($str)) return 0;
  if (is_array($str)) {
    foreach ($str as $key=>$item) {
	  $item = strtotime(modify_date_translate($item));
	  if ($item<0 or !is_numeric($item)) $item = $GLOBALS["time"];
	  $str[$key] = $item;
	}
  } else {
    $str = strtotime(modify_date_translate($str));
    if ($str<0 or !is_numeric($str)) $str = $GLOBALS["time"];
  }
  return $str;
}

function modify_nl2br($str) {
  if (strlen($str)>200) $str = "<code>".$str."</code>";
  if (strlen($str)>30) {
    $from = array("!(http:|https:|www|\S+@)\S+!i", "| _(\S+)_|", "| \*(\S+)\*|");
	$to = array("<a target=\"_blank\" href=\"ext/norefer.php?url=$0\" onmousedown=\"event.cancelBubble=true;\">$0</a>", " <u>$1</u>", " <b>$1</b>");
	$str = preg_replace($from,$to,$str);

	if (strpos($str,"\n&gt;")) {
      $rep = "<span><p><br><a href='#' onclick='showhide(this.parentNode.parentNode.lastChild); return false;'>&gt; {t}Show quoted text{/t}</a><br><div style='display:none;'>\\1</div></span>";
      $str = preg_replace("/\n&gt;([ ]?)/","<br>&gt; ",$str)."\n";
      $str = preg_replace("/(<br>&gt;.*?\n)/",$rep,$str);
	}
  }
  return str_replace(array("\n","\t","  "),array("<br>","&nbsp;&nbsp;&nbsp;&nbsp;","&nbsp; "),$str);
}

function modify_highlight_search($search) {
  $vals = str_replace(" ","|",preg_replace("/ +/"," ",$GLOBALS["t"]["search"]));
  $preg = "/(".str_replace(array("/","*"),array("","[\\w]*"),$vals).")/i";
  $search = htmlspecialchars($search);
  if (strlen($search)>500) {
    $pos = 0;
    if (preg_match($preg,$search,$match)) {
	  $pos = strpos($search,$match[0]);
	  if ($pos>25) $pos -= 25; else $pos = 0;
	}
	if ($pos > 25) {
	  $search = substr($search,0,25)." ... ".substr($search,$pos,470)." ...";
	} else $search = substr($search,0,500)." ...";
  }
  $search = preg_replace($preg,"<span style='background-color: #FFFF80;'>$0</span>",$search);
  return $search;
}

function modify_highlight_string($str) {
  if ($str=="") return "";
  $str = str_replace(array("  "),array("&nbsp; "),htmlspecialchars($str));
  $str = preg_replace('/(&quot;.*?&quot;)/si',"<font color='#DD0000'>\\1</font>",$str);
  $result = "";
  foreach (explode("\n",$str) as $key=>$line) $result .= "<li>".$line."</li>";
  return "<htmlcode><code><font style='color:#0000DD;'><ol>".$result."</ol></font></code></htmlcode>";
}

function modify_highlight_wiki($str) {
  if ($str=="") return "";
  require_once "lib/wiki/Wiki.php";
  $wiki =& new Text_Wiki();
  $wiki->setRenderConf("xhtml", "wikilink", "view_url","ext/norefer.php?url=");
  $wiki->setRenderConf("xhtml", "wikilink", "new_url","ext/norefer.php?url=");
  $wiki->setRenderConf("xhtml", "wikilink", "view_text","@");
  $wiki->disableRule("Interwiki");
  $wiki->disableRule("Image");
  $str = $wiki->transform($str, "Xhtml");
  
  return $str;
}

function modify_htmlfield($text,$allow_pics=false) {
  $badtags = array("applet","area","base","body","button","embed","form","frame","frameset","head",
    "html","iframe","input","link","map","marquee","meta","noscript","object","script","select","style","textarea","title","!doctype");
  if (!$allow_pics) $badtags[] = "img";
  $result = "";
  $text = str_replace(chr(0),"",$text); // remove null-byte vulnerability
  $text = preg_replace(array("|<head[^>]*?>.*?</head>|si","|<script[^>]*?>.*?</script>|si","|<style[^>]*?>.*?</style>|si","|<!--.*?-->|si"),"",$text);
  $text = explode("<"," ".$text);
  $result = array_shift($text);
  foreach ($text as $v) {
    $v = explode(">",$v);
    $bad_tag = false;
	$tag_new = "";
    $tag_arr = explode(" ",trim($v[0]));
	foreach ($tag_arr as $key=>$item_str) {
	  $item = explode("=",$item_str);
	  $item[0] = strtolower($item[0]);
	  if ($item[0][0]=="/") $item[0] = substr($item[0],1);
	  if (substr($item[0],0,2)=="on") continue;
	  if ($key==0 and in_array($item[0],$badtags)) {
	    $bad_tag = true;
		break;
	  } else $tag_new .= " ".$item_str;
	}
	if (!$bad_tag) $result .= "<".trim($tag_new).">";
	if (!empty($v[1])) $result .= $v[1];
  }
  return $result;
}

function modify_striplinksforms($html) {
  $search = array ("'<input.*?>'si","'<noprint[^>]*?>.*?</noprint>'si","'<script[^>]*?>.*?</script>'si","'<form[^>]*?>.*?</form>'si","'<a[^>]*?>.*?</a>'si");
  $html = preg_replace($search, array("&nbsp;","","","&nbsp;",""), $html);
  $html = str_replace(array("> ","<noscript>","</noscript>","display:none"),array(">","","",""),$html);
  return $html;
}

function modify_threadsort($arr) {
  $arr2 = array();
  foreach ($arr as $key=>$value) {
    $arr[$key]["sorting"] = $key;
  }
  uasort($arr, "sys_threadsort_cmp");
  foreach ($arr as $value) {
    $arr2[$value["pid"]][] = $value;
  }
  $result = array();
  sys_threadsort($arr,0,$result,$arr,$arr2);
  $last_sort = 0;
  $elems = count($result);
  foreach ($result as $key=>$resultitem) {
    if ($resultitem["tlevel"]==0) $last_sort = $resultitem["sorting"]*$elems; else $last_sort++;
    $result[$key]["sorting"] = $last_sort;
  }
  uasort($result, "sys_threadsort_cmp2");
  return array_values($result);
}

function modify_truncate($value,$args) {
  if (strlen($value)>$args[0]) return substr($value,0,$args[0])." ..."; else return $value;
}

function modify_empty($value) {
  return "";
}

function modify_sha1($value) {
  if (strlen($value)!=40) return sha1($value); else return $value;
}

function modify_hidepassword($value,$args) {
  return str_repeat("*",strlen($value));
}

function modify_replacechecked($checked) {
  if ($checked=="checked") return 1;
    elseif ($checked=="") return 0;
    elseif ($checked==1) return "{t}yes{/t}";
	else return "{t}no{/t}";
}

function _modify_mydate($format,$date) {
  if ($date==0) return ""; else return sys_date($format,$date);
}

function modify_dateformat($args,$args2=null) {
  if (!is_array($args2) and $args2!="") return _modify_mydate($args2,$args);
  if (is_array($args2)) {
    if (!empty($args2[0]) and !is_numeric($args2[0])) $args = strtotime($args2[0],$args);
	if ($args<0) return "";
	$date = @_modify_mydate($args2[1],$args);
	if ($date=="" and $args!=0) return $args;
	return $date;
  }
  if (!is_array($args) or count($args)!=2) return "";
  if (!is_numeric($args[0])) $args[0] = strtotime($args[0]);
  return _modify_mydate($args[1],$args[0]);
}

function modify_dateformat_request($args,$args2=null) {
  $field = array_shift($args);
  if (isset($_REQUEST[$field])) $args[0] = $_REQUEST[$field];
  return modify_dateformat($args,$args2=null);
}

function modify_fillfrom($args) {
  if (isset($_REQUEST[$args[0]])) {
    if (sys_strbegins($_REQUEST[$args[0]],"mailto:")) $_REQUEST[$args[0]] = substr($_REQUEST[$args[0]],7);
    return $_REQUEST[$args[0]];
  }
}

function modify_shortemail($val) {
  $val = str_replace(array("(",")","\"","'",","),"",$val);
  $val2 = trim(strip_tags($val));
  if ($val2!="") return $val2; else return str_replace(array("<",">"),"",$val);
}

function modify_shortmessage_html($value,$args) {
  $value = trim(preg_replace("/^&gt;.*?$/m","",strip_tags($value)));
  if (strlen($value)>$args[0]) {
    $args[0] = strpos($value," ",$args[0]);
    if ($args[0]>0) $value = substr($value,0,$args[0])." ...";
  }
  return $value;
}

function modify_shortmessage($value,$args) {
  $value = trim(str_replace(array("\n","  ")," ",preg_replace("/^>.*?$/m","",$value)));
  $value = preg_replace("/[=*]+/","",$value);
  if (strlen($value)>$args[0]) {
    $args[0] = strpos($value," ",$args[0]);
    if ($args[0]>0) $value = substr($value,0,$args[0])." ...";
  }
  return $value;
}

function modify_htmlmessage($value) {
  if ($pos = strpos($value,"<body")) $value = substr($value,$pos);
  if ($pos = strpos($value,"<BODY")) $value = substr($value,$pos);
  $value = str_replace(array("\n","</tr>","<br>","<p>"),array("","\n","\n","\n"),$value);
  $value = explode("\n",html_entity_decode(strip_tags($value), ENT_QUOTES));
  foreach ($value as $key=>$val) $value[$key] = trim($val);
  $value = implode("\n",$value);
  $value = preg_replace(array("/ +/","/\n{2,}/"),array(" ","\n\n"),$value);
  return $value;
}

function modify_replymessage($value,$args,$data) {
  $value = trim(str_replace("\n","\n> ","\n".wordwrap($value)));
  if (!empty($data["efrom"]["data"][0]) and !empty($data["created"])) {
    $value = $data["efrom"]["data"][0].":\n".$value;
    $value = "On ".modify_dateformat($data["created"],array("","{t}m/d/Y{/t}")).", ".$value;
  }
  return "\n\n\n".$value;
}

function modify_forwardmessage($value,$args,$data) {
  $value = trim(str_replace("---\r\n".SMTP_FOOTER,"",$value));
  $val = "-------- {t}Original message{/t} --------\n";
  if (!empty($data["subject"]["data"][0])) $val .= "{t}Subject{/t}: ".$data["subject"]["data"][0]."\n";
  if (!empty($data["created"])) $val .= "{t}Date{/t}: ".modify_dateformat($data["created"],array("","{t}m/d/Y{/t}"))."\n";
  if (!empty($data["efrom"]["data"][0])) $val .= "{t}From{/t}: ".$data["efrom"]["data"][0]."\n";
  if (!empty($data["eto"]["data"][0])) $val .= "{t}To{/t}: ".$data["eto"]["data"][0]."\n";
  if (!empty($data["cc"]["data"][0])) $val .= "{t}Cc{/t}: ".$data["cc"]["data"][0]."\n";
  return "\n\n\n".$val."\n".$value;
}

function modify_copyfiles_totemp($value) {
  if ($value=="" or !file_exists($value)) return;
  list($target,$filename) = sys_build_filename("",modify_basename($value),"temp");
  dirs_checkdir($target);
  $target .= $_SESSION["username"]."__".$filename;
  if (copy($value,$target)) return $target; else return "";
}

function modify_replyto($value,$args,$data) {
  if (isset($data["efrom"]["data"][0])) $value = $data["efrom"]["data"][0];
  return $value;
}

function modify_replytoall($value,$args,$data) {
  if (isset($data["efrom"]["data"][0])) $value = $data["efrom"]["data"][0];
  if (isset($data["eto"]["data"][0])) $value .= ", ".$data["eto"]["data"][0];
  if (isset($data["cc"]["data"][0])) $value .= ", ".$data["cc"]["data"][0];
  return trim($value,", ");
}

function modify_replypid($value,$args,$data) {
  if (isset($data["_id"])) $value = $data["_id"];
  return $value;
}

function modify_replysubject($value) {
  return "Re: ".$value;
}

function modify_forwardsubject($value) {
  return "Fwd: ".$value;
}

function modify_translate_recurrence($value) {
  switch ($value) {
    case "years": return "{t}yearly{/t}"; break;
	case "months": return "{t}monthly{/t}"; break;
	case "weeks": return "{t}weekly{/t}"; break;
	case "days": return "{t}daily{/t}"; break;
	default: return ""; break;
  }
}

function modify_shortdateformat($args) {
  if ($args<1) return "";
  $time_arr = getdate();
  $format = "{t}m/d/Y{/t}";
  $midnight = mktime(0,0,0,$time_arr["mon"],$time_arr["mday"],$time_arr["year"]);
  if ($midnight + 2678400 < $args) { // more than 31 days future
    $format = "{t}m/d/Y{/t}";
  } else if ($midnight + 518400 < $args) { // more than 6 days future
    $format = "{t}M j{/t}";
  } else if ($midnight + 86400 < $args) { // more than 1 day future
    $format = "{t}M j, g:i a{/t}";
  } else if ($midnight < $args) { // today
    $format = "{t}g:i a{/t}";
  } elseif ($midnight - 518400 < $args) {// 6 days past
    $format = "{t}M j, g:i a{/t}";
  } elseif ($midnight - 2678400 < $args) {// 31 days past
    $format = "{t}m/d/Y g:i a{/t}";
  } else {
	
  }
  return _modify_mydate($format,$args);
}

function modify_shortdatetimeformat($args) {
  if ($args<1) return "";
  $time_arr = getdate();
  $format = "{t}m/d/Y g:i a{/t}";
  $args_arr = getdate($args);
  if (($args_arr["hours"]==0 and $args_arr["minutes"]==0) or ($args_arr["hours"]==23 and $args_arr["minutes"]==59)) {
    $format = "{t}m/d/Y{/t}";
  } else {
    $midnight = mktime(0,0,0,$time_arr["mon"],$time_arr["mday"],$time_arr["year"]);
    if ($midnight + 2678400 < $args) { // more than 31 days future
      $format = "{t}m/d/Y g:i a{/t}";
    } else if ($midnight + 86400 < $args) { // more than 1 day future
      $format = "{t}M j, g:i a{/t}";
    } else if ($midnight < $args) { // today
      $format = "{t}g:i a{/t}";
    } elseif ($midnight - 518400 < $args) {// 6 days past
      $format = "{t}M j, g:i a{/t}";
    }
  }
  return _modify_mydate($format,$args);
}

function modify_filesize($bytes) {
  $precision = 0;
  $names = '';
  $addon = "";
  if (!is_numeric($bytes) and file_exists($bytes) and !strpos($bytes,"://"))  $bytes = filesize($bytes);
  if (!is_numeric($bytes)) return "";
  if ($bytes < 0) {
    $addon = "-";
	$bytes *= -1;
  }
  for ($level = 0; $bytes >= 1024; $level++) $bytes /= 1024;
  switch ($level) {
    case 0: $suffix = (strlen($names)>0) ? $names[0] : "B"; break;
    case 1: $suffix = (strlen($names)>1) ? $names[1] : "KB"; break;
    case 2: $suffix = (strlen($names)>2) ? $names[2] : "MB"; break;
    case 3: $suffix = (strlen($names)>3) ? $names[3] : "GB"; break;
    case 4: $suffix = (strlen($names)>4) ? $names[4] : "TB"; break;
    default: $suffix = (isset($names[$level])) ? $names[$level] : ""; break;
  }
  if (empty($suffix)) "";
  return $addon.round($bytes, $precision)." ".$suffix;
}

function modify_duration($val) {
  $steps = array(60,60,24,30);
  $units = array("","{t}min{/t}","{t}hours{/t}","{t}days{/t}","{t}months{/t}");
  $val2 = $val;
  for ($level = 0; $val2 >= 10 && $level < 4; $level++) $val2 /= $steps[$level];
  return round($val2,1)." ".$units[$level];
}

function modify_transfileperm($in_Perms) {
  if ($in_Perms=="") return "";
  $sP = "";
  if(($in_Perms & 0xC000) == 0xC000) $sP = "s"; // Socket
    elseif(($in_Perms & 0xA000) == 0xA000) $sP = "l"; // Symbolic Link
    elseif(($in_Perms & 0x8000) == 0x8000) $sP = "-"; // Regular
    elseif(($in_Perms & 0x6000) == 0x6000) $sP = "b"; // Block special
    elseif(($in_Perms & 0x4000) == 0x4000) $sP = "d"; // Directory
    elseif(($in_Perms & 0x2000) == 0x2000) $sP = "c"; // Character special
    elseif(($in_Perms & 0x1000) == 0x1000) $sP = "p"; // FIFO pipe
    else $sP = "u"; // UNKNOWN
   // owner
   $sP .= (($in_Perms & 0x0100) ? "r" : "-").(($in_Perms & 0x0080) ? "w" : "-").
          (($in_Perms & 0x0040) ? (($in_Perms & 0x0800) ? "s" : "x"):(($in_Perms & 0x0800) ? "S" : "-"));
   // group
   $sP .= (($in_Perms & 0x0020) ? "r" : "-").(($in_Perms & 0x0010) ? "w" : "-").
          (($in_Perms & 0x0008) ? (($in_Perms & 0x0400) ? "s" : "x" ):(($in_Perms & 0x0400) ? "S" : "-"));
   // world
   $sP .= (($in_Perms & 0x0004) ? "r" : "-").(($in_Perms & 0x0002) ? "w" : "-").
          (($in_Perms & 0x0001) ? (($in_Perms & 0x0200) ? "t" : "x" ):(($in_Perms & 0x0200) ? "T" : "-"));
   return $sP;
}

function modify_urldecode($str) {
  return rawurldecode($str);
}

function modify_getfileext($filename) {
  if ($filename=="" or !strpos("@".$filename,".")) return $filename;
  $filename = str_replace("\\","/",basename($filename));
  return strtolower(substr($filename,-strpos(strrev($filename),'.')));
}

function modify_basename($filename) {
  if (strpos($filename,"|")) {
    $filename = explode("|",$filename);
    foreach (array_keys($filename) as $key) $filename[$key] = modify_basename($filename[$key]);
	$filename = implode("|",$filename);
  } else {
    $filename = basename($filename);
    if (preg_match("/[0-9abcdef]+?--/",$filename)) {
      $filename = urldecode(substr($filename,strpos($filename,"--")+2));
    }
  }
  return $filename;
}

function modify_realfilename($filename) {
  $result = str_replace("\\","/",realpath(dirname($filename)))."/".basename($filename);
  if (strpos("@".PHP_OS,"WIN") and strpos($result," ")) $result = "\"".$result."\"";
  return $result;
}

function modify_preview_bin($filename,$ext) {
  if (!function_exists("proc_open")) return "ERROR {t}Cannot call 'proc_open'. Please remove 'proc_open' from 'disable_functions' in php.ini and disable 'safe_mode'.{/t}";
  $result = "";
  switch ($ext) {
    case "zip":
	  $src = modify_realfilename($filename);
	  $bin = sys_find_bin("unzip");
	  if ($bin=="") return sprintf("ERROR {t}unable to find %s{/t}","unzip");
	  $result = sys_exec($bin." -l -V ".$src);
	  break;
	case "tar":
	  $src = modify_realfilename($filename);
	  $bin = sys_find_bin("tar");
	  if ($bin=="") return sprintf("ERROR {t}unable to find %s{/t}","tar");
	  $result = sys_exec($bin." -tf ".$src);
	  break;
	case "gz":
	case "tgz":
	  $src = modify_realfilename($filename);
	  $bin = sys_find_bin("gzip");
	  if ($bin=="") return sprintf("ERROR {t}unable to find %s{/t}","gzip");
	  $bin2 = sys_find_bin("tar");
	  if ($bin2=="") return sprintf("ERROR {t}unable to find %s{/t}","tar");
	  $result = sys_exec($bin." -cd ".$src." | ".$bin2." -t");
	  break;
	case "ppt":
	  $src = modify_realfilename($filename);
	  $bin = sys_find_bin("ppthtml");
	  if ($bin=="") return sprintf("ERROR {t}unable to find %s{/t}","ppthtml");
	  $result = sys_exec($bin." ".$src);
	  if ($pos = strpos($result,"<BODY")) $result = substr($result,$pos);
	  $result = utf8_decode(strip_tags($result));
	  break;
	case "doc":
	  $src = modify_realfilename($filename);
	  $bin = sys_find_bin("catdoc");
	  if ($bin=="") return sprintf("ERROR {t}unable to find %s{/t}","catdoc");
	  $result = sys_exec($bin." -d cp1252 ".$src);
	  /*
	    $bin = sys_find_bin("wvware");
	    if ($bin=="") return sprintf("ERROR {t}unable to find %s{/t}","wvware");
		$config = modify_realfilename("tools/wv_win32/wvHtml.xml");
		$result = sys_exec($bin." --nographics --config ".$config." ".$src);
		$result = "<div style='padding:6px; background-color:#FFFFFF'>".$result."</div>";
	  */
	  break;
	case "xls":
	  $src = modify_realfilename($filename);
	  $bin = sys_find_bin("xls2csv");
	  if ($bin=="") return sprintf("ERROR {t}unable to find %s{/t}","xls2csv");
	  $result = sys_exec($bin." -d cp1252 ".$src);
  	  /*
	    $bin = sys_find_bin("xlhtml");
	    if ($bin=="") return sprintf("ERROR {t}unable to find %s{/t}","xlhtml");
		$result = sys_exec($bin." -nh ".$src);
	  */
	  break;
	case "ods": // oo-xls
	case "sxc":
	case "odt": // oo-doc
	case "sxw":
	case "odp": // oo-ppt
	case "sxi":
	  $src = modify_realfilename($filename);
	  $bin = sys_find_bin("unzip");
	  if ($bin=="") return sprintf("ERROR {t}unable to find %s{/t}","unzip");
	  $result = sys_exec($bin." -p ".$src." content.xml");
	  $result = utf8_decode(strip_tags(str_replace(array(">","</text:p>"),array("> ","\n"),$result)));
	  break;
	case "pdf":
	  $src = modify_realfilename($filename);
	  $bin = sys_find_bin("pdfinfo");
	  if ($bin=="") return sprintf("ERROR {t}unable to find %s{/t}","pdfinfo");
	  $result = sys_exec($bin." ".$src);
	  $bin = sys_find_bin("pdftotext");
	  if ($bin=="") return sprintf("ERROR {t}unable to find %s{/t}","pdftotext");
	  $result .= sys_exec($bin." ".$src." @file@");
	  break;
	case "jpg":
	  require_once("lib/exif/exif.inc.php");
	  $er = new phpExifRW($filename);
      $er->processFile();
	  $er->showImageInfo();
	  $result = $er->debug_str;
	  break;
  }
  return $result;
}

function modify_previewfile($file,$arr,$data) {
  if (strpos($file,"_text.txt") or strpos($file,"_html.txt")) return "";
  $result = modify_displayfile($file,filesize($file),"file_get_contents",false);
  if ($result!="") $result = "<br><br>".$result."<br>";
  return $result;
}

function modify_previewlink($file,$arr,$data) {
  $target = SIMPLE_CACHE."/preview/".sha1($file)."--".modify_basename($file);
  $ext = modify_getfileext($file);
  if (!file_exists($target)) copy($file,$target);
  if ($ext=="ics") $type = "icalendar";
  if ($ext=="vcf") $type = "vcard";
  return "index.php?preview=1&markdate=all&folder=".$type.":/".$target;
}

function modify_displayfile($filename,$size=0,$func="file_get_contents",$check_folder=true,$index=false) {
  $ext = modify_getfileext($filename);
  $txt_files = array(
    "ldif","log","css","csv","eml","rfc822","ini","reg","tsv","txt","htm","html","ics","vcf"
  );
  $code_files = array(
    "bas","bat","c","cmd","cpp","csh","inf","sh","vb","vbe","xml",
	"java","js","pas","php","pl","vbs","vcs","wsh","tpl","sql"
  );
  $bin_files = array("doc","xls","ppt","tar","zip","gz","tgz","pdf","odt","sxw","ods","sxc","odp","sxi","jpg","tif");
  if ($check_folder) {
    $checkdir = validate_allowedpath(dirname($filename));
    if ($checkdir!="") return $checkdir;
  }
  $return = "";
  $cid = "displayfile_".sha1($func.$filename.$size.($func=="file_get_contents"?filemtime($filename):""));
  if ($return = sys_cache_get($cid,FILE_TEXT_CACHE)) return $return;

  $type = "";
  if (in_array($ext,$txt_files)) $type = "text";
    else if (in_array($ext,$code_files)) $type = "code";
    else if (in_array($ext,$bin_files)) $type = "bin";

  if ($type!="") {
	if ($type=="bin") {
	  $return = trim(modify_preview_bin($filename,$ext));
	} else $return = trim($func($filename));
	
	if ($index) $limit = INDEX_LIMIT; else $limit = FILE_TEXT_LIMIT;
	if (strlen($return)>$limit) $return = substr($return,0,$limit)." ...";

	if (!strpos("@".$return,chr(159))) $return = utf8_encode($return);
	if (!$index) {
	  if ($type!="code") {
	    $return = nl2br(htmlspecialchars($return));
	  } else $return = modify_highlight_string($return);
	}
  }
  if ($return!="") {
	if (!sys_strbegins($return,"ERROR ")) {
	  sys_cache_set($cid,$return);
	} else if ($index) return "";
	return $return;
  }
  if ($index) return "";
  return sprintf("{t}Cannot create preview for %s{/t}",$ext);
}

function modify_iframe_file($filename) {
  $ext = modify_getfileext($filename);
  $files = array("ics","vcf");
  if (in_array($ext,$files)) return true;
  return false;
}

function modify_spreadsheet_file($filename) {
  $ext = modify_getfileext($filename);
  $files = array("csv","xls");
  if (in_array($ext,$files)) return true;
  return false;
}

function modify_image_file($filename) {
  $ext = modify_getfileext($filename);
  $img_files = array(
    "gif","jpg","jpeg","png",
    "bmp","emf","eps","ico","pcd","pcx","psd","svg","tif","tiff","wmf","xpm"
  );
  if (in_array($ext,$img_files)) return true;
  return false;
}

function modify_exif_file($filename) {
  $ext = modify_getfileext($filename);
  $img_files = array("jpg","jpeg");
  if (in_array($ext,$img_files)) return true;
  return false;
}

function modify_htmlquote($string) {
  return htmlspecialchars($string, ENT_QUOTES);
}

function modify_htmlunquote($string) {
  return html_entity_decode($string,ENT_QUOTES);
}

function modify_replacebr($str) {
  return str_replace("&lt;br&gt;","<br>",$str);
}

function modify_addtranssid_quote($var) {
  $var = preg_replace("/\{\\\$(.*?)\}/","{\$\\1|modify_htmlquote}",$var);
  $from = array(".php?","_php","|modify_replacebr|modify_htmlquote","|modify_htmlfield|modify_htmlquote","|modify_nl2br|modify_htmlquote");
  $to = array(".php?{\$urladdon}&",".php","|modify_htmlquote|modify_replacebr","|modify_htmlfield","|modify_htmlquote|modify_nl2br");
  $var = str_replace($from,$to,$var);
  return $var;
}

function modify_strip_ntdomain($username) {
  return preg_replace("~.*?\\\\(.*?)~si","\\1",strtolower($username));
}
/*
function modify_quotehtml($html) {
  if (!is_array($html)) {
	return str_replace("?","&#63",htmlspecialchars(str_replace("&#63","?",html_entity_decode($html,ENT_QUOTES)),ENT_QUOTES));
  } else {
    return $html;
  }
}

function modify_contentfield($html) {
  if (!is_array($html)) {
    if ($html=="") return "";
	return html_entity_decode($html,ENT_QUOTES);
  } else {
    return $html;
  }
}

function modify_quotehtml($html) {
  if (!is_array($html) and $html!="") {
	return htmlspecialchars(html_entity_decode($html,ENT_QUOTES),ENT_QUOTES);
  } else {
    return $html;
  }
}
*/

function modify_bookmark($val) {
  if ($pos = strpos($val,"?")) $val = substr($val,0,$pos);
  if (strpos($val,$_SERVER["SERVER_NAME"]) or strpos($val,$_SERVER["HTTP_HOST"]) or !strpos($val,"://")) return true;
  return false;
}

function ______S_E_L_E_C_T______() {}

function select_tables() {
  $result = array();
  $handle=opendir("modules/schema/");
  while (($file = readdir($handle))) {
    if (strpos($file,".xml")) {
	  $value = str_replace(".xml","",$file);
	  $result[$value] = $value;
	}
  }
  closedir($handle);
  ksort($result);
  return implode("|",$result);
}

function select_tables_all() {
  $result = array();
  $handle=opendir("modules/schema/");
  while (($file = readdir($handle))) {
    if (strpos($file,".xml")) {
	  $value = str_replace(".xml","",$file);
	  $result[$value] = $value;
	}
  }
  closedir($handle);
  ksort($result);

  $result2 = array();
  $handle=opendir("modules/schema_sys/");
  while (($file = readdir($handle))) {
    if (strpos($file,".xml")) {
	  $value = "sys_".str_replace(".xml","",$file);
	  $result2[$value] = $value;
	}
  }
  closedir($handle);
  ksort($result2);
  
  return implode("|",array_merge($result,$result2));
}

function select_dbselect($params,$search="") {
  $result = "";
  if (count($params)>=4) {
	$vars = array("search" => "%".$search."%", "username"=>$_SESSION["username"]);
    if (!is_array($params[1])) $params[1] = explode(",",$params[1]);
	if (!is_array($params[2])) {
	  if ($params[2]=="") $params[2] = array(); else $params[2] = array($params[2]);
	}
	if (isset($params[4])) $count = db_get_count($params[0],$params[2],$vars);
	if (!isset($params[4]) or $count <= $params[4]) {
	  $params[1][] = "folder";
	  foreach ($params[1] as $key=>$param) $params[1][$key] = sql_concat($param);
	  if (!isset($params[4])) $params[4] = 100;
      $rows = db_select($params[0],array_unique($params[1]),$params[2],$params[3],$params[4],$vars);
      if (is_array($rows) and count($rows)>0) {
	    $rights = array();
        foreach ($rows as $row) {
		  if (empty($rights[$row["folder"]])) $rights[$row["folder"]] = db_get_rights($row["folder"],"","read");
	      if ($rights[$row["folder"]]) {
		    if ($result!="") $result .= "|";
			$data = array_shift($row);
			if ($params[1][0]==$params[1][1]) $data2 = $data; else $data2 = array_shift($row);
			if (trim($data2)=="") $data2 = $data;
			if (strlen($data2)>30) $data2 = substr($data2,0,30)."...";
			if ($data!=$data2) {
			  if (strlen($data)<20) $data2 .= " (".$data.")"; else $data2 .= " (".substr($data,0,20)."...)";
			}
		    $result .= $data."_##_".$data2;
		  }
		}
      }
	} else {
	  unset($params[4]);
	  $params[2][] = $params[1][0]." like @search@";
	  $data = array("dbselect",$params);
	  $ticket = "custom_".count($_SESSION["form_data"]);
	  $_SESSION["form_data"][$ticket] = $data;
	  $result = "_overload_|ticket_##_".$ticket."|module_##_".$params[0];
	}
  }
  return $result;
}

function modify_dbselect($params) {
  return select_dbselect($params);
}

function modify_calendar_repeat($params,$params2,$data) {
  if (empty($data["recurrence"]["data"][0])) return "";
  return $params;
}

function ______V_A_L_I_D_A_T_E______() {}

function validate_fileupload($filename,$params) {
  $exts = explode(",",$params[0]);
  $filename = explode("|",$filename);
  foreach ($filename as $file) {
    $file = strtolower($file);
    $ext = modify_getfileext($file);
    if (!in_array($ext,$exts)) return sprintf("validate_fileupload: {t}Filename must have the right extension. Valid extensions are %s{/t}",$params[0]);
  }
  return "";
}

function validate_checkvirus($files) {
  if (VIRUS_SCANNER=="") return "";
  $files = explode("|",$files);
  foreach ($files as $file) {
	$src = modify_realfilename($file);
	$bin = modify_realfilename(VIRUS_SCANNER);
	if ($bin=="") return sprintf("validate_checkvirus {t}unable to find %s{/t}",VIRUS_SCANNER);
	$result = sys_exec($bin." ".VIRUS_SCANNER_PARAMS." ".$src);
	if ($result!="") {
	  if (VIRUS_SCANNER_DISPLAY and preg_match("|".preg_quote(VIRUS_SCANNER_DISPLAY)."(.*?)\n|i",$result,$match)) {
	    $result = trim($match[1]);
	  }
	  return "validate_checkvirus: ".$result;
	}
  }
  return "";
}

function validate_allowedpath($dir) {
  if (strpos($dir,"://") or $dir=="http:") return "";
  if (!is_dir($dir) or $dir=="/") return "{t}directory does not exist.{/t}";
  if (is_numeric($dir)) return "{t}db-folder{/t}";
  $path_filename = rtrim(strtolower(str_replace("\\","/",realpath($dir))),"/")."/";
  $found = false;
  if (!empty($_SESSION["ALLOWED_PATH"])) {
    foreach ($_SESSION["ALLOWED_PATH"] as $path) {
      $path = rtrim(strtolower(str_replace("\\","/",realpath($dir))),"/")."/";
      if (sys_strbegins($path_filename,$path)) $found = true;
    }
  }
  if ($found) {
    return "";
  } else {
    $GLOBALS["t"]["notification"][] = sprintf("{t}Directory is outside the allowed directory. (%s is outside %s){/t}",$path_filename,implode(", ",$_SESSION["ALLOWED_PATH"]));
	return "{t}wrong directory{/t}";
  }
}

function validate_username($username) {
  if (defined("SETUP_ADMIN_USER") and $username==SETUP_ADMIN_USER) return "validate_username: {t}Username must be different from the super administrator.{/t}";
  if (strlen($username)<21 and strlen($username)>2 and preg_match('/^[a-z0-9_]*$/', $username)) return "";
  return "validate_username: {t}Username must be not null, lowercase, min 3 characters, max 20 containing [a-z0-9_].{/t}";
}

function validate_groupname($groupname) {
  if (strlen($groupname)<21 and strlen($groupname)>2 and preg_match('/^[a-z0-9_]*$/', $groupname)) return "";
  return "validate_groupname: {t}Name must be not null, lowercase, min 3 characters, max 20 containing [a-z0-9_].{/t}";
}

function validate_password($password) {
  if (strlen($password)>4) return "";
  return "validate_password: {t}Password must be not null, min 5 characters.{/t}";
}

function validate_email($email) {
  if (strlen($email)>5 and preg_match("/^[\S]+@[\S]+\.[\S]+$/si", $email)) return "";
  return "validate_email: {t}Please input a valid e-mail adress.{/t}";
}

function validate_url($url) {
  if (strlen($url)>6 and (preg_match("!^(http|www)[\S]+!i",$url) or sys_strbegins($url,"index.php?"))) return "";
  return "validate_url: {t}Please enter a valid url.{/t}";
}

function validate_numeric($var) {
  if (is_numeric($var) and $var>0) return "";
  return "validate_numeric: {t}Variable must be of type int and greater than 0.{/t}";
}

function validate_integer($var) {
  if (is_numeric($var) and ceil($var)==$var) return "";
  return "validate_integer: {t}Variable must be of type int.{/t}";
}

function validate_float($var) {
  if (is_numeric($var)) return "";
  return "validate_float: {t}Variable must be of type float.{/t}";
}

function validate_date($var) {
  $var = modify_date_translate($var);
  if (preg_match("|[0-9]{1,2}/[0-9]{1,2}/[0-9]{2,4}|",$var) and strtotime($var)!=-1) return "";
  return "validate_date: {t}Variable must be of type date (mm/dd/yyyy).{/t}";
}

function validate_time($var) {
  $regs = "";
  if ((strlen($var)<=5 and preg_match("|([0-9]{1,2}):([0-9]{2})|",$var,$regs)) or (strlen($var)>=7 and preg_match("/([0-9]{1,2}):([0-9]{2}) (am|pm)/i",$var,$regs))) {
    $hour = $regs[1];
	$minute = $regs[2];
	if (((strlen($var)<=5 and $hour<24 and $hour>=0) or (strlen($var)>=7 and $hour<=12 and $hour>0)) and $minute>=0 and $minute<=59) return "";
  }
  return "validate_time: {t}Variable must be of type time (hh:mm am/pm).{/t}";
}

function validate_datetime($var) {
  $regs = "";
  $var = modify_date_translate($var);
  if (preg_match("![0-9]{1,2}/[0-9]{1,2}/[0-9]{2,4} [0-9]{1,2}:[0-9]{2} (am|pm)!i",$var) and strtotime($var)!=-1) return "";
  if (preg_match("|[0-9]{1,2}/[0-9]{1,2}/[0-9]{2,4} [0-9]{1,2}:[0-9]{2}|",$var) and strtotime($var)!=-1) return "";
  return "validate_datetime: {t}Variable must be of type datetime (mm/dd/yyyy hh:mm am/pm).{/t}";
}

function validate_itemexists($table,$field,$value,$id) {
  if (strpos($table,"sys_nosql_")) return "";
  $found = false;
  $rows = db_select($table,array("id","folder"),array($field."=@".$field."@","id!=@id@"),"","",array($field=>$value,"id"=>$id));
  if (is_array($rows) and count($rows)>0) {
    foreach ($rows as $row) {
	  if (!folder_in_trash($row["folder"])) {
	    $found = true;
	    break;
	  }
	}
  }
  if (!$found) return "";  
  return sprintf("validate_itemexists: {t}Variable already exists in table. (%s.%s=%s){/t}",$table,$field,$value);
}

// Copyright (c) 2002-2003 Richard Heyes
// Copyright (c) 2003-2005 The PHP Group
function modify_decode_subject($input) {
  $i = 0;
  if ($input!="" and strpos("@".$input,"=?")) {
    $input = preg_replace('/(=\?[^?]+\?(q|b)\?[^?]*\?=)(\s)+=\?/i', '\1=?', $input);
	$charset = "";
   	while (preg_match('/(=\?([^?]+)\?(q|b)\?([^?]*)\?=)/i', $input, $matches)) {
      $text = $matches[4];
	  $charset = strtolower($matches[2]);
      switch (strtolower($matches[3])) { // encoding
   	    case "b": $text = base64_decode($text); break;
   	    case "q":
          $text = str_replace("_"," ",$text);
       	  preg_match_all("/=([a-f0-9]{2})/i",$text,$matches2);
 	      foreach ($matches2[1] as $value) $text = str_replace('='.$value, chr(hexdec($value)), $text);
          break;
   	  }
      $input = str_replace($matches[1],$text,$input);
	  if ($i>4) break;
	  $i++;
    }
	if ($i>0 and strpos("@".$charset,"iso") and $charset!="utf-8") $input = utf8_encode($input);
  }
  if ($i==0 and $input!="") $input = utf8_encode($input);
  return $input;
}
?>