<?php
	/**************************************************************************\
	* Simple Groupware 0.241                                                   *
	* http://www.simple-groupware.de                                           *
	* Copyright (C) 2002-2006 by Thomas Bley                                   *
	* ------------------------------------------------------------------------ *
	*  This program is free software; you can redistribute it and/or           *
	*  modify it under the terms of the GNU General Public License Version 2   *
	*  as published by the Free Software Foundation; only version 2            *
	*  of the License, no later version.                                       *
	*                                                                          *
	*  This program is distributed in the hope that it will be useful,         *
	*  but WITHOUT ANY WARRANTY; without even the implied warranty of          *
	*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the            *
	*  GNU General Public License for more details.                            *
	*                                                                          *
	*  You should have received a copy of the GNU General Public License       *
	*  Version 2 along with this program; if not, write to the Free Software   *
	*  Foundation, Inc., 59 Temple Place - Suite 330, Boston,                  *
	*  MA  02111-1307, USA.                                                    *
	\**************************************************************************/

if (!defined("MAIN_SCRIPT")) exit;

define("CORE_VERSION","0_241");
define("CORE_VERSION_STRING","0.241");
define("CORE_SGSML_VERSION","1_45");
define("SIMPLE_CACHE","../simple_cache");

$GLOBALS["time"] = time();
define("DEBUG",true);
define("DEBUG_SQL",false);
define("DEBUG_SQL_FULL",false);
define("CSV_CACHE",300);
define("INDEX_LIMIT",16384);
define("FILE_TEXT_CACHE",15552000);
$_SESSION["ALLOWED_PATH"] = array("../import/");

$core_output_cache = !DEBUG;
$core_compress_output = !DEBUG;

if (strpos("@".PHP_OS,"WIN")) $sep = ";"; else $sep = ":";
$include_path = explode($sep,ini_get("include_path"));
if (!in_array(".",$include_path)) {
  setup_error(sprintf("{t}Please modify your php.ini or add an .htaccess file changing the setting '%s' to '%s' (current value is '%s') !{/t}","include_path",".".$sep.implode($include_path),ini_get("include_path")));
  display_setup_errors(false);
  exit;
}

include "core/functions.php";
include "core/functions_user.php";
include "core/functions_trigger.php";
include "core/functions_xml.php";

if (DEBUG) debug_capture();
$GLOBALS["setup_errors"] = array();

$extensions = array("xml", "gd", "pcre", "session", "zlib");

$db_extensions = array("MySQL"=>"mysql", "PostgreSQL"=>"pgsql", "Oracle"=>"oci8");

$GLOBALS["db_min_version"]["mysql"] = "4.0.0";
$GLOBALS["db_min_version"]["pgsql"] = "8.1.0";
$GLOBALS["db_min_version"]["oci8"] = "92";

$settings = array("display_errors" => 1, "safe_mode" => 0, "register_globals" => 0, "zlib.output_compression" => 0, "session.auto_start" => 0, "session.use_trans_sid" => 0, "magic_quotes_runtime" => 0, "file_uploads" => 1);

$phpversion = 433;
$phpversion_str = "4.3.3";
$sys_phpversion = (int)str_replace(".","",substr(PHP_VERSION,0,6));
if ($sys_phpversion>999) $phpversion = 4303;
$memorylimit = 16000000;

if (!empty($_SERVER["SERVER_SOFTWARE"]) and !strpos("@".$_SERVER["SERVER_SOFTWARE"],"Apache") and !strpos($_SERVER["SERVER_SOFTWARE"],"nanoweb")) {
  setup_error("{t}Please choose Apache as Web-Server.{/t} (".$_SERVER["SERVER_SOFTWARE"].")");
}
if ($sys_phpversion < $phpversion) setup_error(sprintf("{t}Setup needs php with at least version %s !{/t}",$phpversion_str));

$memory = ini_get("memory_limit");
if (!empty($memory)) {
  $memory = (int)str_replace("m","000000",strtolower($memory));
  if ($memory < $memorylimit) setup_error(sprintf("{t}Please modify your php.ini or add an .htaccess file changing the setting '%s' to '%s' (current value is '%s') !{/t}","memory_limit",str_replace("000000","M",$memorylimit),ini_get("memory_limit")));
}

$GLOBALS["extensions2"] = get_loaded_extensions();
foreach($extensions as $key => $key2) if (!in_array($key2, $GLOBALS["extensions2"])) setup_error(sprintf("{t}Setup needs php-extension with name %s !{/t}",$key2));

$GLOBALS["databases"] = array();
foreach($db_extensions as $key => $key2) if (in_array($key2, $GLOBALS["extensions2"])) $GLOBALS["databases"][$key] = $key2;
if (count($GLOBALS["databases"])==0) setup_error(sprintf("{t}Setup needs a database-php-extension ! (%s){/t}",implode(", ",$db_extensions)));

foreach($settings as $setting => $value) if (!ini_get($setting) == $value) setup_error(sprintf("{t}Please modify your php.ini or add an .htaccess file changing the setting '%s' to '%s' (current value is '%s') !{/t}",$setting,$value,ini_get($setting)));

if (!isset($_SERVER["SERVER_ADDR"]) or $_SERVER["SERVER_ADDR"]=="") $_SERVER["SERVER_ADDR"]="127.0.0.1";

clearstatcache();
if (!is_writable(SIMPLE_CACHE."/") or !is_writable(SIMPLE_STORE."/")) setup_error(sprintf("{t}Please give write access to %s and %s{/t}",SIMPLE_CACHE."/",SIMPLE_STORE."/"));

if (count($GLOBALS["setup_errors"])>0) {
  display_setup_errors(false);
} else {
  $lang_dir = "lang/";
  if (!is_dir($lang_dir)) $lang_dir = "../lang/";
  header("Content-Type: text/html; charset=utf-8");
  if (DEBUG and !isset($_REQUEST["install"]) and !isset($_REQUEST["lang"])) {
	echo "
	  <html><head><title>Simple Groupware</title>
	  <meta http-equiv='Content-Type' content='text/html; charset=utf-8'/>
	  </head><body><center>
	  <h2>Simple Groupware</h2><hr>
	  <a href='index.php?lang=en'>English</a><br><br>
	";
    $handle=opendir($lang_dir);
    while (($file = readdir($handle))) {
      if ($file!="." and $file!=".." and $file!="master.lang" and strpos($file,".lang")>0) {
		preg_match("|{t}!_Language{/t}\n(.*?)\n|",file_get_contents($lang_dir.$file),$regs);
		if (!empty($regs[1])) $lang_str = $regs[1]; else $lang_str = "unknown (".$file.")";
	    echo "<a href='index.php?lang=".str_replace(".lang","",$file)."'>".$lang_str."</a><br><br>";
	  }
	}
	echo "
	  <a href='index.php?lang=dev'>Developer</a><hr>
	  <a href='http://www.simple-groupware.de/cms/index.php?n=Main.Installation' target='_blank'>Installation manual</a> / 
	  <a href='http://www.simple-groupware.de/cms/index.php?n=Main.Update' target='_blank'>Update manual</a><hr>
	  <a href='http://www.simple-groupware.de/cms/index.php?n=Main.Documentation' target='_blank'>Documentation</a> / 
	  <a href='http://www.simple-groupware.de/cms/index.php?n=Main.FAQ' target='_blank'>FAQ</a><hr>
	  </center></body></html>";
	exit;
  }
  if (DEBUG and !isset($_REQUEST["install"]) and $_REQUEST["lang"]!="dev") {
    header("Content-Type: text/html; charset=utf-8");
	echo "Building translations:<br><br>\n";
    build_trans($lang_dir.basename($_REQUEST["lang"]).".lang","./","../bin/");
	echo '<a href="../bin/index.php">Continue</a>';
	exit;
  } else {
    dirs_create_default_folders();
    if (isset($_REQUEST["install"]) and isset($_REQUEST["accept_gpl"]) and $_REQUEST["accept_gpl"]=="yes") {
      install();
    } else {
      show_form();
    }
  }
}

function show_form() {
  ob_start();
  header("Content-Type: text/html; charset=utf-8");
  echo '
    <html>
    <head>
	<title>Simple Groupware</title>
	<style>
		body, h2, img, div, table#data,a {
		  background-color: #FFFFFF; color: #666666; font-size: 13px; font-family: Arial, Helvetica, Verdana, sans-serif;
		}
		a,input,select { color: #0000FF; }
		input {
		  font-size: 11px; background-color: #F5F5F5; border: 1px solid #AAAAAA; height: 18px;
		  vertical-align: middle; padding-left: 5px; padding-right: 5px; -moz-border-radius:10px;
		}
		select { font-size: 11px; background-color: #F5F5F5; border: 1px solid #AAAAAA;	}
		input:focus { border: 1px solid #FF0000; }
		.checkbox,.radio { border: 0px; background-color: transparent; }
		.submit { color: #0000FF; background-color: #FFFFFF; width: 230px; font-weight: bold; }
		table#data td,table#data td#data { padding-left: 5px; padding-right: 5px; }
		table#data tr#fields td { color: #FFFFFF; background-color: #B6BDD2; padding: 2px; }

	</style>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
	<script>
	function opacity() {
	  var timer=0;
	  for(i=0; i<100; i++) {
	    setTimeout("changeOpac(" + i + ",\'sgs_logo\')",(timer * 15));
	    timer++;
	  }
	}
	
	function activate() {
	  document.getElementById("sgs_logo").style.display="none";
	  document.getElementById("setup").style.display="";
	}

	function changeOpac(opacity, id) {
	  var object = document.getElementById(id).style;
	  object.opacity = (opacity / 100);
	  object.filter = "alpha(opacity=" + opacity + ")";
	}
	</script>
    </head>
    <body onload="'.((empty($_REQUEST["install"]))?'opacity();setTimeout(\'activate()\',3500);':'activate();').'">

    <div id="sgs_logo" style="'.(!empty($_REQUEST["install"])?"display:none;":"").'width: 100%; height: 98%; background-color: #FFFFFF; opacity: 0; filter:alpha(opacity=0);" onclick="activate();">
    <table width="100%" height="90%"><tr><td align="center">
      <table><tr><td align="right">
      <table style="border: 1px solid #AAAAAA" width="480" height="260">
	    <tr><td align="center" valign="middle">
  	      <img src="ext/sgs_logo_setup.jpg" alt="" width="424" height="222" border="0">
	    </td></tr>
      </table>
      </td></tr></table>
    </td></tr></table>
    </div>
    <div id="setup" style="display:none;">
    <div style="border-bottom: 1px solid black; letter-spacing: 2px; font-size: 18px; font-weight: bold;">Simple Groupware '.CORE_VERSION_STRING.'</div>
    <br>
	<form action="index.php" method="post">
	<input type="hidden" value="{t}en{/t}" name="language">
	<table id="data">
	<tr>
	  <td><label for="db_host">{t}Database Hostname / IP{/t}</label></td>
	  <td><input type="Text" value="localhost" size="30" maxlength="50" name="db_host" id="db_host"></td>
	</tr>
	<tr>
	  <td><label for="db_user">{t}Database User{/t}</label></td>
	  <td><input type="Text" value="root" size="30" maxlength="50" name="db_user" id="db_user"></td>
	</tr>
	<tr>
	  <td><label for="db_pw">{t}Database Password{/t}</label></td>
	  <td><input type="Text" value="" size="30" maxlength="50" name="db_pw" id="db_pw"></td>
	</tr>
	<tr>
	  <td><label for="db_name">{t}Database Name{/t}</label></td>
	  <td><input type="Text" value="sgs_'.CORE_VERSION.'" size="30" maxlength="50" name="db_name" id="db_name"></td>
	</tr>
	<tr>
	  <td><label for="db_type">{t}Database{/t}</label></td>
	  <td>
  ';
  if (count($GLOBALS["databases"])>1) {
    echo '<select name="db_type" id="db_type">';
    foreach ($GLOBALS["databases"] as $key=>$key2) echo '<option value="'.$key2.'"> '.$key;
    echo '</select>';
  }	else {
    foreach ($GLOBALS["databases"] as $key=>$key2) echo '<input type="hidden" name="db_type" value="'.$key2.'"> '.$key;
  }
  echo '
	  </td>
	</tr>
	<tr>
	  <td><label for="admin_user">{t}Admin Username{/t}</label></td>
	  <td><input type="text" value="admin" size="30" maxlength="50" name="admin_user" id="admin_user"></td>
	</tr>
	<tr>
	  <td><label for="admin_pw">{t}Admin Password{/t}</label></td>
	  <td><input type="text" value="admin" size="30" maxlength="50" name="admin_pw" id="admin_pw"></td>
	</tr>
	</table>
    <div style="border-bottom: 1px solid black;">&nbsp;</div>
	<h2>GNU GPL {t}License{/t} Version 2</h2>
	<h4>
	<a href="http://www.gnu.org/copyleft/gpl.html" target="_blank">{t}More information about the GNU GPL{/t}</a><br>
	<a href="http://www.gnu.org/licenses/translations.html" target="_blank">{t}Translations of the GNU GPL{/t}</a><br> 
	<a href="http://www.gnu.org/licenses/gpl-faq.html" target="_blank">{t}GNU GPL Frequently Asked Questions{/t}</a>
	<br>
	</h4>
	<font color="#ff0000">*** {t}To continue installing Simple Groupware you must check the box under the license{/t} ***</font><br><br>
	{t}Please read the following license agreement. Use the scroll bar to view the rest of this agreement.{/t}<br>

    <div style="border-bottom: 1px solid black;">&nbsp;</div>

	<pre>'.trim(file_get_contents("LICENSE.txt")).'</pre>

    <div style="border-bottom: 1px solid black;">&nbsp;</div>
	<br>
	<div style="border: 2px solid #FF0000; width: 50%;">&nbsp; <input onclick="if (this.checked) this.parentNode.style.border=\'2px solid #00A000\'; else this.parentNode.style.border=\'2px solid #FF0000\';" type="Checkbox" class="checkbox" name="accept_gpl" id="accept_gpl" value="yes" style="margin: 0px;"> <label for="accept_gpl">{t}I Accept the GNU GENERAL PUBLIC LICENSE VERSION 2{/t}</label></div>
	<br>
	<br>
	<input type="submit" name="install" value="{t}I n s t a l l{/t}" class="submit"><br>
	<br>
	</form>
    <div style="border-top: 1px solid black;">Powered by Simple Groupware, Copyright (C) 2002-2006 by Thomas Bley.</div>
	</div>
	</body></html>
  ';
  $out = ob_get_contents();
  ob_end_clean();
  echo sys_remove_trans($out);
}

function out($str) {
  echo sys_remove_trans($str);
  flush();
  @ob_flush();
}

function setup_error($msg) {
  $GLOBALS["setup_errors"][] = $msg;
}

function display_setup_errors($exit) {
  $msgs = $GLOBALS["setup_errors"];
  $output = '
    <center>
    <div style="border-bottom: 1px solid black; letter-spacing: 2px; font-size: 18px; font-weight: bold;">Simple Groupware Setup</div>
	<br>
	{t}Error{/t}<br>
	'.str_replace("\n","<br>",htmlspecialchars(implode("\n",$msgs))).'<br>
	<br>
	<a href="index.php">{t}Relaunch Setup{/t}</a><br><br>
	<hr>
	<a href="http://www.simple-groupware.de/cms/index.php?n=Main.Installation" target="_blank">Installation manual</a> / 
	<a href="http://www.simple-groupware.de/cms/index.php?n=Main.Update" target="_blank">Update manual</a><hr>
	<a href="http://www.simple-groupware.de/cms/index.php?n=Main.Documentation" target="_blank">Documentation</a> / 
	<a href="http://www.simple-groupware.de/cms/index.php?n=Main.FAQ" target="_blank">FAQ</a><hr>
	<br>
	</center>
  ';
  $output = str_replace(array("{t"."}","{"."/t}"),array("",""),$output);
  echo $output;
  if ($exit) exit();
  phpinfo();
}

function install() {
  header("Content-Type: text/html; charset=utf-8");
  echo '
    <html>
    <head>
	<title>Simple Groupware</title>
	<style>
		body, h2, img, div, table#data,a {
		  background-color: #FFFFFF; color: #666666; font-size: 13px; font-family: Arial, Helvetica, Verdana, sans-serif;
		}
		a,input { color: #0000FF; }
		input {
		  font-size: 11px; background-color: #F5F5F5; border: 1px solid #AAAAAA; height: 18px;
		  vertical-align: middle; padding-left: 5px; padding-right: 5px; -moz-border-radius:10px;
		}
		.submit { color: #0000FF; background-color: #FFFFFF; width: 230px; font-weight: bold; }
	</style>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    </head>
    <body>
    <div style="border-bottom: 1px solid black; letter-spacing: 2px; font-size: 18px; font-weight: bold;">Simple Groupware '.CORE_VERSION_STRING.'</div>
	<br>
  ';

  $_SESSION["serverid"] = 1;
  $_SESSION["username"] = "setup";
  @unlink(SIMPLE_STORE."/setup.txt");
  if ($validate=validate_username($_REQUEST["admin_user"]) and $validate!="") setup_error("{t}Admin Username{/t} - {t}validation failed{/t} ".$validate);
  if ($_REQUEST["db_host"]=="") setup_error(sprintf("{t}missing field{/t}: %s","{t}Database Hostname / IP{/t}"));
  if ($_REQUEST["db_user"]=="") setup_error(sprintf("{t}missing field{/t}: %s","{t}Database User{/t}"));
  if ($_REQUEST["db_name"]=="") setup_error(sprintf("{t}missing field{/t}: %s","{t}Database Name{/t}"));
  if ($_REQUEST["admin_pw"]=="") setup_error(sprintf("{t}missing field{/t}: %s","{t}Admin Password{/t}"));
  
  define("SETUP_DB_TYPE",$_REQUEST["db_type"]);

  if (!sql_connect($_REQUEST["db_host"], $_REQUEST["db_user"], $_REQUEST["db_pw"], $_REQUEST["db_name"])) {
    if (!sql_connect($_REQUEST["db_host"], $_REQUEST["db_user"], $_REQUEST["db_pw"])) setup_error("{t}Connection to database failed.{/t}\n".sql_error());
    @set_time_limit(30);
	if (!sql_create_database($_REQUEST["db_name"])) setup_error("{t}Creating database failed.{/t}\n".sql_error());
  }
  if (!sql_connect($_REQUEST["db_host"], $_REQUEST["db_user"], $_REQUEST["db_pw"], $_REQUEST["db_name"])) setup_error("{t}Connection to database failed.{/t}\n".sql_error());
  if (!isset($GLOBALS["DB"])) display_setup_errors(true);

  if (!$version = sql_version()) setup_error(sprintf("{t}Could not determine database-version.{/t}"));
  $database_version_min_int = (int)substr(str_replace(".","",$GLOBALS["db_min_version"][SETUP_DB_TYPE]),0,3);
  if ($version < $database_version_min_int) setup_error(sprintf("{t}Wrong database-version (%s). Please use at least %s !{/t}",$version,$GLOBALS["db_min_version"][SETUP_DB_TYPE]));

  @set_time_limit(10);

  if (SETUP_DB_TYPE=="pgsql") {
    if (!sql_query(file_get_contents("modules/core/pgsql.sql"))) setup_error("pgsql.sql: ".sql_error());
  }
  if (SETUP_DB_TYPE=="oci8") {
    $sqls = explode(";",file_get_contents("modules/core/oracle.sql"));
	foreach ($sqls as $sql) {
	  if (trim($sql)!="" and !sql_query($sql)) setup_error("oracle.sql: ".$sql." ".sql_error());
	}
  }
  
  out(sprintf("{t}Processing %s ...{/t}","schema updates")."<br>");

  // 0.219
  if (!sql_column_rename("simple_calendar","end","ending")) setup_error("rename[1]: ".sql_error());
  if (!sql_column_rename("simple_contactactivities","end","ending")) setup_error("rename[2]: ".sql_error());
  if (!sql_column_rename("simple_tasks","end","ending")) setup_error("rename[3]: ".sql_error());
  if (!sql_table_rename("simple_sys_chat","simple_sys_chat2")) setup_error("rename[4]: ".sql_error());

  // 0.220
  if (!sql_column_rename("simple_gallery","title","filename")) setup_error("rename[5]: ".sql_error());
  if (!sql_column_rename("simple_gallery","attachment","filedata")) setup_error("rename[6]: ".sql_error());

  if (count($GLOBALS["setup_errors"])>0) display_setup_errors(true);
  
  out(sprintf("{t}Processing %s ...{/t}","schema, search index")."<br>");

  if (sql_table_exists("simple_sys_search")) {
    db_delete("simple_sys_search",array(),array());
  }
  foreach (array("modules/schema/","modules/schema_sys/") as $dir) {
    $handle=opendir($dir);
    while (($file = readdir($handle))) {
      if (strpos($file,".xml")) {
	    out($file." ");
		$schema = db_get_schema($dir.$file);
		
		if (sys_strbegins($file,"nosql_")) continue;
		if (empty($schema["display"])) continue;
		if (!empty($schema["display"]["att"]["SQL_HANDLER"])) continue;
		if (!empty($schema["display"]["att"]["NO_SEARCH_INDEX"])) continue;
		
		$table = $schema["display"]["att"]["NAME"];
		$fields = $schema["display"]["fields"];
		$trashed = array();

		@set_time_limit(60);
		$rows = db_select($table,array("id","folder"),array(),"",array(),array());
	    if (is_array($rows) and count($rows)>0) {
		  out(" ... ");
		  foreach ($rows as $row) {
		    if (!isset($trashed[$row["folder"]])) $trashed[$row["folder"]] = folder_in_trash($row["folder"]);
			if (!$trashed[$row["folder"]]) {
			  @set_time_limit(15);
			  db_search_update($table,$row["id"],$fields,$row["folder"]);
			}
		  }
		}
	  }
    }
    closedir($handle);
  }
  out("<br>");

  // change System folder to administration menu, 0.220
  if (sql_table_exists("simple_sys_tree")) {
    db_update("simple_sys_tree",array("ftype"=>"sys_admin"),array("anchor=@anchor@"),array("anchor"=>"system"));
  }  
  
  out(sprintf("{t}Processing %s ...{/t}","sessions")."<br>");
  db_delete("simple_sys_session",array(),array());

  out(sprintf("{t}Processing %s ...{/t}","trigger_calcappointment")."<br>");
  $rows = db_select("simple_calendar",array("*"),array(),"",array(),array());
  if (count($rows)>0) {
    foreach ($rows as $row) trigger_calcappointment($row["id"],$row);
  }

  @set_time_limit(60);
  out(sprintf("{t}Processing %s ...{/t}","folder structure")."<br>");
  $sel_folder = db_select_first("simple_sys_tree",array("count(*) as count"),array(),"","",array());
  if ($sel_folder["count"]==0) folder_create_default_folders(file_get_contents("modules/core/folders.xml"),0,true);

  out(sprintf("{t}Processing %s ...{/t}","default groups")."<br>");
  $groups = array("admin_calendar","admin_news","admin_projects","admin_bookmarks","admin_contacts","admin_inventory","admin_organisation");
  foreach ($groups as $group) trigger_creategroup($group);

  $parent = db_select_first("simple_sys_tree",array("id"),array("anchor=@anchor@"),"lft asc","",array("anchor"=>"system"));
  if (!empty($parent["id"])) {
    $row = db_select_first("simple_sys_tree",array("id"),array("ftype=@ftype@"),"lft asc","",array("ftype"=>"sys_nosql_tablesizes"));
    if (empty($row["id"])) {
	  _folder_create("{t}Table sizes{/t}","sys_nosql_tablesizes",$parent["id"],false,array("nochecksys"=>true));
    }
    $row = db_select_first("simple_sys_tree",array("id"),array("ftype=@ftype@"),"lft asc","",array("ftype"=>"sys_nosql_backups"));
    if (empty($row["id"])) {
	  _folder_create("{t}Backups{/t}","sys_nosql_backups",$parent["id"],false,array("nochecksys"=>true));
    }
    $row = db_select_first("simple_sys_tree",array("id"),array("anchor=@anchor@"),"lft asc","",array("anchor"=>"trash"));
    if (empty($row["id"])) {
	  _folder_create("{t}Trash{/t}","blank",$parent["id"],false,array("nochecksys"=>true));
    }
  }
  
  out(sprintf("{t}Processing %s ...{/t}","update treesize")."<br>");
  @set_time_limit(300);
  $folders = db_select("simple_sys_tree",array("*"),array(),"lft asc","",array());
  foreach ($folders as $folder) {
	db_update_treesize("simple_".$folder["ftype"],$folder["id"]);
  }
  
  out(sprintf("{t}Processing %s ...{/t}","config.php")."<br>");
  if (($fp = fopen(SIMPLE_STORE."/config.php", "w"))) {
    fwrite($fp,"<?"."php\n");
	fwrite($fp,"define('APP_TITLE','Simple Groupware');\n");
	fwrite($fp,"define('SETUP_DB_PW','".sys_encrypt($_REQUEST["db_pw"],sha1($_REQUEST["admin_user"]))."');\n");
	fwrite($fp,"define('SETUP_DB_VERSION',".(int)$version.");\n");
	fwrite($fp,"define('SETUP_ADMIN_PW','".sha1($_REQUEST["admin_pw"])."');\n");

	fwrite($fp,"define('SETUP_DB_NAME','".$_REQUEST["db_name"]."');\n");
	fwrite($fp,"define('SETUP_DB_HOST','".$_REQUEST["db_host"]."');\n");
	fwrite($fp,"define('SETUP_DB_USER','".$_REQUEST["db_user"]."');\n");
	fwrite($fp,"define('SETUP_ADMIN_USER','".$_REQUEST["admin_user"]."');\n");
	fwrite($fp,"define('SETUP_LANGUAGE','".$_REQUEST["language"]."');\n");
	
	fwrite($fp,"define('SETUP_DB_TYPE','".SETUP_DB_TYPE."');\n");
	fwrite($fp,"define('CORE_VERSION','".CORE_VERSION."');\n");
	fwrite($fp,"define('CORE_VERSION_STRING','".CORE_VERSION_STRING."');\n");
	fwrite($fp,"define('CORE_SGSML_VERSION','".CORE_SGSML_VERSION."');\n");
	fwrite($fp,"define('SIMPLE_CACHE','".SIMPLE_CACHE."');\n");
	
	fwrite($fp,"define('CORE_COMPRESS_OUTPUT',".($GLOBALS["core_compress_output"]?"true":"false").");\n");
	fwrite($fp,"define('CORE_OUTPUT_CACHE',".($GLOBALS["core_output_cache"]?"true":"false").");\n");
	fwrite($fp,"define('DEBUG',".(DEBUG?"true":"false").");\n");
	fwrite($fp,"define('SMTP_FOOTER','Sent with Simple Groupware http://www.simple-groupware.de/');\n");
	$vars = array(
	  "SETUP_AUTH"=>"'sql'",
	  "SETUP_AUTH_DOMAIN"=>"''", "SETUP_AUTH_LDAP_USER"=>"''", "SETUP_AUTH_LDAP_PW"=>"''",
	  "SETUP_AUTH_BASE_DN"=>"''", "SETUP_AUTH_AUTOCREATE"=>"0",
	  "SETUP_AUTH_HOSTNAME_LDAP"=>"''", "SETUP_AUTH_HOSTNAME_IMAP"=>"''",
	  "SETUP_AUTH_HOSTNAME_SMTP"=>"''", "SETUP_AUTH_HOSTNAME_FTP"=>"''",
	  "CHECK_DOS"=>"1", "FORCE_SSL"=>"0", "ENABLE_ANONYMOUS"=>"1",
	  "DEBUG_SQL"=>"false", "DEBUG_SQL_FULL"=>"false",
	  "LOCKING"=>"900", "LOGIN_TIMEOUT"=>"1800", "DEFAULT_STYLE"=>"'core'", "WEEKSTART"=>"0",
	  "OUTPUT_CACHE"=>"86400", "CSV_CACHE"=>"300", "BOOKMARKS_CACHE"=>"300", "ICALENDAR_CACHE"=>"300",
	  "RSS_CACHE"=>"600", "VCARD_CACHE"=>"300", "XML_CACHE"=>"300",
	  "IMAP_CACHE"=>"300", "IMAP_LIST_CACHE"=>"30", "IMAP_MAIL_CACHE"=>"15552000",
	  "POP3_LIST_CACHE"=>"30", "POP3_MAIL_CACHE"=>"15552000",
	  "FILE_TEXT_LIMIT"=>"3000", "FILE_TEXT_CACHE"=>"15552000",
	  "LDAP_LIST_CACHE"=>"30", "INDEX_LIMIT"=>"16384",
	  "VIRUS_SCANNER"=>"''", "VIRUS_SCANNER_PARAMS"=>"''", "VIRUS_SCANNER_DISPLAY"=>"''",
	);
	foreach ($vars as $key=>$var) fwrite($fp,"define('".$key."',".$var.");\n");
	fwrite($fp,"\$GLOBALS['time'] = time();\n");
    fwrite($fp,"?>\n");
	fclose($fp);
	if (!file_exists(SIMPLE_STORE."/config.php") or filesize(SIMPLE_STORE."/config.php")==0) {
	  die("cannot write to: ".SIMPLE_STORE."/config.php");
	}
	sys_log_message_log("info",sprintf("{t}Setup: setup-data written to %s.{/t}",SIMPLE_STORE."/config.php"),"");
	out('
	<br>
	<a href="index.php">{t}C O N T I N U E{/t}</a><br>
	<br>
    <div style="border-top: 1px solid black;">Powered by Simple Groupware, Copyright (C) 2002-2006 by Thomas Bley.</div>
	</div>
	</body></html>
	');
  } else die("cannot write to: ".SIMPLE_STORE."/config.php");

  db_optimize_tables();
}

function dirs_create_default_folders() {
  _dirs_create_htaccess(SIMPLE_STORE."/");
  _dirs_create_dir(SIMPLE_STORE."/home");
  _dirs_create_dir(SIMPLE_STORE."/backup");
  dirs_clear_caches();
}

function dirs_clear_caches() {
  $empty_dir = array(
    SIMPLE_STORE."/locking",
	SIMPLE_CACHE, SIMPLE_CACHE."/debug", SIMPLE_CACHE."/imap", SIMPLE_CACHE."/pop3",
	SIMPLE_CACHE."/ip", SIMPLE_CACHE."/jpgraph", SIMPLE_CACHE."/output",
	SIMPLE_CACHE."/schema", SIMPLE_CACHE."/schema_data", SIMPLE_CACHE."/smarty",
	SIMPLE_CACHE."/thumbs", SIMPLE_CACHE."/upload", SIMPLE_CACHE."/backup",
	SIMPLE_CACHE."/preview"
  );
  foreach ($empty_dir as $dir) dirs_create_empty_dir($dir);
  _dirs_create_htaccess(SIMPLE_CACHE."/");
}

function _dirs_create_htaccess($dirname) {
  if (($fd = @fopen($dirname.".htaccess", "w"))) {
    fwrite($fd, "Order deny,allow\nDeny from all\n");
    fclose($fd);
  } else {
	setup_error(sprintf("{t}Please give write access to %s{/t}",$dirname));
  }
  _dirs_create_index_htm($dirname);
}

function _dirs_create_dir($dirname) {
  if (!is_dir($dirname)) sys_mkdir($dirname);
  _dirs_create_index_htm($dirname."/");
}

function get_lang_strings($lang_file) {
  $unicode = false;
  $lang_strings = array();
  if (file_exists($lang_file)) {
    $file_data = split("{t"."}",str_replace("\n\n","",file_get_contents($lang_file)));
    if (ord($file_data[0])==239) $unicode = true; // BOM
    foreach ($file_data as $elem) {
      if ($elem!="") {
  	    $elem = split("{/t"."}",$elem);
	    $elem[0] = trim($elem[0]);
	    if (isset($elem[1])) $elem[1] = trim($elem[1]);
	    if (!empty($elem[1])) {
	      if (!$unicode) $elem[1] = utf8_encode($elem[1]);
	      $lang_strings[$elem[0]] = htmlspecialchars($elem[1],ENT_QUOTES,"UTF-8");
	    }
	  }
    }
  }
  return $lang_strings;
}

function build_trans($lang_file,$source,$target) {
  $lang_strings = get_lang_strings($lang_file);
  clearstatcache();
  if (!is_writable($target)) die("Please give write access to ".$target);
  
  db_lock_tree();
  if (file_exists($target."index.php") and !unlink($target."index.php")) die("Could not delete ".$target."index.php");
  $queue = array($source);
  while (count($queue)>0) {
    $src = array_shift($queue);
    if (is_dir($src) and $dh=opendir($src)) {
      while (($file = readdir($dh)) !== false) {
   	    if ($file!="." and $file!="..") {
	      if (is_dir($src.$file)) {
		    if (!file_exists($src.$file."/_.exclude") and !file_exists($src.$file."/_.exclude_bin")) {
		      $queue[] = $src.$file."/";
		      $newdir = str_replace($source,$target,$src.$file."/");
		      if (!is_dir($newdir)) mkdir($newdir);
		    }
	      } else {
		    $newfile = str_replace($source,$target,$src.$file);
		    $data = file_get_contents($src.$file);
		    $ext = strtolower(substr($file,-strpos(strrev($file),'.')));
		    if (!file_exists($newfile)) {
			  if ($ext!="lang" and preg_match_all("|\{t\}(.*?)\{/t\}|i",$data,$matches,PREG_SET_ORDER)) {
		  	    foreach ($matches as $match) {
	    		  if (count($match)==2) {
			        if (isset($lang_strings[$match[1]])) {
				      $data = str_replace($match[0],$lang_strings[$match[1]],$data);
				    } else $data = str_replace($match[0],$match[1],$data);
			      }
		        }
			  }
			  $data = str_replace("define(\"DEBUG\",true);","define(\"DEBUG\",false);",$data);
		  	  $fp = fopen($newfile,"wb");
		  	  fwrite($fp,$data);
		      fclose($fp);
		    } else echo "Cannot write ".$newfile.", file already exists.<br>\n";
	      }
	    }
      }
    }
  }
  db_unlock_tree();
}

?>