<?php
	/**************************************************************************\
	* Simple Groupware 0.241                                                   *
	* http://www.simple-groupware.de                                           *
	* Copyright (C) 2002-2006 by Thomas Bley                                   *
	* ------------------------------------------------------------------------ *
	*  This program is free software; you can redistribute it and/or           *
	*  modify it under the terms of the GNU General Public License Version 2   *
	*  as published by the Free Software Foundation; only version 2            *
	*  of the License, no later version.                                       *
	*                                                                          *
	*  This program is distributed in the hope that it will be useful,         *
	*  but WITHOUT ANY WARRANTY; without even the implied warranty of          *
	*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the            *
	*  GNU General Public License for more details.                            *
	*                                                                          *
	*  You should have received a copy of the GNU General Public License       *
	*  Version 2 along with this program; if not, write to the Free Software   *
	*  Foundation, Inc., 59 Temple Place - Suite 330, Boston,                  *
	*  MA  02111-1307, USA.                                                    *
	\**************************************************************************/

if (!defined("MAIN_SCRIPT")) exit;
if ($_SESSION["username"]!=SETUP_ADMIN_USER) die("{t}Not allowed. Please log in as super administrator.{/t}");

  ob_start();
  header("Content-Type: text/html; charset=utf-8");
  echo '
    <html>
    <head>
	<title>Simple Groupware</title>
	<style>
		body, h2, img, div, table#data,a {
		  background-color: #FFFFFF; color: #666666; font-size: 13px; font-family: Arial, Helvetica, Verdana, sans-serif;
		}
		a,input { color: #0000FF; }
		input {
		  font-size: 11px; background-color: #F5F5F5; border: 1px solid #AAAAAA; height: 18px;
		  vertical-align: middle; padding-left: 5px; padding-right: 5px; -moz-border-radius:10px;
		}
		.submit { color: #0000FF; background-color: #FFFFFF; width: 230px; font-weight: bold; }
	</style>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    </head>
    <body>
  ';
  $inputs = array(
    "app_title"=>array("{t}Application title{/t}"),
    "setup_db_host"=>array("{t}Database Hostname / IP{/t}"),
    "setup_db_user"=>array("{t}Database User{/t}"),
    "setup_db_pw"=>array("{t}Database Password{/t}"),
    "setup_db_name"=>array("{t}Database Name{/t}"),
    "setup_admin_user"=>array("{t}Admin Username{/t}"),
    "setup_admin_pw"=>array("{t}Admin Password{/t}"),
    "virus_scanner"=>array("{t}Virus scanner{/t}"),
    "virus_scanner_params"=>array("{t}Virus scanner{/t}: {t}parameters{/t}"),
    "virus_scanner_display"=>array("{t}Virus scanner{/t}: {t}display filter{/t}"),
  );
  $auths = array(
    "sql"=>array("SQL",false,""),
	"htaccess"=>array("{t}Apache based (Basic, NTLM, etc.){/t}",false,""),
	"ldap"=>array("LDAP",true,"(ldaps://server/ | server)"),
	"ftp"=>array("FTP",true,""),
	"imap"=>array("IMAP",true,"(server[:port[:ssl|tls]])"),
	"smtp"=>array("SMTP",true,"(server[:port[:ssl|tls]])"),
  );
  $bools = array(
    "SETUP_AUTH_AUTOCREATE"=>"{t}Enable automatic user creation{/t}<br>[htaccess, LDAP, IMAP, SMTP, FTP]",
    "ENABLE_ANONYMOUS"=>"{t}Enable anonymous access{/t}",
	"FORCE_SSL"=>"{t}Force SSL{/t}",
	"CHECK_DOS"=>"{t}Check DoS Attacks{/t}",
	"CORE_COMPRESS_OUTPUT"=>"{t}Compress output{/t}",
	"CORE_OUTPUT_CACHE"=>"{t}Cache output{/t}",
	"DEBUG"=>"",
	"DEBUG_SQL"=>"",
	"DEBUG_SQL_FULL"=>""
  );
  $caches = array("LOGIN_TIMEOUT"=>"","LOCKING"=>"","OUTPUT_CACHE"=>"",
    "CSV_CACHE"=>"","BOOKMARKS_CACHE"=>"","ICALENDAR_CACHE"=>"","RSS_CACHE"=>"","VCARD_CACHE"=>"",
	"XML_CACHE"=>"","IMAP_CACHE"=>"","IMAP_LIST_CACHE"=>"","IMAP_MAIL_CACHE"=>"","POP3_LIST_CACHE"=>"",
	"POP3_MAIL_CACHE"=>"","SIMPLE_CACHE"=>"","LDAP_LIST_CACHE"=>"",
	"FILE_TEXT_LIMIT"=>"","FILE_TEXT_CACHE"=>"", "INDEX_LIMIT"=>"",
  );
  $textareas = array(
	"smtp_footer"=>array("SMTP {t}mail footer{/t}",false)
  );
  
  $selects = array(
    "default_style"=>array("{t}Default theme{/t}",array(
      "core"=>"simple core","contrast"=>"simple contrast","water"=>"simple water","lake"=>"simple lake","beach"=>"simple beach",
	  "paradise"=>"simple paradise","earth"=>"simple earth","sunset"=>"simple sunset",
	  "nature"=>"simple nature","desert"=>"simple desert","black"=>"simple black",
	)),
    "weekstart"=>array("{t}Week start{/t}",array(
      "0"=>"{t}Su{/t}", "1"=>"{t}Mo{/t}", "2"=>"{t}Tu{/t}", "3"=>"{t}We{/t}",
      "4"=>"{t}Th{/t}", "5"=>"{t}Fr{/t}", "6"=>"{t}Sa{/t}"
	)),
  );
  echo '
    <div style="border-bottom: 1px solid black; letter-spacing: 2px; font-size: 18px; font-weight: bold;">Simple Groupware '.CORE_VERSION_STRING.'</div>
	<br>
	<div style="color:#FF0000;">
  ';
  $show_form = true;
  if (!empty($_REQUEST["setup_language"])) {
    $error = false;
    if ($_REQUEST["setup_admin_user"]!=SETUP_ADMIN_USER and $validate=validate_username($_REQUEST["setup_admin_user"]) and $validate!="") {
	  $error = true;
	  echo "{t}Admin Username{/t} - {t}validation failed{/t} ".$validate;
	}
    if ($_REQUEST["setup_db_host"]=="") {
	  $error = true;
	  echo sprintf("{t}missing field{/t}: %s","{t}Database Hostname / IP{/t}");
	}
    if ($_REQUEST["setup_db_user"]=="") {
	  $error = true;
	  echo sprintf("{t}missing field{/t}: %s","{t}Database User{/t}");
	}
    if ($_REQUEST["setup_db_name"]=="") {
	  $error = true;
	  echo sprintf("{t}missing field{/t}: %s","{t}Database Name{/t}");
	}
	$noenc = false;
    if ($_REQUEST["setup_admin_pw"]=="" and $_REQUEST["setup_admin_user"]==SETUP_ADMIN_USER) {
	  $_POST["setup_admin_pw"] = SETUP_ADMIN_PW;
	  $noenc = true;
	} else if ($_REQUEST["setup_admin_pw"]=="") {
	  $error = true;
	  echo sprintf("{t}missing field{/t}: %s","{t}Admin Password{/t}");
	}
    if (empty($_REQUEST["setup_auth"])) {
	  $error = true;
	  echo sprintf("{t}missing field{/t}: %s","{t}Authentication Mode{/t}");
	}
    if (!sql_connect($_REQUEST["setup_db_host"], $_REQUEST["setup_db_user"], $_REQUEST["setup_db_pw"], $_REQUEST["setup_db_name"])) {
	  $error = true;
      echo "{t}Connection to database failed.{/t}\n".sql_error();
    }
    if (!$error and $fp = fopen(SIMPLE_STORE."/config.php", "w")) {
	  fwrite($fp,"<?php\n");
	  fwrite($fp,"\$GLOBALS['time'] = time();\n");
	  fwrite($fp,"define('CORE_VERSION','".CORE_VERSION."');\n");
	  fwrite($fp,"define('CORE_VERSION_STRING','".CORE_VERSION_STRING."');\n");
	  fwrite($fp,"define('CORE_SGSML_VERSION','".CORE_SGSML_VERSION."');\n");
	  fwrite($fp,"define('SETUP_DB_TYPE','".SETUP_DB_TYPE."');\n");
	  fwrite($fp,"define('SETUP_DB_VERSION','".SETUP_DB_VERSION."');\n");
      foreach ($_POST as $key=>$val) {
	    if ($key!="action_sys") {
	      if ($key=="setup_db_pw") $val = sys_encrypt($val,sha1($_REQUEST["setup_admin_user"]));
	      if (!$noenc and $key=="setup_admin_pw") $val = sha1($val);
		  $key = strtoupper($key);
	      if (!is_numeric($val)) $val = "'".$val."'";
		  if (isset($bools[$key])) {
		    if ($val=="'checked'") $val = "true"; else $val = "false";
		  }
	      fwrite($fp,"define('".$key."',".$val.");\n");
	    }
	  }
	  fwrite($fp,"?>\n");
	  fclose($fp);
	  if (SIMPLE_CACHE!=$_REQUEST["simple_cache"]) {
	    dirs_clear_caches(SIMPLE_CACHE);
	    dirs_clear_caches($_REQUEST["simple_cache"]);
	  }
	  sys_log_message_log("info",sprintf("{t}Setup: setup-data written to %s.{/t}",SIMPLE_STORE."/config.php"),"");
	  echo sprintf('{t}Setup: setup-data written to %s.{/t}',SIMPLE_STORE."/config.php");
	  $show_form = false;
	}
	echo "<br><br>";
  }
  echo '
	<a href="index.php">{t}Back{/t}</a><br><br>
    </div>
  ';
  
  if ($show_form) {
	  echo '
		<form action="index.php" method="post">
		<input type="hidden" value="edit_setup" name="action_sys">
		<input type="hidden" value="{t}en{/t}" name="setup_language">
		<table id="data">
	  ';
	  foreach ($inputs as $key=>$input) {
	    echo '
		  <tr>
		    <td>'.$input[0].'</td>
		';
		if ($key=="setup_db_pw") {
		    echo '<td><input type="Text" size="60" maxlength="255" name="'.$key.'" value="'.htmlspecialchars(sys_decrypt(SETUP_DB_PW,sha1(SETUP_ADMIN_USER)),ENT_QUOTES).'"></td>';
		} else if ($key=="setup_admin_pw") {
		    echo '<td><input type="Text" size="60" maxlength="255" name="'.$key.'" value=""></td>';
		} else {
		    echo '<td><input type="Text" size="60" maxlength="255" name="'.$key.'" value="'.htmlspecialchars(constant(strtoupper($key)),ENT_QUOTES).'"></td>';
		}
		echo '
		  </tr>
		';
	  }
	  echo '
		<tr>
		  <td>{t}Database{/t}</td>
		  <td>'.htmlspecialchars(SETUP_DB_TYPE,ENT_QUOTES).'</td>
		</tr>
		<tr>
		  <td nowrap valign="top">{t}Authentication Mode{/t}</td>
		  <td>
		  	<table id="data" style="background-color: #FFFFFF; border: 0px; margin: 0px;">
	  ';
	  foreach ($auths as $key=>$auth) {
	    echo '
		<tr>
		<td><input type="Radio" class="radio" name="setup_auth" value="'.$key.'" '.(SETUP_AUTH==$key?"checked":"").'></td>
		';
		if (!$auth[1]) {
		  echo '<td colspan="2">'.$auth[0].'</td>';
		} else {
		  echo '
		    <td>'.$auth[0].'</td>
			<td>{t}Host{/t} <input type="Text" name="setup_auth_hostname_'.$key.'" value="'.htmlspecialchars(constant("SETUP_AUTH_HOSTNAME_".strtoupper($key)),ENT_QUOTES).'"> '.$auth[2].'</td>';

		  if ($key=="ldap") {
			echo '<tr><td colspan="2"></td><td>{t}Domain{/t} <input type="Text" name="setup_auth_domain" value="'.htmlspecialchars(SETUP_AUTH_DOMAIN,ENT_QUOTES).'"> (Active Directory)</td></tr>';
			echo '<tr><td colspan="2"></td><td>Base DN <input type="Text" name="setup_auth_base_dn" value="'.htmlspecialchars(SETUP_AUTH_BASE_DN,ENT_QUOTES).'"> ({t}if not autodetected with namingContexts{/t})</td></tr>';
			echo '<tr><td colspan="2"></td><td>User DN <input type="Text" name="setup_auth_ldap_user" value="'.htmlspecialchars(SETUP_AUTH_LDAP_USER,ENT_QUOTES).'"> ({t}LDAP without anonymous access{/t})</td></tr>';
			echo '<tr><td colspan="2"></td><td>{t}Password{/t} <input type="Text" name="setup_auth_ldap_pw" value="'.htmlspecialchars(SETUP_AUTH_LDAP_PW,ENT_QUOTES).'"> ({t}LDAP without anonymous access{/t})</td></tr>';
		  }
		}
		echo '</tr>';
	  }
	  echo '
			</table>
		  </td>
		</tr>
	  ';
	  foreach ($bools as $key=>$val) {
	    echo '
		<input type="hidden" name="'.strtolower($key).'" value="">
		<tr>
		  <td>'.($val?$val:$key).'</td>
		  <td><input type="Checkbox" class="checkbox" name="'.strtolower($key).'" value="checked" '.(constant($key)?"checked":"").'></td>
		</tr>
	    ';
	  }
	  foreach ($caches as $key=>$val) {
	    echo '
		<tr>
		  <td>'.($val?$val:$key).'</td>
		  <td><input type="Text" size="15" maxlength="50" name="'.strtolower($key).'" value="'.htmlspecialchars(constant($key),ENT_QUOTES).'"></td>
		</tr>
	    ';
	  }
	  foreach ($selects as $key=>$val) {
	    echo '
		  <tr>
		    <td>'.$val[0].'</td>
		    <td><select name="'.$key.'">
	    ';
	    foreach ($val[1] as $key2=>$val2) {
	      echo '<option value="'.$key2.'" '.(DEFAULT_STYLE==$key2?"checked":"").'> '.$val2;
	    }
	    echo '	  
		    </select>
		  </tr>
	    ';
	  }
	  foreach ($textareas as $key=>$input) {
	    echo '
		  <tr>
		    <td>'.$input[0].'</td>
		    <td><textarea name="'.$key.'" style="width:450px; height:100px;" wrap="off">'.($input[1]?"":htmlspecialchars(constant(strtoupper($key)),ENT_QUOTES)).'</textarea></td>
		  </tr>
		';
	  }
	  echo '
		</table>
	    <div style="border-bottom: 1px solid black;">&nbsp;</div>
		<br>
		<input type="submit" value="   {t}S a v e{/t}   " class="submit"><br>
		</form>
	  ';
  }
  
  echo '
    <div style="border-top: 1px solid black;">Powered by Simple Groupware, Copyright (C) 2002-2006 by Thomas Bley.</div>
	</div>
	</body></html>
  ';
  $out = ob_get_contents();
  ob_end_clean();
  echo sys_remove_trans($out);
  

function dirs_clear_caches($cache) {
  $empty_dir = array(
	$cache, $cache."/debug", $cache."/imap", $cache."/pop3", $cache."/ip", $cache."/jpgraph",
	$cache."/output", $cache."/schema", $cache."/schema_data", $cache."/smarty", $cache."/thumbs",
	$cache."/upload", $cache."/backup"
  );
  foreach ($empty_dir as $dir) dirs_create_empty_dir($dir);

  if (($fd = @fopen(SIMPLE_CACHE."/.htaccess", "w"))) {
    fwrite($fd, "Order deny,allow\nDeny from all\n");
    fclose($fd);
  }
  _dirs_create_index_htm($dirname);
}

?>