<?php
	/**************************************************************************\
	* Simple Groupware 0.241                                                   *
	* http://www.simple-groupware.de                                           *
	* Copyright (C) 2002-2006 by Thomas Bley                                   *
	* ------------------------------------------------------------------------ *
	*  This program is free software; you can redistribute it and/or           *
	*  modify it under the terms of the GNU General Public License Version 2   *
	*  as published by the Free Software Foundation; only version 2            *
	*  of the License, no later version.                                       *
	*                                                                          *
	*  This program is distributed in the hope that it will be useful,         *
	*  but WITHOUT ANY WARRANTY; without even the implied warranty of          *
	*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the            *
	*  GNU General Public License for more details.                            *
	*                                                                          *
	*  You should have received a copy of the GNU General Public License       *
	*  Version 2 along with this program; if not, write to the Free Software   *
	*  Foundation, Inc., 59 Temple Place - Suite 330, Boston,                  *
	*  MA  02111-1307, USA.                                                    *
	\**************************************************************************/
  
  define("MAIN_SCRIPT",basename($_SERVER["PHP_SELF"]));

  error_reporting(E_ALL);
  define("SIMPLE_STORE","../simple_store");
  @include(SIMPLE_STORE."/config.php");
  
  include "core/functions.php";
  include "core/functions_user.php";

  if (!defined("SETUP_DB_HOST")) exit;
  header("Content-Type: text/html; charset=utf-8");
  if (get_magic_quotes_gpc()) modify_stripslashes($_REQUEST);

  if (!defined("SETUP_DB_HOST") or !sql_connect(SETUP_DB_HOST, SETUP_DB_USER, sys_decrypt(SETUP_DB_PW,sha1(SETUP_ADMIN_USER)), SETUP_DB_NAME, SETUP_DB_VERSION)) {
    echo sql_error();
	exit;
  }

  login_handle_login();
  if (isset($_REQUEST["logout"])) {
    echo sys_remove_trans("{t}Access denied.{/t}");
	exit;
  }
  if (empty($_SESSION["username"])) {
    echo sys_remove_trans("{t}Your session has timed out.{/t}");
	exit;
  }

  if (!empty($_REQUEST["item"])) {
    $req = $_REQUEST["item"];
    $req = tree_process_openclose_request($req);
	if (!isset($_SESSION["folder_states"][$req])) {
	  echo "none";
	  return;
	}
	$is_mp = false;
	$level = 0;
	$req_path = "";
	$path2 = "";
	if (!is_numeric($req) and $req) {
	  $url = sys_parse_folder($req);
	  $req = $url["mfolder"];
	  $req_path = $url["path"];
	  $path2 = $url["mountpoint"];
	  $level = substr_count($req_path,"/")-1;
	  $is_mp = true;
	}
    $folder = db_select_first("simple_sys_tree",array("fmountpoint","flevel","id"),array("id=@id@",$_SESSION["permission_sql_read"]),"","",array("id"=>$req));
	if (empty($folder["id"])) return;
    $folders = db_select("simple_sys_tree",array("id","flevel","ftitle","fcount","fmountpoint"),array("parent=@parent@",$_SESSION["permission_sql_read"]),"lft asc","",array("parent"=>$req));
	
	if ($folder["fmountpoint"]!="") {
	  $folder["fmountpoint"] = str_replace("%username%",$_SESSION["username"],$folder["fmountpoint"]);
	  $url = sys_parse_folder($folder["fmountpoint"]);
	  $handler = $url["handler"];
	  $path = $url["path"];
  	  if ($is_mp) {
	    $folder["flevel"] += substr_count($req_path,"/") - substr_count($url["path"],"/");
		$level = 1;
	    $path = $path2;
	  }
	  if (!empty($url["user"])) $GLOBALS["credentials"][$handler."_".$folder["id"]] = array("server"=>$url["mfolder"],"username"=>$url["user"],"password"=>$url["pass"],"port"=>$url["port"],"ssl"=>$url["ssl"],"path"=>$url["mountpoint"]);
	  $func = $handler."_get_dirs";
	  if (file_exists("modules/lib/".$handler.".php")) include_once("modules/lib/".$handler.".php");
	  if (function_exists($func)) {
	    $next_rows = _folder_get_mount_dirs($path,$handler,$req,$func,true);
		if (is_array($next_rows) and count($next_rows)>0) {
		  foreach ($next_rows as $next_row) {
		    if (($req_path=="" or strpos($next_row["id"],$req_path)) and $next_row["flevel"]==$level) $folders[] = $next_row;
	} } } }
	if (count($folders)>0) {
	  foreach ($folders as $item) {
		unset($_SESSION["folder_states"][$item["id"]]);

        $item["icon"] = "folder";
	    $item["plus"] = "plus";
	    $item["flevel"] = $folder["flevel"]+1;
	    $item["id"] = urlencode($item["id"]);
 	    if (DEBUG) $item["ftitle"] = sys_remove_trans($item["ftitle"]);
		if (!isset($_REQUEST["plain"])) {
	      echo "<div style='white-space:nowrap;'>";
	      echo str_repeat("<img src='ext/line.gif'>",$item["flevel"]);
	      echo "<a onclick='tree_open(\"".$item["id"]."\");'><img id='".$item["id"]."_img' src='ext/".$item["plus"].".gif'></a>&nbsp;";
	      echo "<a href='index.php?folder=".$item["id"]."'><img src='images.php?image=".$item["icon"]."1&style=".$_SESSION["style"]."'> ".htmlspecialchars($item["ftitle"],ENT_QUOTES)."&nbsp;";
	      if ($item["fcount"]>0) echo "(".$item["fcount"].")";
	      echo "</a></div>";
	      echo "<div id='".$item["id"]."' style='display:none;'></div>";
		} else {
		  echo $item["ftitle"];
	      if ($item["fcount"]>0) echo " (".$item["fcount"].")";
		  echo "\n".$item["id"]."\n\n";
		}
	  }
    } else echo "empty";
  }

  
function tree_process_openclose_request($item) {
  if ($item=="1") {
	$folder = db_select_first("simple_sys_tree",array("id"),array($_SESSION["permission_sql_read"]),"lft asc","",array());
	if (!empty($folder["id"])) $item = $folder["id"];
  }
  if (isset($_SESSION["folder_states"][$item])) {
	foreach ($_SESSION["folder_states"][$item] as $child) {
	  if (isset($_SESSION["folder_states"][$child])) unset($_SESSION["folder_states"][$child]);
	}
	unset($_SESSION["folder_states"][$item]);
  } else {
    if (is_numeric($item)) {
	  $where = array("id=@id@",$_SESSION["permission_sql_read"]);
	  $vars = array("id"=>$item);
	  $item_arr = db_select_first("simple_sys_tree",array("id","lft","rgt"),$where,"lft asc","",$vars);
	} else $item_arr = array("id"=>$item);

	if (isset($item_arr["id"])) {
  	  $parents = db_get_parents($item_arr);
	  if (is_array($parents) and count($parents)>0) {
	    foreach ($parents as $parent) {
	      $id = $parent["id"];
	      if (!isset($_SESSION["folder_states"][$id]) or !in_array($item,$_SESSION["folder_states"][$id])) {
	        $_SESSION["folder_states"][$id][] = $item;
	      }
	    }
	  }
	  if (!isset($_SESSION["folder_states"][$item])) $_SESSION["folder_states"][$item] = array(1);
	}
  }
  if (isset($item_arr["id"])) return $item_arr["id"]; else return 0;
}

  
?>
