	/**************************************************************************\
	* Simple Groupware 0.241                                                   *
	* http://www.simple-groupware.de                                           *
	* Copyright (C) 2002-2006 by Thomas Bley                                   *
	* ------------------------------------------------------------------------ *
	*  This program is free software; you can redistribute it and/or           *
	*  modify it under the terms of the GNU General Public License Version 2   *
	*  as published by the Free Software Foundation; only version 2            *
	*  of the License, no later version.                                       *
	*                                                                          *
	*  This program is distributed in the hope that it will be useful,         *
	*  but WITHOUT ANY WARRANTY; without even the implied warranty of          *
	*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the            *
	*  GNU General Public License for more details.                            *
	*                                                                          *
	*  You should have received a copy of the GNU General Public License       *
	*  Version 2 along with this program; if not, write to the Free Software   *
	*  Foundation, Inc., 59 Temple Place - Suite 330, Boston,                  *
	*  MA  02111-1307, USA.                                                    *
	\**************************************************************************/


create or replace view show_full_columns as 
(select
lower(column_name) as "Field",
lower(data_type)||' ('||CASE WHEN DATA_PRECISION>0 THEN DATA_PRECISION ELSE DATA_LENGTH END||')' as "Type",
nullable as "Null",
'' as "Key",
data_default as "Default",
'' as "Extra",
'' as "Privileges",
lower(table_name) as table_name
from cols);

create or replace view show_index as
(select
lower(a.table_name) as "Table",
'' as "Non_unique",
lower(a.index_name) as "Key_name",
'' as "Seq_in_index",
lower(a.column_name) as "Column_name",
'' as "Collation",
b.num_rows as "Cardinality",
'' as "Sub_part",
'' as "Packed",
'' as "Null",
lower(b.index_type) as "Index_type",
'' as "Comment",
lower(a.table_name) as table_name
from user_ind_columns a, user_indexes b
where a.index_name=b.index_name);

create or replace view show_table_status as
(select
lower(table_name) as "Name",
num_rows as "Rows",
(select created from user_objects where object_type='TABLE' and object_name=table_name) as "Create_time",
(select last_ddl_time from user_objects where object_type='TABLE' and object_name=table_name) as "Update_time",
last_analyzed as "Check_time",
avg_row_len as "Avg_row_length",
(select bytes from user_segments where segment_type='TABLE' and segment_name=table_name) as "Data_length",
0 as "Index_length",
0 as "Data_free"
from tabs
where table_name like 'SIMPLE_%');
