<?php
	/**************************************************************************\
	* Simple Groupware 0.241                                                   *
	* http://www.simple-groupware.de                                           *
	* Copyright (C) 2002-2006 by Thomas Bley                                   *
	* ------------------------------------------------------------------------ *
	*  This program is free software; you can redistribute it and/or           *
	*  modify it under the terms of the GNU General Public License Version 2   *
	*  as published by the Free Software Foundation; only version 2            *
	*  of the License, no later version.                                       *
	*                                                                          *
	*  This program is distributed in the hope that it will be useful,         *
	*  but WITHOUT ANY WARRANTY; without even the implied warranty of          *
	*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the            *
	*  GNU General Public License for more details.                            *
	*                                                                          *
	*  You should have received a copy of the GNU General Public License       *
	*  Version 2 along with this program; if not, write to the Free Software   *
	*  Foundation, Inc., 59 Temple Place - Suite 330, Boston,                  *
	*  MA  02111-1307, USA.                                                    *
	\**************************************************************************/

if (!defined("MAIN_SCRIPT")) exit;

function backups_get_dirs($path, $left, $level, &$tree, $parent, $recursive) {
  if (validate_allowedpath($path)!="") return $left;
  $right = $left+1;
  $right = $right+2;
  $tree[$left] = array("id"=>$path,"lft"=>$left,"rgt"=>$right,"flevel"=>$level,"ftitle"=>basename($path),"ftype"=>"sys_nosql_fs");
  return $right+1;
}

function backups_get_count($path,$where,$vars,$mfolder) {
  $path = SIMPLE_STORE."/backup/";
  if (validate_allowedpath($path)!="") return 0;
  $files = 0;
  if (($handle=@opendir($path))) {
    while (false !== ($file = readdir($handle))) {
      if ($file=='.' or $file=='..' or is_dir($path.$file)) continue;
	  if (modify_getfileext($file)!="tar") continue;
	  $files++;
    }
    closedir($handle);
  }
  return $files;
}

function backups_get_select($path,$fields,$where,$order,$limit,$vars,$mfolder) {
  $path = SIMPLE_STORE."/backup/";
  if (validate_allowedpath($path)!="") return array();
  $file_array = array();
  if (!$handle=@opendir($path)) return array();
  while (false !== ($file = readdir($handle))) {
    if ($file=='.' or $file=='..' or is_dir($path.$file)) continue;
	if (modify_getfileext($file)!="tar") continue;
	$file_array[]=$file;
  }
  closedir($handle);

  $rows = array();
  foreach ($file_array as $filename) {
    $data = stat($path.$filename);
	$row = array();
	foreach ($fields as $field) {
	  switch ($field) {
	    case "filedata":
	    case "id": $row[$field] = $path.$filename; break;
	    case "folder": $row[$field] = $vars["folder"]; break;
		case "category": 
		  $row[$field] = str_replace(array("__"),array("/"),substr(modify_basename($filename),0,strpos(modify_basename($filename),"--")));
		  break;
		case "filename":
		  $row[$field] = basename(str_replace(array("__"),array("/"),modify_basename($filename)));
		  $row[$field] = substr($row[$field],0,strpos($row[$field],"--"));
		  if ($row[$field]=="") $row[$field] = $filename;
		  break;
		case "searchcontent": $row[$field] = $filename; break;
		case "createdby":
		case "lastmodifiedby": $row[$field] = ""; break;
		case "created": $row[$field] = $data["ctime"]; break;
		case "lastmodified": $row[$field] = $data["mtime"]; break;
		case "filesize": $row[$field] = $data["size"]; break;
		default: $row[$field] = ""; break;
	  }
	}
	if (sys_get_select_where($row,$where,$vars)) $rows[] = $row;
  }
  $rows = sys_get_select($rows,$order,$limit,$fields);
  return $rows;
}

function backups_get_delete($path,$where,$vars,$mfolder) {
  if (empty($vars["id"]) or validate_allowedpath(dirname($vars["id"]))!="" or !file_exists($vars["id"])) return "error";
  unlink($vars["id"]);
  if (!file_exists($vars["id"])) return ""; else return "error";
}

function backups_insert($path,$data,$mfolder) {
  $path = SIMPLE_STORE."/backup/";
  if (validate_allowedpath($path)!="") return "";
  $source = $data["filedata"];
  $target = $path.$data["filename"];
  if (!is_dir($source) and file_exists($source)) {
    if (file_exists($target)) unlink($target);
	rename($source,$target);
  }
}
?>