<?php
	/**************************************************************************\
	* Simple Groupware 0.241                                                   *
	* http://www.simple-groupware.de                                           *
	* Copyright (C) 2002-2006 by Thomas Bley                                   *
	* ------------------------------------------------------------------------ *
	*  This program is free software; you can redistribute it and/or           *
	*  modify it under the terms of the GNU General Public License Version 2   *
	*  as published by the Free Software Foundation; only version 2            *
	*  of the License, no later version.                                       *
	*                                                                          *
	*  This program is distributed in the hope that it will be useful,         *
	*  but WITHOUT ANY WARRANTY; without even the implied warranty of          *
	*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the            *
	*  GNU General Public License for more details.                            *
	*                                                                          *
	*  You should have received a copy of the GNU General Public License       *
	*  Version 2 along with this program; if not, write to the Free Software   *
	*  Foundation, Inc., 59 Temple Place - Suite 330, Boston,                  *
	*  MA  02111-1307, USA.                                                    *
	\**************************************************************************/

if (!defined("MAIN_SCRIPT")) exit;

function csv_contacts_get_dirs($path, $left, $level, &$tree, $parent, $recursive) {
  $right = $left+1;
  $tree[$left] = array("id"=>$path,"lft"=>$left,"rgt"=>$right,"flevel"=>$level,"ftitle"=>basename($path),"ftype"=>"nosql_".basename($path));
  return $right+1;
}

function csv_contacts_get_count($path,$where,$vars,$mfolder) {
  $count = count(sys_parse_csv($path));
  if ($count>0) $count--;
  return $count;
}

function csv_contacts_get_select($path,$fields,$where,$order,$limit,$vars,$mfolder) {
  $path = rtrim($path,"/");
  $datas = sys_parse_csv($path);
  $rows = array();
  $index = array_shift($datas);
  $i = 0;
  $ids = array();
  $mapping = array(
    "email" => "E-mail Address",
	"company" => "Company",
	"firstname" => "First Name",
	"lastname" => "Last Name",
	"title" => "Title",
	"mobile" => "Mobile Phone",
	"pager" => "Pager",
	"phone" => "Business Phone",
	"fax" => "Business Fax",
	"description" => "Notes",
	"position" => "Job Title",
	"emailprivate" => "E-mail 2",
	"phoneprivate" => "Home Phone",
	"street" => "Business Address"
  );

  foreach ($datas as $data) {
	$i++;
    $row = array();
	foreach ($fields as $field) {
	  $row[$field] = "";
	  switch ($field) {
	    case "id": $row[$field] = $path."/?".$i; break;
	    case "folder": $row[$field] = $path; break;
		case "created": $row[$field] = 0; break;
		case "lastmodified": $row[$field] = 0; break;
		case "lastmodifiedby": $row[$field] = ""; break;
		case "searchcontent": $row[$field] = implode(" ",$data); break;
		case "contactid": 
			if (in_array("Last Name",$index)) {
			  $ind = array_search("Last Name", $index);
			  if (!empty($data[$ind])) $row[$field] = $data[$ind];
			}
			if (in_array("First Name",$index)) {
			  $ind = array_search("Last Name", $index);
			  if (!empty($data[$ind])) $row[$field] .= " ".$data[$ind];
			}
			if ($row[$field]=="" and in_array("Name",$index)) {
			  $ind = array_search("Name", $index);
			  if (!empty($data[$ind])) $row[$field] = $data[$ind];
			}
			$row[$field] = str_replace(" ","_",$row[$field]);
			while (isset($ids[$row[$field]])) $row[$field] .= "_2";
			$ids[$row[$field]] = "";
		  break;
		case "lastname":
			if (in_array("Last Name",$index)) {
			  $ind = array_search("Last Name", $index);
			  if (!empty($data[$ind])) $row[$field] = $data[$ind];
			}
			if ($row[$field]=="" and in_array("Name",$index)) {
			  $ind = array_search("Name", $index);
			  if (!empty($data[$ind])) {
			    if ($pos = strpos($data[$ind]," ")) {
			      $row[$field] = substr($data[$ind],$pos+1);
				} else $row[$field] = $data[$ind];
			  }
			}
			break; 
		case "firstname":
			if (in_array("First Name",$index)) {
			  $ind = array_search("First Name", $index);
			  if (!empty($data[$ind])) $row[$field] = $data[$ind];
			}
			if ($row[$field]=="" and in_array("Name",$index)) {
			  $ind = array_search("Name", $index);
			  if (!empty($data[$ind])) {
			    if ($pos = strpos($data[$ind]," ")) $row[$field] = substr($data[$ind],0,$pos);
			  }
			}
			break; 
		default:
		  $key = $field;
		  if (isset($mapping[$field])) $field = $mapping[$field];
		  if (in_array($field,$index)) $row[$key] = $data[array_search($field, $index)];
		  break;
	  }
	}
	if (sys_get_select_where($row,$where,$vars)) $rows[] = $row;
  }
  $rows = sys_get_select($rows,$order,$limit,$fields);
  return $rows;
}

?>