<?php
	/**************************************************************************\
	* Simple Groupware 0.241                                                   *
	* http://www.simple-groupware.de                                           *
	* Copyright (C) 2002-2006 by Thomas Bley                                   *
	* ------------------------------------------------------------------------ *
	*  This program is free software; you can redistribute it and/or           *
	*  modify it under the terms of the GNU General Public License Version 2   *
	*  as published by the Free Software Foundation; only version 2            *
	*  of the License, no later version.                                       *
	*                                                                          *
	*  This program is distributed in the hope that it will be useful,         *
	*  but WITHOUT ANY WARRANTY; without even the implied warranty of          *
	*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the            *
	*  GNU General Public License for more details.                            *
	*                                                                          *
	*  You should have received a copy of the GNU General Public License       *
	*  Version 2 along with this program; if not, write to the Free Software   *
	*  Foundation, Inc., 59 Temple Place - Suite 330, Boston,                  *
	*  MA  02111-1307, USA.                                                    *
	\**************************************************************************/

if (!defined("MAIN_SCRIPT")) exit;

function _rss_parse_start_el($parser, $name, $attrs) {
  if ($name=="ENTRY" or $name=="ITEM" or $name=="FEED" or $name=="CHANNEL") $GLOBALS["rss_data"][] = array("link"=>"","summary"=>"","title"=>"","lastmodified"=>0,"order"=>count($GLOBALS["rss_data"]));
  $GLOBALS["rss_data_tag"] = $name;
}

function _rss_parse_end_el($parser, $name) {
  $GLOBALS["rss_data_tag"] = "";
}

function _rss_parse_value($parser, $data) {
  if (count($GLOBALS["rss_data"])==0) return;
  $obj = $GLOBALS["rss_data"][count($GLOBALS["rss_data"])-1];
  switch ($GLOBALS["rss_data_tag"]) {
 	case "TITLE": if ($obj["title"]!=$data) $obj["title"] .= $data; break;
	case "SUMMARY":
	case "DESCRIPTION": $obj["summary"] .= $data; break;
	case "ID":
 	case "LINK": if ($obj["link"]!=$data) $obj["link"] .= $data; break;
  }
  $GLOBALS["rss_data"][count($GLOBALS["rss_data"])-1] = $obj;
}

function _rss_parse($file) {
  if ($data = sys_cache_get("rss_".sha1($file),RSS_CACHE)) return $data;
  if (validate_allowedpath(dirname($file))!="") return array();

  if (!($data = @file_get_contents($file))) {
    $GLOBALS["t"]["notification"][] = "{t}The url doesn't exist.{/t} (".$file.")";
  	return array();
  }
  if (!strpos("@".strtolower(substr($data,0,100)),"<?xml")) { // find RSS in website
    if (preg_match("/rss[^>]+?href=\"(.*?)\"/i",$data,$match)) {
	  if (!($data = @file_get_contents($match[1]))) {
        $GLOBALS["t"]["notification"][] = "{t}The url doesn't exist.{/t} (".$match[1].")";
  	    return array();
	  }
	}
  }
  $ret = array();
  $GLOBALS["rss_data"] = array();
  $xml_parser = xml_parser_create("");
  xml_parser_set_option($xml_parser,XML_OPTION_SKIP_WHITE,1);

  if (preg_match("/<?xml.*?encoding=['\"]iso-/i",$data)) {
    xml_parser_set_option($xml_parser, XML_OPTION_TARGET_ENCODING, "utf-8");
  }
  xml_set_element_handler($xml_parser, "_rss_parse_start_el", "_rss_parse_end_el");
  xml_set_character_data_handler($xml_parser, "_rss_parse_value");
  xml_parse($xml_parser, $data);
  xml_parser_free($xml_parser);

  sys_cache_set("rss_".sha1($file),$GLOBALS["rss_data"]);
  return $GLOBALS["rss_data"];
}

function rss_get_dirs($path, $left, $level, &$tree, $parent, $recursive) {
  $right = $left+1;
  $title = "{t}News{/t}";
//  $data = _rss_parse($path);
//  if (isset($data[0]["title"])) $title = $data[0]["title"]; else $title = basename($path);
  $tree[$left] = array("id"=>$path,"lft"=>$left,"rgt"=>$right,"flevel"=>$level,"ftitle"=>$title,"ftype"=>"nosql_".basename($path));
  return $right+1;
}

function rss_get_count($path,$where,$vars,$mfolder) {
  $count = count(_rss_parse($path));
  return $count;
}

function rss_get_select($path,$fields,$where,$order,$limit,$vars,$mfolder) {
  $path = rtrim($path,"/");
  $datas = _rss_parse($path);
  $rows = array();
  
  foreach ($datas as $data) {
    if (empty($data["title"])) continue;
    $row = array();
	foreach ($fields as $field) {
	  switch ($field) {
	    case "id": $row[$field] = $path."/?".md5($data["link"]); break;
	    case "folder": $row[$field] = $path; break;
		case "created": $row[$field] = 0; break;
		case "lastmodifiedby": $row[$field] = ""; break;
		case "searchcontent": $row[$field] = implode(" ",$data); break;
		default:
		  if (isset($data[$field])) {
		    $row[$field] = trim(strip_tags($data[$field]));
		  } else $row[$field] = "";
		  break;
	  }
	}
	if (sys_get_select_where($row,$where,$vars)) $rows[] = $row;
  }
//  debug_html($rows);
  $rows = sys_get_select($rows,$order,$limit,$fields);
//  debug_html(strptime("%Y-%m-%dT%H:%m:%S+01:00", ""));
  return $rows;
}

?>