<?php
	/**************************************************************************\
	* Simple Groupware 0.241                                                   *
	* http://www.simple-groupware.de                                           *
	* Copyright (C) 2002-2006 by Thomas Bley                                   *
	* ------------------------------------------------------------------------ *
	*  This program is free software; you can redistribute it and/or           *
	*  modify it under the terms of the GNU General Public License Version 2   *
	*  as published by the Free Software Foundation; only version 2            *
	*  of the License, no later version.                                       *
	*                                                                          *
	*  This program is distributed in the hope that it will be useful,         *
	*  but WITHOUT ANY WARRANTY; without even the implied warranty of          *
	*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the            *
	*  GNU General Public License for more details.                            *
	*                                                                          *
	*  You should have received a copy of the GNU General Public License       *
	*  Version 2 along with this program; if not, write to the Free Software   *
	*  Foundation, Inc., 59 Temple Place - Suite 330, Boston,                  *
	*  MA  02111-1307, USA.                                                    *
	\**************************************************************************/

if (!defined("MAIN_SCRIPT")) exit;

include_once("lib/mail/SMTP.php");
include_once("lib/mail/mimePart.php");

function smtp_get_dirs($path, $left, $level, &$tree, $parent, $recursive) {
  $right = $left+1;
  $tree[$left] = array("id"=>$path,"lft"=>$left,"rgt"=>$right,"flevel"=>$level,"ftitle"=>basename($path),"ftype"=>"nosql_".basename($path));
  return $right+1;
}

function smtp_encodeHeaders($input) {
  foreach ($input as $hdr_name => $hdr_value) {
    preg_match_all("/(\w*[\x80-\xFF]+\w*)/", $hdr_value, $matches);
    foreach ($matches[1] as $value) {
      $replacement = preg_replace("/([\x80-\xFF])/e",'"=".strtoupper(dechex(ord("\1")))',$value);
      $hdr_value = str_replace($value,"=?UTF-8?Q?".$replacement."?=",$hdr_value);
    }
    $input[$hdr_name] = $hdr_value;
  }
  return $input;
}

function _smtp_group_lookup($rcpt_arr) {
  $rcpt_to = array();
  foreach ($rcpt_arr as $to) {
    $to = trim($to);
    if ($to=="") continue;
	if ($to[0]=="@") {
	  $members = "";
	  $to = substr($to,1);
	  $row = db_select_first("simple_sys_groups",array("members"),array("groupname=@name@"),"","",array("name"=>$to));
	  if (!empty($row["members"])) {
	    $member_ids = explode("|",trim($row["members"],"|"));
		foreach ($member_ids as $id) {
	      $email = db_select_first("simple_sys_users",array("email"),array("username=@username@","email!=''"),"","",array("username"=>$id));
		  if (isset($email["email"])) $rcpt_to[$email["email"]] = "";
		}
	  } else {
  	    $row = db_select_first("simple_contactgroups",array("members"),array("groupname=@name@"),"","",array("name"=>$to));
	    if (!empty($row["members"])) {
	      $member_ids = explode("|",trim($row["members"],"|"));
		  foreach ($member_ids as $id) {
		    $email = db_select_first("simple_contacts",array("email"),array("contactid=@contactid@","email!=''"),"","",array("contactid"=>$id));
		    if (isset($email["email"])) $rcpt_to[$email["email"]] = "";
		  }
	    }
	  }
	} else {
	  $rcpt_to[$to] = "";
	}
  }
  return array_keys($rcpt_to);
}

function smtp_insert($path,$data,$mfolder,$sendtofrom=true) {
  $cid = "smtp_".$mfolder;
  if (isset($GLOBALS["credentials"][$cid])) {
    $username = $GLOBALS["credentials"][$cid]["username"];
    $password = $GLOBALS["credentials"][$cid]["password"];
	$server = $GLOBALS["credentials"][$cid]["server"];
	$port = $GLOBALS["credentials"][$cid]["port"];
	$from = $GLOBALS["credentials"][$cid]["options"];
	if (!$port) $port = 25;
	$ssl = $GLOBALS["credentials"][$cid]["ssl"];
	if ($ssl and !extension_loaded("openssl")) return sprintf("{t}%s is not compiled / loaded into PHP.{/t}","OpenSSL");
  } else return "{t}Error: no credentials{/t}";

  $email = array();
  if ($data["attachments"]!="") {
	@set_time_limit(120); // 2min
    $email = new Mail_mimePart("This is a multi-part message in MIME format.", array("content_type"=>"multipart/mixed"));
    $email->addSubPart($data["message"], array("content_type"=>"text/plain","charset"=>"UTF-8","encoding"=>"7bit"));
    $attachments = explode("|",$data["attachments"]);
	foreach ($attachments as $attachment) {
	  if (file_exists($attachment) and filesize($attachment)>0) {
	    $mime = "application/octet-stream";
	  	switch (modify_getfileext($attachment)) {
		  case "gif": $mime = "image/gif"; break;
		  case "jpg": $mime = "image/jpeg"; break;
		  case "png": $mime = "image/png"; break;
		  case "txt": $mime = "text/plain"; break;
		  case "html": case "htm": $mime = "text/html"; break;
		}
	    $email->addSubPart(file_get_contents($attachment), array(
		  "content_type"=>$mime."; name=\"".modify_basename($attachment)."\"", "encoding"=>"base64",
		  "disposition"=>"attachment", "dfilename"=>modify_basename($attachment),
	    ));
	  }
	}
	$email = $email->encode();
  }
  
  $smtp = new Net_SMTP($ssl?($ssl."://".$server):$server,$port);
  // $smtp->setDebug(true);
  
  if (PEAR::isError($e = $smtp->connect(10))) {
	return sprintf("{t}Smtp-error %s: %s{/t}","conn",$e->getMessage());
  }
  if ($username!="" and !empty($smtp->_esmtp['AUTH']) and PEAR::isError($e = $smtp->auth($username, $password))) {
	return sprintf("{t}Smtp-error %s: %s{/t}","auth",$e->getMessage());
  }
  
  if ($username!="") {
    if ($from=="") {
      $from = $username;
      if (!strpos($from,"@")) $from .= "@".$server;
	}
  } else if (!empty($data["efrom"])) {
    $from = $data["efrom"];
  } else {
    $email = db_select_first("simple_sys_users",array("email"),array("username=@username@","email!=''"),"","",array("username"=>$_SESSION["username"]));
	if (isset($email["email"])) $from = $email["email"]; else $from = "unknown@invalid.local";
  }
  
  if (PEAR::isError($e = $smtp->mailFrom($from))) {
	return sprintf("{t}Smtp-error %s: %s{/t}","from",$e->getMessage()." [".$from."]");
  }

  $rcpt_str = $data["eto"].",".(isset($data["cc"])?$data["cc"]:"").",".(isset($data["bcc"])?$data["bcc"]:"");
  if ($sendtofrom) $rcpt_str .= ",".$from;

  $rcpt = _smtp_group_lookup(explode(",",$rcpt_str));
  foreach ($rcpt as $to) {
    if (PEAR::isError($e = $smtp->rcptTo($to))) {
	  return sprintf("{t}Smtp-error %s: %s{/t}","to",$e->getMessage()." [".$to."]");
    }
  }

  if (!empty($data["efrom"])) $from = $data["efrom"];
  $headers = array(
  	"Subject: ".$data["subject"], "From: ".$from,
    "To: ".$data["eto"], "Date: ".date("r",$GLOBALS["time"]), 
    "Mime-Version: 1.0", "X-Mailer: Simple Groupware ".CORE_VERSION,
    "Content-Type: ".($data["attachments"]?$email["headers"]["Content-Type"]:"text/plain; charset=UTF-8")
  );
  $headers = smtp_encodeHeaders($headers);

  $data["message"] .= "\n\n---\n".SMTP_FOOTER;

  @set_time_limit(300); // 5min.
  if (PEAR::isError($e = $smtp->data(implode("\r\n",$headers)."\r\n\r\n".($data["attachments"]?$email["body"]:$data["message"])))) {
	return sprintf("{t}Smtp-error %s: %s{/t}","data",$e->getMessage());
  }
  $smtp->disconnect();
  
  if ($sendtofrom and $data["attachments"]!="") {
    $attachments = explode("|",$data["attachments"]);
	foreach ($attachments as $attachment) @unlink($attachment);
  }
  // TODO2 insert mail to database ??
  return "";
}
?>