<?php
	/**************************************************************************\
	* Simple Groupware 0.241                                                   *
	* http://www.simple-groupware.de                                           *
	* Copyright (C) 2002-2006 by Thomas Bley                                   *
	* ------------------------------------------------------------------------ *
	*  This program is free software; you can redistribute it and/or           *
	*  modify it under the terms of the GNU General Public License Version 2   *
	*  as published by the Free Software Foundation; only version 2            *
	*  of the License, no later version.                                       *
	*                                                                          *
	*  This program is distributed in the hope that it will be useful,         *
	*  but WITHOUT ANY WARRANTY; without even the implied warranty of          *
	*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the            *
	*  GNU General Public License for more details.                            *
	*                                                                          *
	*  You should have received a copy of the GNU General Public License       *
	*  Version 2 along with this program; if not, write to the Free Software   *
	*  Foundation, Inc., 59 Temple Place - Suite 330, Boston,                  *
	*  MA  02111-1307, USA.                                                    *
	\**************************************************************************/

die("This feature is disabled by default. Please change 'xmlrpc_server.php' and 'xmlrpc_client.php'.");

$url = "http://localhost/sgs/src/dev/xmlrpc_server.php";
$username = "admin";
$password = "admin";

$sgs_remote = new sgs_remote($url,$username,$password);

$folder = 117301;
$view = "new";
$data = array(
  "username"=>"mynewuser1a",
  "password"=>"newpw",
  "password_confirm"=>"newpw",
  "email"=>"aa@ccc1a.def",
);

$result = $sgs_remote->create($folder,$view,$data);

echo "<pre>";
print_r($result);
echo "</pre>";

$folder = 117301;
$view = "details";

$result = $sgs_remote->getlist($folder,$view);
ksort($result);
$id = array_pop(array_keys($result));

echo "newest id is ".$id."<br>";

echo "updating id $id ...<br>";
$folder = 117301;
$view = "edit";
$data = array(
  "id"=>$id,
  "username"=>"none",
  "password"=>"newpw",
  "password_confirm"=>"newpw",
  "email"=>"aa@ccc1e.def",
  "firstname"=>"my first name",
);

$result = $sgs_remote->edit($folder,$view,$data);

echo "<pre>";
print_r($result);
echo "</pre>";

class sgs_remote {
  var $client = null;
  
  function sgs_remote($server,$username,$password) {
	require_once("lib/xmlrpc/xmlrpc.php");
	$this->client = new xmlrpc_client($server);
	$this->client->setdebug(1);
	$this->client->setCredentials($username,$password);
  }

  function create($folder,$view,$data) {
    $params = array("folder"=>$folder,"view"=>$view,"data"=>$data);
	$r = $this->client->send(new xmlrpcmsg("remote.create",array(php_xmlrpc_encode($params))));
	if (!$r->faultCode()) {
	  return php_xmlrpc_decode($r->value());
	} else {
	  return array($r->faultCode(),$r->faultString());
	}
  }
  
  function edit($folder,$view,$data) {
    $params = array("folder"=>$folder,"view"=>$view,"data"=>$data);
	$r = $this->client->send(new xmlrpcmsg("remote.edit",array(php_xmlrpc_encode($params))));
	if (!$r->faultCode()) {
	  return php_xmlrpc_decode($r->value());
	} else {
	  return array($r->faultCode(),$r->faultString());
	}
  }

  function getlist($folder,$view) {
    $params = array("folder"=>$folder,"view"=>$view);
	$r = $this->client->send(new xmlrpcmsg("remote.getlist",array(php_xmlrpc_encode($params))));
	if (!$r->faultCode()) {
	  return php_xmlrpc_decode($r->value());
	} else {
	  return array($r->faultCode(),$r->faultString());
	}
  }
}

?>
